#include "header.h"

/* to initialize cell_u_average, cell_v_average and cell_w_average */

void INI_AVE(int *avenumber, struct cell_average cell_ave[][ysample_number])
{
    int i,j,k;
    double jet_width = 0.01;   // just used to define the cell_ave.y!!! no other use

    for(j=0; j<=xstep_number/record_xstep; j++)
    {
        avenumber[j]=0;  
        for(i=0; i<ysample_number; i++)
        {

            for(k=0;k<Par_SN; k++)
            {
                cell_ave[j][i].par_ndnumber[k] = 0;
                //  cell_ave[j][i].par_ndfluxnumber[k] = 0;
            }

            cell_ave[j][i].x = (j)*dx_stir*record_xstep;
            cell_ave[j][i].y = (i+0.5-ysample_number/2.0)*(domain_y)/ysample_number;  // the sample domain width is 30D*60D.
            cell_ave[j][i].u = 0.0;
            cell_ave[j][i].v_lateral = 0.0;
            cell_ave[j][i].v_trip = 0.0;
            cell_ave[j][i].v_ave = 0.0;
            cell_ave[j][i].w = 0.0;
            //            cell_ave[j][i].density = 0.0;
            cell_ave[j][i].eddy_density = 0.0;
            cell_ave[j][i].eddy_density_instant = 0.0;
            cell_ave[j][i].particle.par_surface = 0.0;
            cell_ave[j][i].particle.par_volume =0.0;
            cell_ave[j][i].particle.par_size = 0.0;
            cell_ave[j][i].particle.par_d10 = 0.0;
            cell_ave[j][i].particle.par_d32 = 0.0;
            for(k=0; k<Par_SN; k++)
            {
                cell_ave[j][i].particle.par_number[k] = 0.0;
                cell_ave[j][i].particle.par_massflux[k] = 0.0;
                cell_ave[j][i].particle.par_u[k] = 0.0;
                cell_ave[j][i].particle.par_v[k] = 0.0;
                cell_ave[j][i].particle.par_Re[k] = 0.0;
                cell_ave[j][i].particle.par_numberdensity[k] = 0.0;

                cell_ave[j][i].particle.par_nd0th_new[k] = 0.0;
                cell_ave[j][i].particle.par_0thdiffcoe[k] = 0.0;
                cell_ave[j][i].particle.Tem[k] = 0.0;
                cell_ave[j][i].particle.Mass_P[0][k] = 0.0;
                cell_ave[j][i].particle.Mass_P[1][k] = 0.0;
                cell_ave[j][i].particle.Mass_P[2][k] = 0.0;
                cell_ave[j][i].particle.Mass_P[3][k] = 0.0;
                cell_ave[j][i].particle.Mass_P[4][k] = 0.0;
                cell_ave[j][i].particle.density[k] = 0.0;
            }
            cell_ave[j][i].particle.par_nd1st_new = 0.0;                
            cell_ave[j][i].particle.par_1stdiffcoe = 0.0;
            cell_ave[j][i].particle.par_nd2nd_new = 0.0;
            cell_ave[j][i].particle.par_2nddiffcoe = 0.0;
            cell_ave[j][i].particle.par_nd3rd_new = 0.0;
            cell_ave[j][i].particle.par_3rddiffcoe = 0.0;
            
            cell_ave[j][i].uu = 0.0;  //Reynolds stress!
            cell_ave[j][i].deta_u = 0.0;
            cell_ave[j][i].uv = 0.0;
            cell_ave[j][i].vv = 0.0;
            cell_ave[j][i].ww = 0.0;

            // initialize source term
            cell_ave[j][i].source.mass = 0.0;
            cell_ave[j][i].source.mom_u = 0.0;
            cell_ave[j][i].source.mom_v = 0.0;
            cell_ave[j][i].source.mom_w = 0.0;
            for(k=0; k<Species_Number; k++)
                cell_ave[j][i].source.massflux_species[k];

            //to initialize mixture information in the cell
            for(k=0; k<5; k++)
            {
                cell_ave[j][i].mixture.Mixture_Fraction[k] = 0.0;
                cell_ave[j][i].mixture.Mixture_Fraction_Var[k] = 0.0;
                cell_ave[j][i].mixture.MixtureFr_Coal[k] = 0.0;
                cell_ave[j][i].mixture.MixtureFr_Coal_Var[k] = 0.0;
            }
            cell_ave[j][i].mixture.Mass_Flux = 0.0;
            cell_ave[j][i].mixture.Mole_Number_Flux = 0.0;
            cell_ave[j][i].mixture.Tem = 0.0;
            cell_ave[j][i].mixture.Density = 0.0;
            cell_ave[j][i].mixture.Molecular_Weight = 0.0;
            cell_ave[j][i].mixture.Enthalpy = 0.0;
            cell_ave[j][i].mixture.Entropy = 0.0;
            cell_ave[j][i].mixture.Kinetic_Viscosity_Coeff = 0.0;


            cell_ave[j][i].mixture.Conduction_Coeff = 0.0;
            for(k=0; k<Species_Number; k++)
            {
                cell_ave[j][i].mixture.Massfr[k] = 0.0;
                cell_ave[j][i].mixture.Molefr[k] = 0.0;
                cell_ave[j][i].mixture.Spe_Diff_Coeff[k] = 0.0;
                cell_ave[j][i].massfr_rms[k] = 0.0;
            }
        }
    }
}







// to initialize cell information in the centerflow except cell.size, cell.y, cell.u cell.v, cell.w
void INI_CENTERFLOW_CELL(int i, struct cell_information *cell)
{
    int k;
    extern double Oxy_Pry_Total, MFR_Pry_Total;

    cell[i].pressure = Pressure;
    cell[i].mixture.Tem = Tem_OP;  // temperature of the primary oxidizer
    cell[i].Tem_old = cell[i].mixture.Tem;
    for(k=0; k<Species_Number; k++)
        cell[i].mixture.Molefr[k] = Species_Mole_Center[k]/Oxy_Pry_Total;
        //     printf("ini[%d]=%f\n",i,cell[i].mixture.Molefr[Air]);
    for(k=0; k<5; k++)
        cell[i].mixture.MixtureFr_Coal[k] = Mixfr_Center[k]/MFR_Pry_Total;
    cell[i].mixture.Mole_Total = 1.0;
}







// to initialize cell information in the secondary oxidizer region.
void INI_OS_CELL(int i, struct cell_information *cell)
{
    int k;
    extern double Oxy_Sec_Total, MFR_Sec_Total;

    cell[i].pressure = Pressure;
    cell[i].mixture.Tem = Tem_OS;     // temperature of the secondary oxidizer
    cell[i].Tem_old = cell[i].mixture.Tem;
    for(k=0; k<Species_Number; k++)
        cell[i].mixture.Molefr[k] = Species_Mole_Center_1[k]/Oxy_Sec_Total;
        //     printf("ini[%d]=%f\n",i,cell[i].mixture.Molefr[Air]);
    for(k=0; k<5; k++)
        cell[i].mixture.MixtureFr_Coal[k] = Mixfr_Center_1[k]/MFR_Sec_Total;
    cell[i].mixture.Mole_Total = 1.0;
}








// to initialize cell information in the coflow except cell.size, cell.y, cell.v, cell.w
void INI_COFLOW_CELL(int i, double S, double ini_halfjetwidth, struct cell_information *cell)
{
    int k;
    double fabs_y;
    extern double Mix_Coflow_Total, MFR_Coflow_Total;

    fabs_y = cell[i].y<0?-cell[i].y:cell[i].y;
    cell[i].u = S*pow((fabs_y/ini_halfjetwidth),-(1.0/2.0));
    cell[i].u = cell[i].u<covelocity ? covelocity : cell[i].u;
    
    //        printf("cell[i].u=%8.5f,cell[i].y=%8.5f, pow=%8.5f\n",cell[i].u,cell[i].y,pow((fabs_y/ini_halfjetwidth),(-1.0/2.0)));
    cell[i].pressure = Pressure;
    cell[i].mixture.Tem = Tem_Coflow;
    cell[i].Tem_old = cell[i].mixture.Tem;
    for(k=0; k<Species_Number; k++)
        cell[i].mixture.Molefr[k] = Species_Mole_Coflow[k]/Mix_Coflow_Total;
    for(k=0; k<5; k++)
        cell[i].mixture.MixtureFr_Coal[k] = Mixfr_Coflow[k]/MFR_Coflow_Total;
    cell[i].mixture.Mole_Total = 1.0;
        //     printf("ini[%d]=%f\n",i,cell[i].mixture.Molefr[Air]);
}








// to initialize cell information in the coflow except cell.size, cell.y, cell.v, cell.w
void INI_BOUNDARY_CELL(int i, double U, struct cell_information *cell)
{
    int j,k;
    extern double Mix_Coflow_Total, MFR_Coflow_Total;

    cell[i].u = U;
    cell[i].pressure = Pressure;
    cell[i].mixture.Tem = Tem_Coflow;
    cell[i].Tem_old = cell[i].mixture.Tem;
    for(k=0; k<Species_Number; k++)
        cell[i].mixture.Molefr[k] = Species_Mole_Coflow[k]/Mix_Coflow_Total;
        //     printf("ini[%d]=%f\n",i,cell[i].mixture.Molefr[Air]);
    for(k=0; k<5; k++)
        cell[i].mixture.MixtureFr_Coal[k] = Mixfr_Coflow[k]/MFR_Coflow_Total;
    cell[i].mixture.Mole_Total = 1.0;
}







/********************************************************************************
ujet[]: axial velocity profiles in the jet, acquired by FLUENT simulation

********************************************************************************/
void INITIALIZE(int *core_bdcell, double *grid_y, struct cell_information *cell, struct eddy_information *eddy, struct part_infor *par_info_ini, struct part_infor *par_info_new,int *domain_cellnumber, struct back_grid *backgrid_nd)
{
    int i,j,k,startpoint,endpoint,cells,k_spe;
    double S,Ini_JW=(jet_width_OP-incells*dy_cen)/2.0;  // S is a parameter to define the covelocity. v_co = S*(x/x0)^(-1/2), Ini_Jw is the initial half Jet width
    double ranum, mole_total;
    double gridy1[center_inicell+1][2];  //the variable that used to read the y & u information from the data file
    double massflow_Pry, massflow_Sec, massflow_O2;
    double pry_ratio=1.02295, sec_ratio=1.0566;
    //centercell_number is for data files, center_number is for the cell number in the jet
    //    double P_C, P_O; //P_C means how many moles of C atom in this cell, P_C = sum(N_1,j*X[j]), symilarly, P_O=sum(N_3,j*X[j])
    int centercell_number, center_number, center_number_OP;

    FILE *Uprofile;

    center_number = int((jet_width_OS+1e-10)/dy_cen);   //the cell numbers of the jet(including primary jet and secondary jet)
    center_number_OP = int((jet_width_OP+1e-10)/dy_cen);   // the cell number of the primary jet
    centercell_number = center_inicell; 

    //read the velocity profile from the data file acquired by FLUENT simulation
    if((Uprofile = fopen("gasification.dat","r"))==NULL)
    {	printf("cannot open this file.\n");		exit(0);	}
    for(i=0; i<center_inicell+1; i++)
        fscanf(Uprofile, "%lf\t%lf\n", &gridy1[i][0], &gridy1[i][1]);
    fclose(Uprofile);

    //    to change velocity profile
    for(i=0; i<centercell_number+1; i++)
    {
        gridy1[centercell_number-i][0] *= ((jet_width_OP)/1e-2);
       
        gridy1[centercell_number-i][1] *= 1.;
    }
//    printf("gridy1[0][0]=%8.5f, gridy1[%d][0]=%8.5f\n",gridy1[0][0],centercell_number, gridy1[centercell_number][0]);

    // to give the initial grid point position
    for(i=0; i<(cellnumber+1); i++)
    {
        if(i==0)
            grid_y[i] = -domain_y/2;
        else if(i>cellnumber/2-center_number/2 && i<=cellnumber/2+center_number/2)
            {
                grid_y[i] = dy_cen+grid_y[i-1];
            }
        else
            grid_y[i] = dy_co+grid_y[i-1];
    }
//         printf("grid_y[cellnumber]=%f\n",grid_y[cellnumber]);
//         printf("grid_y[center]=%f\n",grid_y[cellnumber/2]);

    for(i=0; i<20;i++)
        ranum=(double)rand()/RAND_MAX;

    for(i=0; i<2; i++)
        domain_cellnumber[i] = cellnumber;

    // to initialize core_bdcell. which is the cells which the boundary of the core region is in 
    core_bdcell[0] = domain_cellnumber[0]/2-center_number/2;
    core_bdcell[1] = domain_cellnumber[0]/2+center_number/2-1;
        
    //    printf("\n$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$BEGIN INITIALIZE!!!!$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$\ncellnumber=%d\t\tconumber=%d\t\tcenternumber=%d\tdy_co=%8.5f\t\tdy_cen=%8.5f\njet_width_OS=%8.5f\tdomain_width=%8.5f\tjet_cellnumber=%d\tco_cellnumber=%d\n",cellnumber,cellnumber-center_number, int((jet_width_OS+1e-10)/dy_cen), dy_co,dy_cen,jet_width_OS,domain_y,(int)((jet_width_OS+1e-10)/dy_cen),(int)((1e-10+domain_y-jet_width_OS)/dy_co));

    //to calculate the center point coordinate for each cell
    for(i=0; i<cellnumber; i++)
        cell[i].y = (grid_y[i]+grid_y[i+1])/2;
 
    //to identify S
//     for(i=0; i<(centercell_number+1); i++)
//     {
//         if(gridy1[i][0]<-Ini_JW && gridy1[i+1][0]>-Ini_JW)
//         {
//             S = (0.1*gridy1[i][1]+0.0*gridy1[i+1][1]);
//             printf("i=%d\tS=%f\tgrid.y=%f\tgrid.u=%f\n", i,S, gridy1[i][0],gridy1[i][1]);
//             i=centercell_number+1;
//         }
//         if(gridy1[i][0] == -Ini_JW)
//         {
//             S = (0.1*gridy1[i][1]+0.0*gridy1[i+1][1]);
//             printf("i=%d\tS=%f\tgrid.y=%f\tgrid.u=%f\n", i,S, gridy1[i][0],gridy1[i][1]);
//             i=centercell_number+1;
//         }
//     }
    S = 5.;  

    k=0;
    //to initialize cell.size(m), u(m/s), v(m/s), w(m/s) and pressure(Pa)
    //to initialze mixture property of: Temperature, Molefraction
    for(i=0; i<cellnumber; i++)
    {
        //to initialize cell size
        if(i>cellnumber/2-center_number/2-1 && i<cellnumber/2+center_number/2)
            cell[i].size = dy_cen;
        else
            cell[i].size = dy_co;

        cell[i].size_old = cell[i].size;
        
        ranum=(double)rand()/RAND_MAX;
        ranum=2*ranum-1;

        //in the jet flow
        if(i>(int)(cellnumber/2-center_number/2-1+incells/2) && i<(int)(cellnumber/2+center_number/2-incells/2))
        {
            // in case that cell[i].size > gridy1.size
            while(cell[i].y>gridy1[k+1][0])
                k++;

            if(cell[i].y>gridy1[k][0] && cell[i].y<gridy1[k+1][0])
            {
                cell[i].u = gridy1[k][1]+(gridy1[k+1][1]-gridy1[k][1])*(cell[i].y-gridy1[k][0])/(gridy1[k+1][0]-gridy1[k][0]);

                if(i>cellnumber/2-center_number_OP/2-1+incells/2 && i<cellnumber/2+center_number_OP/2-incells/2)
                {
                    cell[i].u *=pry_ratio;
                    INI_CENTERFLOW_CELL(i, cell);
                }
                else
                {
                    cell[i].u *= sec_ratio;
                    INI_OS_CELL(i, cell);
                }

                if(k<centercell_number)
                {
                    while(gridy1[k+1][0]<cell[i+1].y)
                        k++;
                }
                //printf("k=%d\n",k);
                //printf("cell[%d].u=%8.5fcell[%d].y=%8.5f\n", i, cell[i].u,i,cell[i].y);
            }
            if(cell[i].y == gridy1[k+1][0])
            {
                cell[i].u = gridy1[k+1][1];
     
                if(i>cellnumber/2-center_number_OP/2-1+incells/2 && i<cellnumber/2+center_number_OP/2-incells/2)
                {
                    cell[i].u *=pry_ratio;
                    INI_CENTERFLOW_CELL(i, cell);
                }
                else
                {
                    cell[i].u *= sec_ratio;
                    INI_OS_CELL(i, cell);
                }
                if(k<centercell_number)
                {
                    while(gridy1[k+1][0]<=cell[i+1].y)
                        k++;
                }
                //printf("k=%d\n",k);
                //printf("cell[%d].u=%8.5fcell[%d].y=%8.5f\n", i, cell[i].u,i,cell[i].y);
            }

        }
        //in the co-flow
    	else
            INI_COFLOW_CELL(i, S, Ini_JW, cell);

        //to initialize v and w.
        ranum=(double) rand()/RAND_MAX;
        ranum=ranum*2-1;
        cell[i].v_lateral = 0.0+ranum*turb_intensity_coflow*covelocity;
        cell[i].v_trip = cell[i].v_lateral;
        ranum=(double) rand()/RAND_MAX;
        ranum=ranum*2-1;
        cell[i].w = 0.0+ranum*turb_intensity_coflow*covelocity;
    }


    // to initialize lembda (which is used in equilibrium algorithm ===element_potential)
    for(i=0; i<domain_cellnumber[1]; i++)
    {
        if(cell[i].mixture.Molefr[CH4]>0.7)
        {
            cell[i].mixture.Lambda[0] = INI_Lambda_Fuerich[0];
            cell[i].mixture.Lambda[1] = INI_Lambda_Fuerich[1];       
            cell[i].mixture.Lambda[2] = INI_Lambda_Fuerich[2];
            cell[i].mixture.Lambda[3] = INI_Lambda_Fuerich[3];
            cell[i].mixture.Lambda[4] = INI_Lambda_Fuerich[4];
        }
        else if(cell[i].mixture.Molefr[CH4]<0.06)
        {
            cell[i].mixture.Lambda[0] = INI_Lambda_Oxrich[0];
            cell[i].mixture.Lambda[1] = INI_Lambda_Oxrich[1];       
            cell[i].mixture.Lambda[2] = INI_Lambda_Oxrich[2];
            cell[i].mixture.Lambda[3] = INI_Lambda_Oxrich[3];
            cell[i].mixture.Lambda[4] = INI_Lambda_Oxrich[4];
        }
        else
        {
            cell[i].mixture.Lambda[0] = INI_Lambda_Other[0];
            cell[i].mixture.Lambda[1] = INI_Lambda_Other[1];       
            cell[i].mixture.Lambda[2] = INI_Lambda_Other[2];
            cell[i].mixture.Lambda[3] = INI_Lambda_Other[3];
            cell[i].mixture.Lambda[4] = INI_Lambda_Other[4];
        }
        cell[i].mixture.EQU_FLAG = 0; //no equilibrium before

    }
    // to calculate species property and to renew the mixture property according to the know T,P and Molefraction of each species in the Mixture
    for(i=0; i<domain_cellnumber[1]; i++)
        RENEW_MIXPRO_MOLEX(i, cell);


//     printf("item\t\tcell_%d\t\tcell_%d\tcell_%d\tcell_%d\tcell_%d\n",1,int(domain_cellnumber[1]/4.0),int(domain_cellnumber[1]/2.0),int(domain_cellnumber[1]*3.0/4.0),domain_cellnumber[1]);
//     printf("density\t\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",cell[0].mixture.Density,cell[int(domain_cellnumber[1]/4.0)].mixture.Density,cell[int(domain_cellnumber[1]/2.0)].mixture.Density,cell[int(domain_cellnumber[1]*3.0/4.0)].mixture.Density,cell[domain_cellnumber[1]-1].mixture.Density);
//     for(i=0; i<Species_Number; i++)
//         printf("%s\t\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",Species_Name[i],cell[0].mixture.Molefr[i],cell[int(domain_cellnumber[1]/4.0)].mixture.Molefr[i],cell[int(domain_cellnumber[1]/2.0)].mixture.Molefr[i],cell[int(domain_cellnumber[1]*3.0/4.0)].mixture.Molefr[i],cell[int(domain_cellnumber[1]-1)].mixture.Molefr[i]);
        
//     printf("S=%f, S1=%f, S2=%f, Y1=%f, Ini_JW=%f\n",S,gridy1[centercell_number-incells/2][1],gridy1[centercell_number-incells/2-1][1],gridy1[centercell_number-incells/2][0],Ini_JW);
//     for(i=0; i<domain_cellnumber[1]; i++)
//     {
//         if(i>domain_cellnumber[1]/2-center_number-20 && i< domain_cellnumber[1]/2+center_number+20)
//         {
//             if(i%1==0)
//                 printf("cell[%d].y=%8.5f,cell[%d].u=%8.5f,cell[%d].size=%8.5f, Tem=%8.5f\n",i,cell[i].y,i,cell[i].u,i,cell[i].size,cell[i].mixture.Tem);
//         }
//         else
//         {
//             if(i%100==0)
//                 printf("cell[%d].y=%8.5f,cell[%d].u=%8.5f,cell[%d].size=%8.5f, Tem=%8.5f\n",i,cell[i].y,i,cell[i].u,i,cell[i].size, cell[i].mixture.Tem);
//         }
//     }

//     for(i=0; i<centercell_number; i++)
//         printf("grid[%d].y=%8.5f,grid[%d].u=%8.5f\n",i,gridy1[i][0],i,(gridy1[i][1]+gridy1[i+1][1])/2.0);

		
    /* to initialize each eddy information */
    for(i=0; i<eddy_number; i++)
    {
        eddy[i].ser_number = 0; 
        eddy[i].xcellstart = 0;
        eddy[i].xcellend = 0;
        eddy[i].ystart = 0;
        eddy[i].yend = 0;
        eddy[i].ycellstart = 0;
        eddy[i].ycellend = 0;
        eddy[i].lifetime = 0.0;
        eddy[i].height = 0.0;
        eddy[i].height_judge = 0.0;
        eddy[i].length = 0.0;
        eddy[i].u = 0.0;
        eddy[i].v = 0.0;
        eddy[i].w = 0.0;
        eddy[i].vlateral =0.0;
    }

    // to initialize particle information for each particle track
    INI_PARTICLE_TRACK(cell, par_info_ini, par_info_new);

    k = 0;
    startpoint = 0;
    for(i=1; i<domain_cellnumber[0]+1; i++)          //backgrid grid is used to calculate v_lateral based on Eular coordinate
    {
        if(grid_y[i]>=(k-int((domain_y+1e-10)/dy_bg/2)+1)*dy_bg-1e-8)
        {
            endpoint = i;
            backgrid_nd[k].y = (k-int((domain_y+1e-10)/dy_bg/2)+1/2)*dy_bg;
            backgrid_nd[k].Flag_eddy = 0;    //the cell was not occupied by an eddy.
            backgrid_nd[k].vgas0 = 0.0;  // to record v velocity(vgas=vdiff) in initial ODT step
            backgrid_nd[k].ugas0 = 0.0;
            backgrid_nd[k].vgas1 = 0.0;
            backgrid_nd[k].mass0 = 0.0;

            if( k == 0 )
            {
                backgrid_nd[k].ugas1 = cell[0].u*cell[0].size*cell[0].mixture.Density;
                backgrid_nd[k].mass1 = cell[0].size*cell[0].mixture.Density;
            }
            else
            {
                backgrid_nd[k].ugas1 = (grid_y[startpoint]-(k-int((domain_y+1e-10)/dy_bg/2))*dy_bg)*cell[startpoint-1].u*cell[startpoint-1].mixture.Density;
                backgrid_nd[k].mass1 = (grid_y[startpoint]-(k-int((domain_y+1e-10)/dy_bg/2))*dy_bg)*cell[startpoint-1].mixture.Density;
            }

            for(j=startpoint+1; j<endpoint; j++)
            {
                backgrid_nd[k].mass1 += cell[j-1].size*cell[j-1].mixture.Density;
                backgrid_nd[k].ugas1 += cell[j-1].u*cell[j-1].size*cell[j-1].mixture.Density;
            }
            backgrid_nd[k].mass1 += ((k+1-int((domain_y+1e-10)/dy_bg/2))*dy_bg-grid_y[endpoint-1])*cell[endpoint-1].mixture.Density;
            backgrid_nd[k].ugas1 += ((k+1-int((domain_y+1e-10)/dy_bg/2))*dy_bg-grid_y[endpoint-1])*cell[endpoint-1].u*cell[endpoint-1].mixture.Density;
            backgrid_nd[k].ugas1 /= backgrid_nd[k].mass1;
            k++;
            //if a cell size is larger than dy
            if(grid_y[endpoint]>=(k+1-int((domain_y+1e-10)/dy_bg/2))*dy_bg-1e-8)
            {
                cells = int((grid_y[endpoint]-(k-int((domain_y+1e-10)/dy_bg/2))*dy_bg)/dy_bg);
                for(j=0; j<cells; j++)
                {
                    backgrid_nd[k].mass1 = cell[endpoint-1].mixture.Density*dy_bg;
                    backgrid_nd[k].ugas1 = cell[endpoint-1].u;
                    k++;
                }
            }
            startpoint = endpoint;
        }
    }

    for(i=0; i<(int)((domain_y+1e-10)/dy_bg); i++)
    {
        for(k=0;k<Par_SN;k++)
        {
            backgrid_nd[i].par_numberdensity[k] = 0.0;
            backgrid_nd[i].par_nd0th_new[k] = 0.0;
        }
        backgrid_nd[i].par_nd1st_new = 0.0;
        backgrid_nd[i].par_nd2nd_new = 0.0;
        backgrid_nd[i].par_nd3rd_new = 0.0;
    }

    // to initialize particle numberdensity and moments flux for each uniform cell
    for(i=0; i<par_tracknumber; i++)
    {
        backgrid_nd[(int)((par_info_new[i].y+domain_y/2)/dy_bg)].par_numberdensity[Par_SN-1] += par_info_new[i].particle_number/par_info_new[i].u/dy_bg;
        backgrid_nd[(int)((par_info_new[i].y+domain_y/2)/dy_bg)].par_nd0th_new[Par_SN-1] += par_info_new[i].particle_number/dy_bg;
        backgrid_nd[(int)((par_info_new[i].y+domain_y/2)/dy_bg)].par_nd1st_new += par_info_new[i].particle_number/dy_bg*par_info_new[i].diameter;
        backgrid_nd[(int)((par_info_new[i].y+domain_y/2)/dy_bg)].par_nd2nd_new += par_info_new[i].particle_number/dy_bg*PI*pow(par_info_new[i].diameter,2);
        backgrid_nd[(int)((par_info_new[i].y+domain_y/2)/dy_bg)].par_nd3rd_new += par_info_new[i].particle_number/dy_bg*PI*pow(par_info_new[i].diameter,3)/6;

        if(par_info_new[i].diameter == 1e-5)
        {
            backgrid_nd[(int)((par_info_new[i].y+domain_y/2)/dy_bg)].par_numberdensity[0] += par_info_new[i].particle_number/par_info_new[i].u/dy_bg;
            backgrid_nd[(int)((par_info_new[i].y+domain_y/2)/dy_bg)].par_nd0th_new[0] += par_info_new[i].particle_number/dy_bg;
        }

        else if(par_info_new[i].diameter == 7e-5)
        {
            backgrid_nd[(int)((par_info_new[i].y+domain_y/2)/dy_bg)].par_numberdensity[1] += par_info_new[i].particle_number/par_info_new[i].u/dy_bg;
            backgrid_nd[(int)((par_info_new[i].y+domain_y/2)/dy_bg)].par_nd0th_new[1] += par_info_new[i].particle_number/dy_bg;
        }

        else
        {
            backgrid_nd[(int)((par_info_new[i].y+domain_y/2)/dy_bg)].par_numberdensity[2] += par_info_new[i].particle_number/par_info_new[i].u/dy_bg;
            backgrid_nd[(int)((par_info_new[i].y+domain_y/2)/dy_bg)].par_nd0th_new[2] += par_info_new[i].particle_number/dy_bg;
        }
    }

    massflow_Pry = 0.0;
    massflow_Sec = 0.0;
    massflow_O2 = 0.0;
    for(i=domain_cellnumber[0]/2-center_number/2; i<domain_cellnumber[0]/2+center_number/2; i++)
    {
        if(i>domain_cellnumber[0]/2-center_number_OP/2-1 && i<domain_cellnumber[0]/2+center_number_OP/2)
        {
            massflow_Pry += cell[i].size*cell[i].mixture.Density*cell[i].u;
            massflow_O2 += cell[i].size*cell[i].mixture.Density*cell[i].u*cell[i].mixture.Massfr[O2];
        }
        else
        {
            massflow_Sec += cell[i].size*cell[i].mixture.Density*cell[i].u;
            massflow_O2 += cell[i].size*cell[i].mixture.Density*cell[i].u*cell[i].mixture.Massfr[O2];
        }
    }


    printf("Pry mfr=%f kg/s, Sec_mfr=%f kg/s, O2_mfr=%f, Coal=%f kg/s", massflow_Pry, massflow_Sec, massflow_O2, par_massflow);
    printf("MO2_pry=%f, MO2_sec=%f\n", cell[domain_cellnumber[0]/2].mixture.Massfr[O2], cell[domain_cellnumber[0]/2+center_number_OP/2+10].mixture.Massfr[O2]);
    printf("bd_left=%f, %f, bd_right=%f, %f\n", cell[domain_cellnumber[0]/2-center_number/2-1].y, cell[domain_cellnumber[0]/2-center_number/2].y, cell[domain_cellnumber[0]/2+center_number/2-1].y,cell[domain_cellnumber[0]/2+center_number/2].y);
    printf("bd_left=%f, %f, bd_right=%f, %f\n", cell[domain_cellnumber[0]/2-center_number_OP/2-1].y, cell[domain_cellnumber[0]/2-center_number_OP/2].y, cell[domain_cellnumber[0]/2+center_number_OP/2-1].y,cell[domain_cellnumber[0]/2+center_number_OP/2].y);


//     printf(" O2_mfr=%f, Coal=%f kg/s, rate=%f", massflow_O2, par_massflow, par_massflow/massflow_O2);

//     printf("bd_left=%f, %f, bd_right=%f, %f\n", cell[domain_cellnumber[0]/2-center_number/2-1].y, cell[domain_cellnumber[0]/2-center_number/2].y, cell[domain_cellnumber[0]/2+center_number/2-1].y,cell[domain_cellnumber[0]/2+center_number/2].y);
//     //    printf("bd_left=%f, %f, bd_right=%f, %f\n", cell[domain_cellnumber[0]/2-center_number_OP/2-1].y, cell[domain_cellnumber[0]/2-center_number_OP/2].y, cell[domain_cellnumber[0]/2+center_number_OP/2-1].y,cell[domain_cellnumber[0]/2+center_number_OP/2].y);

}







// this function is used to initialize the particle information for each particle track
void INI_PARTICLE_TRACK(struct cell_information *cell, struct part_infor *par_info_ini, struct part_infor *par_info_new)
{
    int i,j;
    struct coal_information coal_particle[Par_SN-1];  //small, medium and large

    for(j=0; j<Par_SN-1; j++)
    {
        coal_particle[j].Tem = par_Tem_dist[j];
        /// to initialize coal particles according its temperature!
        INIT_COAL_PARTICLE(&(coal_particle[j]));
    }

    /* to initialize each particle information */
    for(i=0;i<par_tracknumber;i++)
    {
        par_info_ini[i].cellin = cellnumber/2-(int)((jet_width_OP+1e-10)/dy_cen/2)+i/(par_tracknumber/((int)((jet_width_OP+1e-10)/dy_cen)));
        par_info_ini[i].eddy_on = eddy_number;
        par_info_ini[i].eddy_trip = 0;        // the particle is not tripletted by any eddy
        par_info_ini[i].eddy_trip_former = 0; // the particle is not tripletted by any eddy before the latest triplet map
        par_info_ini[i].boundary_type = 0;		//means particle was in this domain
        par_info_ini[i].x = 0.0;
        par_info_ini[i].y = -jet_width_OP/2+(i+0.5)*jet_width_OP/par_tracknumber;  //particles distributed at the jet outlet uniformly
        par_info_ini[i].z = 0.0;
        par_info_ini[i].u = cell[par_info_ini[i].cellin].u*0.8;
        par_info_ini[i].v = 0.0; /*(i/(par_tracknumber/30)-15.0)/15.0*2.0;*/
        par_info_ini[i].w = 0.0;
        par_info_ini[i].vm = sqrt(pow(par_info_ini[i].u,2)+pow(par_info_ini[i].v,2)+pow(par_info_ini[i].w,2));
        if(i%18==0)
        {
            for(j=0;j<18;j++)
            {
                par_info_ini[i+j].diameter = par_size[j];
                if(par_info_ini[i+j].diameter == par_size_dist[0])
                {
                    par_info_ini[i+j].temperature = par_Tem_dist[0];
                    par_info_ini[i+j].coal = coal_particle[0];
                }
                else if(par_info_ini[i+j].diameter == par_size_dist[1])
                {
                    par_info_ini[i+j].temperature = par_Tem_dist[1];
                    par_info_ini[i+j].coal = coal_particle[1];
                }
                else
                {
                    par_info_ini[i+j].temperature = par_Tem_dist[2];
                    par_info_ini[i+j].coal = coal_particle[2];
                }
            }
        }
        //par_info_ini[i].diameter = 60e-6;
        par_info_ini[i].surface = PI*par_info_ini[i].diameter*par_info_ini[i].diameter;  //particle surface
        par_info_ini[i].volume = PI*pow(par_info_ini[i].diameter,3);

        par_info_ini[i].coal.diameter = par_info_ini[i].diameter;
        par_info_ini[i].density = par_info_ini[i].coal.density[4];
        par_info_ini[i].mass = PI/6*pow(par_info_ini[i].diameter,3)*par_info_ini[i].density;
        par_info_ini[i].coal.Mass[0] = par_info_ini[i].mass;
        par_info_ini[i].coal.Mass[1] = par_info_ini[i].mass;
        // to calculate the mass of each primary mass in a coal particle  kg/#
        for(j=0; j<4; j++)
        {
            par_info_ini[i].coal.Mass_P[j] = par_info_ini[i].coal.mfr_primary[j]*par_info_ini[i].coal.Mass[0];
            par_info_ini[i].coal.Mass_P[j] /= (par_info_ini[i].coal.mfr_primary[0]==0?1-coal_primary_mfr[0]:1);
        }


        par_info_ini[i].massflowrate = par_massflow/par_tracknumber;
        par_info_ini[i].massflowrate *= (par_info_ini[i].coal.mfr_primary[0]==0?1-coal_primary_mfr[0]:1.);
        par_info_ini[i].particle_number = par_info_ini[i].massflowrate/par_info_ini[i].mass;

        par_info_ini[i].Re_p = par_info_ini[i].diameter*fabs(par_info_ini[i].vm-sqrt(pow(cell[par_info_ini[i].cellin].u,2)+pow(cell[par_info_ini[i].cellin].v_trip,2)+pow(cell[par_info_ini[i].cellin].w,2)))/(cell[par_info_ini[i].cellin].mixture.Kinetic_Viscosity_Coeff/cell[par_info_ini[i].cellin].mixture.Density);
        par_info_ini[i].tao = par_info_ini[i].density*pow(par_info_ini[i].diameter,2)/(18*cell[par_info_ini[i].cellin].mixture.Kinetic_Viscosity_Coeff);

        // to backup the initial information for each particle
        par_info_new[i] = par_info_ini[i];
    }

    printf("par[%d].cellin=%d, .y=%f, .Tem=%f\n", 0, par_info_new[0].cellin, par_info_new[0].y, par_info_new[0].coal.Tem);
    printf("par[%d].cellin=%d, .y=%f, .Tem=%f\n", 900, par_info_new[900].cellin, par_info_new[900].y, par_info_new[900].coal.Tem);
    printf("par[%d].cellin=%d, .y=%f, .Tem=%f\n", 1799, par_info_new[1799].cellin, par_info_new[1799].y, par_info_new[1799].coal.Tem);
}









// to preprocess the coal properties according to the primary analysis and the ultimate analysis
void INIT_COAL_PARTICLE(struct coal_information *coal)
{
    int i,j;
    double Ratio_DAF_AS;
    double ultimate_total=0.0;
    double total1=0.0,total2=0.0;
    extern double Molecular_Weight[Species_Number+2];

    //  printf("Ratio=%f\n",Ratio_DAF_AS);

    // to acquire primary analysis data
    for(j=0; j<4; j++)
        coal->mfr_primary[j] = coal_primary_mfr[j];
    // to acquire ultimate analysis data (dry basis)
    for(j=0; j<5; j++)
    {
        coal->mfr_ultimate[j] = coal_ultimate_mfr[j];
        ultimate_total += coal_ultimate_mfr[j];
    }
    // to set mfr_N2 = mfr_N2+mfr_S, and to set mfr_S=0.0
    coal->mfr_ultimate[3] += coal->mfr_ultimate[4];
    coal->mfr_ultimate[4] = 0;

    Ratio_DAF_AS = coal->mfr_primary[Pry_C]+coal->mfr_primary[Pry_V];

    // to convert ultimate analysi data from other basis to DAF(dry_ash_free) basis
    for(j=0; j<5; j++)
        coal->mfr_ultimate[j] /= ultimate_total;

    // to calculate the coefficient of coeff_ultimate based on AS basis
    for(j=0; j<4; j++)
        coal->coeff_ultimate[j] = coal->mfr_ultimate[j]*1000/MW_Element[j]*Ratio_DAF_AS;
    coal->coeff_ultimate[4] = 0.0;

    // to initialize the composition of the volatile of the coal
    COAL_INI_COMPOSITION(coal);
    // to calculate initial coal density
    CAL_COAL_DENSITY(coal);
    // to calculate coal HHV and LHV
    CAL_COAL_THERMAL(coal);

    if((coal->Tem) >Tem_boiling)  
    {
        coal->density[4] *= (1-coal_primary_mfr[0]);  // the density without water
        coal->mfr_primary[0] = 0.0;
    }

    for(i=0; i<Species_Number+2; i++)
    {
        total1 += coal->mfr_species[i];
        total2 += coal->mfr_species[i]*1000/Molecular_Weight[i];
    }

//     printf("\n\n///////////////////the coal /////////////////////////\n");
//     printf("the coal property is as follows:\n");
//     printf("the primary analysis(As Received): M=%f, V=%f, C(s)=%f, A=%f\n", coal->mfr_primary[Pry_M]*100, coal->mfr_primary[Pry_V]*100, coal->mfr_primary[Pry_C]*100, coal->mfr_primary[Pry_A]*100);
//     printf("the ultimate analysis(Dry Ash Free): C=%f, H=%f, O=%f, N=%f, S=%f\n", coal->mfr_ultimate[Ult_C]*100,coal->mfr_ultimate[Ult_H]*100, coal->mfr_ultimate[Ult_O]*100,coal->mfr_ultimate[Ult_N]*100, coal->mfr_ultimate[Ult_S]*100); 
//     printf("coal density:\t%f  kg/m3\n", coal->density[4]);
//     printf("coal Molecular pression(MW=1000):\t%c(%6.4f)%c(%6.4f)%c(%6.4f)%c(%6.4f)\n",CoalElement_Name[0],coal->coeff_ultimate[0],CoalElement_Name[1],coal->coeff_ultimate[1],CoalElement_Name[2],coal->coeff_ultimate[2],CoalElement_Name[3],coal->coeff_ultimate[3]);
//     printf("the composition of volatile is as follows(As_Received):\n");
//     printf("Material\tMass_fraction\tMoles\n");

//     for(i=0; i<Species_Number+2; i++)
//         printf("%s\t\t%8.5f\t%8.5f\n",Species_Name[i],coal->mfr_species[i],coal->mfr_species[i]*1000/Molecular_Weight[i]);
//     printf("total:\t\t%8.5f\t%8.5f\n",total1, total2);

//     printf("Cp:\tM:%f, V:%f, C:%f, A:%f, coal:%f J/(kg.K)\n",coal->heat_capacity[Pry_M], coal->heat_capacity[Pry_V],coal->heat_capacity[Pry_C],coal->heat_capacity[Pry_A],coal->heat_capacity[4]);
//     printf("HHV:\t%fJ/kg\n",coal->heat_value_estimate[0]);
//     printf("LHV:\t%fJ/kg\n",coal->heat_value_estimate[1]);
//     printf("HHV_measurement\t%fJ/kg\n",coal->heat_value);
//     printf("error=%%%f\n",(coal->heat_value_estimate[0]-coal->heat_value)/coal->heat_value*100);
//     printf("hfg_latent:\t%f J/kg\n", coal->heat_release[0]);
//     printf("hfg_devola:\t%f J/kg\n", coal->heat_release[1]);
//     printf("heat_carbon_oxygen:\t%f J/kg\n", coal->heat_release[2]);
//     printf("heat_carbon_CO2:\t%f J/kg\n", coal->heat_release[3]);
//     printf("heat_carbon_steam:\t%f J/kg\n", coal->heat_release[4]);
//     printf("heat_carbon_H2:\t%f J/kg\n", coal->heat_release[5]);

//     printf("////////////////////end of the coal////////////////////////\n\n");    

}












//to identify the initial composition of the volatile of the coal (As Received basis)
void COAL_INI_COMPOSITION(struct coal_information *coal) 
{
    int i,j;
    double ratio_DAF_AS;   // ratio from DAF/AS
    double vol_mass=0.0;   // total volatile mass for 100g coal particle 
    double total = 0;
    // Ratio_CO: mole fraction of Oxygen that are converted to CO
    // Ratio_CO2: mole fraction of Oxygen that are converted to CO2
    // Ratio_C2H2_CH4: 
    double Ratio_CO=0.5, Ratio_CO2=0.5,  Ratio_C2H2_CH4=0.5;
    extern double Molecular_Weight[Species_Number+2];

    ratio_DAF_AS = coal->mfr_primary[Pry_C]+coal->mfr_primary[Pry_V];

    for(i=0; i<Species_Number+2; i++)
        coal->mfr_species[i] = 0.0;

    coal->mfr_species[N2] = coal->mfr_ultimate[Ult_N];  //all nitrogen will be convert to N2
    coal->mfr_species[CO] = coal->mfr_ultimate[Ult_O]*Ratio_CO*Molecular_Weight[CO]/MW_Element[Ele_O];   //all oxygen*Ratio_CO will be convert to CO

    coal->mfr_species[CO2] = coal->mfr_ultimate[Ult_O]*(Ratio_CO2)*Molecular_Weight[CO2]/(2.0*MW_Element[Ele_O]); // the oxygen*Ratio_CO2 is converted to CO2

    coal->mfr_species[H2O] = coal->mfr_ultimate[Ult_O]*(1-Ratio_CO-Ratio_CO2)*Molecular_Weight[H2O]/MW_Element[Ele_O]; // the rest O2 is converted to H2O

    coal->mfr_species[C2H2] = (coal->mfr_ultimate[Ult_C]-coal->mfr_primary[Pry_C]/(1-coal->mfr_primary[Pry_M]-coal->mfr_primary[Pry_A])-coal->mfr_species[CO]*MW_Element[Ele_C]/Molecular_Weight[CO]-coal->mfr_species[CO2]*MW_Element[Ele_C]/Molecular_Weight[CO2])*Ratio_C2H2_CH4*Molecular_Weight[C2H2]/(2*MW_Element[Ele_C]);  // for rest carbon, Ratio_C2H2_CH4 is conberted to C2H2

    coal->mfr_species[CH4] = (coal->mfr_ultimate[Ult_C]-coal->mfr_primary[Pry_C]/(1-coal->mfr_primary[Pry_M]-coal->mfr_primary[Pry_A])-coal->mfr_species[CO]*MW_Element[Ele_C]/Molecular_Weight[CO]-coal->mfr_species[CO2]*MW_Element[Ele_C]/Molecular_Weight[CO2]-coal->mfr_species[C2H2]*2*MW_Element[Ele_C]/Molecular_Weight[C2H2])*Molecular_Weight[CH4]/MW_Element[Ele_C];  //the rest carbon is converted to CH4

    coal->mfr_species[H2] = (coal->mfr_ultimate[Ult_H]-coal->mfr_species[CH4]*4.0*MW_Element[Ele_H]/Molecular_Weight[CH4]-coal->mfr_species[C2H2]*2.0*MW_Element[Ele_H]/Molecular_Weight[C2H2]-coal->mfr_species[H2O_L]*2.0*MW_Element[Ele_H]/Molecular_Weight[H2O_L]);  // the rest Hydrogen is converted to H2




  //   coal->mfr_species[N2] = coal->mfr_ultimate[Ult_N];  //all nitrogen will be convert to N2
//     coal->mfr_species[CO] = (coal->mfr_ultimate[Ult_C]-coal->mfr_primary[Pry_C]/ratio_DAF_AS)*Molecular_Weight[CO]/MW_Element[Ele_C];            // all carbon is converted to CO
//     coal->mfr_species[H2O] = (coal->mfr_ultimate[Ult_O]-coal->mfr_species[CO]*MW_Element[Ele_O]/Molecular_Weight[CO])*Molecular_Weight[H2O]/MW_Element[Ele_O];
//     coal->mfr_species[H2] = coal->mfr_ultimate[Ult_H]-coal->mfr_species[H2O]*2*MW_Element[Ele_H]/Molecular_Weight[H2O];
    //to convert mass fraction based on DAF to the one based on AR
    total = 0.0;
    for(i=0; i<Species_Number+2; i++)
    {
        coal->mfr_species[i] *= ratio_DAF_AS;
        total += coal->mfr_species[i];
    }
    //    printf("total=%f\n",total);

    coal->mfr_species[H2O_L] += coal->mfr_primary[Pry_M];
    coal->mfr_species[C_S] = coal->mfr_primary[Pry_C];

    total += (coal->mfr_primary[Pry_M]+coal->mfr_species[C_S]);
    vol_mass = coal->mfr_species[N2]+coal->mfr_species[CO]+coal->mfr_species[C2H2]+coal->mfr_species[CH4]+coal->mfr_species[H2]+coal->mfr_species[CO2]+coal->mfr_species[H2O_L]-coal->mfr_primary[Pry_M];

    printf("vol_mass=%f, total=%f\n", vol_mass, total);
}







// to set source term and particle information in each cell to 0
//to set initial particle source term to 0
//to set initial particle information in each uniform cell to 0
void INI_SOU_PARCELL(int domain_cellnumber, struct source_information *source, struct back_grid *backgrid_nd)
{
    int i,k;
    for(i=0; i<domain_cellnumber; i++)
    {
        source[i].mom_u = 0.0;
        source[i].mom_v = 0.0;
        source[i].mom_w = 0.0;
        source[i].mass = 0.0;
        source[i].enthalpy = 0.0;
        source[i].Enth_h = 0.0;
        for(k=0; k<Species_Number; k++)
            source[i].massflux_species[k] = 0.0;
        for(k=0; k<3; k++)
            source[i].mixture_fr[k] = 0.0;
    }
}
