#include "header.h"
using namespace std;


// to set global variable: Molecular_Weight and Density_Standard
// These two variable are only caluclated in main(), but will be used in other files and functions
double Molecular_Weight[Species_Number+2];
double Density_Standard[Species_Number+2];
double Oxy_Pry_Ele[Element_Number];  //C/H/O/N/Ar  mole number per mole in primary oxidize flow
double Oxy_Sec_Ele[Element_Number];  // C/H/O/N/Ar  mole number per mole in secondary oxidize flow
double Fuel_C_Ele[Element_Number]; //C/H/O/N/Ar  mole number per mole in carbon flow
double Fuel_Vol_Ele[Element_Number]; //C/H/O/N/Ar  mole number per mole in volatile flow
double Oxy_Pry_EleY[Element_Number];  //C/H/O/N/Ar  mass fraction per mole in primary oxidize flow
double Oxy_Sec_EleY[Element_Number];  // C/H/O/N/Ar  mass fraction per mole in secondary oxidize flow
double Fuel_C_EleY[Element_Number]; //C/H/O/N/Ar  mass fraction per mole in carbon flow
double Fuel_Vol_EleY[Element_Number]; //C/H/O/N/Ar  mass fraction per mole in volatile flow
double Oxy_Pry_Total;  // total mole fraction of Species_Mole_Center;
double Oxy_Sec_Total;  // total mole fraction of Species_Mole_Center_1;
double Mix_Coflow_Total; // total mole fraction of species_Mole_Coflow
double MFR_Pry_Total;   // total mixture summation of Center
double MFR_Sec_Total;    // total mixture summation of Secondary flow
double MFR_Coflow_Total; // total mixture summation of coflow

//struct coal_information coal_particle;     // the information of the raw coal particles
/*********************************************************************************
This function is used to simulate a planar jet/plumes/plane flame jets with
ODT model. 
The sub-models of molecular viscous diffusion process is also included in this file.In an ODT simulation work, the split methodology was impleded. for eg. to simulate
a plumes, the turbulent flow of the plume was splited into 4 steps
1. the viscous diffusion process, where boundary equation controls the boundary flow
2. The triplet map process. a series of eddies was judged to occure in this step,
The triplet map in these eddies was adopted to represent turbulent mixing process
in the turbulent plumes.
3. The species diffusion process. This process is used to simulate the mass transfer
process in the flow. A set of species equations was solved in this process.
4. The reactions. In this section, several reaction models are planed to be used. But
equilibrium model based on the principle of minimum Gibbs Energy was adopted at first.
The detailed reaction mechanism models, for eg. GRI Mech. 3.0, will be used finnaly.

Besides these steps, particle dispersion process was also simulated in the model.
the lagrangian particle tracking method is used to track the particle motion and to
capture the particle reactions, for eg. particle combustion and gasification process.
A set of uniform background meshes was used to capture the particle informations in
Euler frames.

A 2-way/4-way particle interaction model can be introduced to consider the detailes of
particle-gas phased interactions.
*********************************************************************************/	

int main(int argc, char *argv[])
{
    // to add parallel programming at first!
    int rank=0, size=1;  //rank: which processor. size: how many processors
    int root=0;  //root: the main processor
	
    int i,j,k,k1,E_S_number, E_S_old, diff_number;  // i:domain cell number, j:diffusion step, k&k1:species number, E_S_number:eddy sample step number. odt_x=E_S_number*dx_stir~~j*dx
    int diff_steps,sub_step;   //to see how many diffusion steps happend in this simulation
    int domain_cellnumber[3];		//cell number before each diffusion step
    int Visc_Flag, SpeDiff_Flag, MFRDiff_Flag, Tem_Flag,  Trip_Flag, Regrid_Flag;  // variables are used to monitor if error occurs during diffusion process ,viscous process or triplet map process.  

    int eddy_occur, eddy_totalnumber=0, eddy_numbers, realization;  //realization means realization numbers
    int avenumber[(int)(xstep_number/record_xstep+1)];   // this variable is set to account for adding times for each average velocity line
    int avenumber1[(int)(xstep_number/record_xstep+1)];   // this variable is set for parallel calculation
    int eddies_x;  //to calculate how many eddies occur during the jth step.this variable is used to calculate the Reuv stress

    int core_bdcell[2];      // cells that the boundary core region is in. Where core region is defined as the region where each eddy shoul past

    int deta_number,E_S_renew;        //deta_number=(diffusion_height-E_S_old*dx_stir)/dx_stir, deta_number <= (E_S_number-E_S_old)/dx_stir

    double odt_x, deta_x,deta_x1,  diffdx_max;  /// odt_x:the height of the odt line on the donwstream wise of the jet flow. deta_x:the diffusion step. deta_x1:the backup diffusion step, diffdx_max: the max step that diffusion step should be considered
    
    double grid_y[gridnumber];
    //eddy_lp[0]=eddy_length, eddy_lp[1]=accepted eddy's pdf value, eddy_lp[2]=eddy selection process number, eddy_lp[3]=candidate eddy's pdf value
    double eddy_lp[4],eddy_lpp[4];  // average eddy length/pdf in one realization and average eddy length/pdf through simulation
    double ranum;
    double Fuel_Vol_mass, Fuel_C_mass, Oxy_Pry_mass, Oxy_Sec_mass;
    double T_momflux, T_massflux, Ave_u;  // total mass flux and momentum flux of the ODT line, and the average u velocity
    //    double kinetic_energy[xstep_number][9];  // this array is used to record the flux and kinetic energy change

    //initial and final value of momentum flux, mass flux and energy flux, used to check the conservation of massflux, momentum flux and energy flux
    //    double mom_ini=0.0, mom_fin=0.0, mass_ini=0.0, mass_fin=0.0, ene_ini=0.0, ene_fin=0.0;
    char Step[6];
    char alex_rank_indep[25], alex_rank_dep[25];
    char *Alexindep = "_Alex_indep.txt";
    char *Alexdep = "_Alex_dep.txt";

    struct cell_information cell_info[totalnumber],  cell_backup[totalnumber];
    struct cell_average cell_ave[(int)(xstep_number/record_xstep+1)][ysample_number];
    // cellave_final is for parallel calculation
    struct cell_average cellave_final[(int)(xstep_number/record_xstep+1)][ysample_number];
    struct eddy_information eddy_info[eddy_number];
    struct part_infor par_info_ini[par_tracknumber], par_info[par_tracknumber];  //par_info_ini is used to record the initial value of each particle streams
    struct back_grid backgrid_nd[(int) ((domain_y+1e-10)/dy_bg)];  //backgrid_nd is used to calculate the particle information based on uniform grid
    struct source_information source[totalnumber];       //structure that records the soure information of the particle phase

		
    // Parameter_table: to record all parameters for the model
    //Velocity_gas and Velocity_particle records the information of gas and particles in one realization
    //Alex files was used to record the information about particle diffusions
    //Eddies was used to record the eddy information during one realization
    FILE *Parameter_table,*Velocity_gas, *Velocity_particle;
    FILE *ALEX_DEP, *ALEX_INDEP;
    FILE *Eddies;
    FILE *Particle_tracking;

    //    printf("begin calculation!\n");


    /////////////////////////////////////////////////////////////////////////
       MPI_Init(&argc, &argv);  //initialt parallel work
       //printf("aft init\n");
       MPI_Comm_rank(MPI_COMM_WORLD,&rank);  // acquire which processor
       //printf("aft rank\n");
       MPI_Comm_size(MPI_COMM_WORLD,&size);  // acquire how many processors
       //       printf("aft size\n");
    /////////////////////////////////////////////////////////////////////////

       my_itoa(rank,alex_rank_indep);
       my_itoa(rank, alex_rank_dep);
       strcat(alex_rank_indep, Alexindep);
       strcat(alex_rank_dep, Alexdep);

    //to calculate molecular weight and standard density for each species at first
    // since these two variables( MW and density) are used in different places in the program 
    // they are calculated at first in order to avoid non-necessary calculation
    //density = pre*MW/1000/R/T
    for(k=0; k<Species_Number+2; k++)
    {
        Molecular_Weight[k] = 0.0;
        for(j=0; j<Element_Number; j++)
            Molecular_Weight[k] += MW_Element[j]*N_IJ[k][j];
    }
    for(k=0; k<Species_Number; k++)
        Density_Standard[k] = Pressure*Molecular_Weight[k]/R/Tem_Standard/1000;
    Density_Standard[C_S] = 1300;
    Density_Standard[H2O_L] = 998.0;


    // to calculate Moles of each element and Mass fraction of each element in the fuel/oxidizor stream
    for(i=0; i<Element_Number; i++)
    {
        Oxy_Pry_Ele[i] = 0.0;
        Oxy_Sec_Ele[i] = 0.0;
        Fuel_Vol_Ele[i] = 0.0;
        Fuel_C_Ele[i] = 0.0;
        Oxy_Pry_EleY[i] = 0.0;
        Oxy_Sec_EleY[i] = 0.0;
        Fuel_Vol_EleY[i] = 0.0;
        Fuel_C_EleY[i] = 0.0;
    }
    Fuel_Vol_mass = 0.0;
    Fuel_C_mass = 0.0;
    Oxy_Pry_mass = 0.0;
    Oxy_Sec_mass = 0.0;
    for(k=0; k<Species_Number; k++)
    {
        for(i=0; i<Element_Number; i++)
        {
            Oxy_Pry_Ele[i] += Species_Mole_Center[k]*N_IJ[k][i];
            Oxy_Sec_Ele[i] += Species_Mole_Center_1[k]*N_IJ[k][i];
            // Fuel_Ele[i] += Species_Mole_Center[k]*N_IJ[k][i];
        }
        Oxy_Pry_mass += Species_Mole_Center[k]*Molecular_Weight[k];
        Oxy_Sec_mass += Species_Mole_Center_1[k]*Molecular_Weight[k];
    }
    Fuel_C_mass = (Oxy_Pry_Ele[0]+ Oxy_Pry_Ele[1]+Oxy_Pry_Ele[2]+Oxy_Pry_Ele[3]);
    Fuel_Vol_mass = (Oxy_Sec_Ele[0]+ Oxy_Sec_Ele[1]+Oxy_Sec_Ele[2]+Oxy_Sec_Ele[3]);
    for(i=0; i<Element_Number; i++)
    {
        Oxy_Pry_EleY[i] = Oxy_Pry_Ele[i]*MW_Element[i]/Oxy_Pry_mass;
        Oxy_Sec_EleY[i] = Oxy_Sec_Ele[i]*MW_Element[i]/Oxy_Sec_mass;
        Oxy_Pry_Ele[i] /= Fuel_C_mass ;
        Oxy_Sec_Ele[i] /= Fuel_Vol_mass;
    }

    /// to set C/H/O/N/Ar mass fraction for char particle
    Fuel_C_EleY[Ele_C] = 1.0;
    Fuel_C_EleY[Ele_H] = 0.0;
    Fuel_C_EleY[Ele_O] = 0.0;
    Fuel_C_EleY[Ele_N] = 0.0;
    Fuel_C_EleY[Ele_Ar] = 0.0;
    /// to uniform ultimate mass fraction, transfer any basis to DAF(dry ash free) basis
    Fuel_Vol_mass = coal_ultimate_mfr[0]+coal_ultimate_mfr[1]+coal_ultimate_mfr[2]+coal_ultimate_mfr[3]+coal_ultimate_mfr[4];
//    printf("Vol: %f\n", Fuel_Vol_mass);
    for(i=0; i<4; i++)
        Fuel_Vol_EleY[i] = coal_ultimate_mfr[i]/Fuel_Vol_mass;
    Fuel_Vol_EleY[3] += coal_ultimate_mfr[4]/Fuel_Vol_mass;  /// up to this step, Fuel_Vol_EleY is the C/H/O/N/Ar element mass fraction for the coal(dry ash free, merge S to N), but not for the volatile
//    printf("F_V: %f, %f, %f, %f\n", Fuel_Vol_EleY[0],Fuel_Vol_EleY[1],Fuel_Vol_EleY[2],Fuel_Vol_EleY[3]);
    Fuel_Vol_EleY[Ele_C] -= coal_primary_mfr[Pry_C]/(coal_primary_mfr[Pry_C]+coal_primary_mfr[Pry_V]); ///to reduce the carbon fraction of the char(dry ash free base)
    /// to uniform ultimate mass fraction and get the final C/H/O/N/Ar element mass fraction for volatile
    Fuel_Vol_mass = Fuel_Vol_EleY[0]+Fuel_Vol_EleY[1]+Fuel_Vol_EleY[2]+Fuel_Vol_EleY[3];
    for(i=0; i<4; i++)
        Fuel_Vol_EleY[i] /= Fuel_Vol_mass;

    // to calculate the total moles for initial condition, in order to uniform
    Oxy_Pry_Total = 0.0;
    Oxy_Sec_Total = 0.0;
    Mix_Coflow_Total = 0.0;
    for(i=0; i<Species_Number; i++)
    {
        Oxy_Pry_Total += Species_Mole_Center[i];
        Oxy_Sec_Total += Species_Mole_Center_1[i];
        Mix_Coflow_Total += Species_Mole_Coflow[i];
    }

    // to calculate the summation of the mixture fraction for initial condition
    MFR_Pry_Total = 0.0;
    MFR_Sec_Total = 0.0;
    MFR_Coflow_Total = 0.0;
    for(i=0; i<5; i++)
    {
        MFR_Pry_Total += Mixfr_Center[i];
        MFR_Sec_Total += Mixfr_Center_1[i];
        MFR_Coflow_Total += Mixfr_Coflow[i];
    }


//     printf("Oxy_Pry_MW=%f,  Oxy_Sec_MW=%f\n", Oxy_Pry_mass, Oxy_Sec_mass);
//     printf("Oxy_Pry_Ele[C]=%f, [H]=%f,  [O]=%f, [N]=%f\n",Oxy_Pry_Ele[0],Oxy_Pry_Ele[1],Oxy_Pry_Ele[2],Oxy_Pry_Ele[3]);
//     printf("Oxy_Sec_Ele[C]=%f, [H]=%f,  [O]=%f, [N]=%f\n",Oxy_Sec_Ele[0],Oxy_Sec_Ele[1],Oxy_Sec_Ele[2],Oxy_Sec_Ele[3]);
//     printf("Oxy_Pry_EleY[C]=%f, [H]=%f,  [O]=%f, [N]=%f\n",Oxy_Pry_EleY[0],Oxy_Pry_EleY[1],Oxy_Pry_EleY[2],Oxy_Pry_EleY[3]);
//     printf("Oxy_Sec_EleY[C]=%f, [H]=%f,  [O]=%f, [N]=%f\n",Oxy_Sec_EleY[0],Oxy_Sec_EleY[1],Oxy_Sec_EleY[2],Oxy_Sec_EleY[3]);
//     printf("Fuel_C_EleY[C]=%f, [H]=%f, [O]=%f, [N]=%f\n", Fuel_C_EleY[0], Fuel_C_EleY[1], Fuel_C_EleY[2], Fuel_C_EleY[3]);
//     printf("Fuel_Vol_EleY[C]=%f, [H]=%f, [O]=%f, [N]=%f\n", Fuel_Vol_EleY[0], Fuel_Vol_EleY[1], Fuel_Vol_EleY[2], Fuel_Vol_EleY[3]);

    
    //Initialize the average array 
    INI_AVE(avenumber, cell_ave);

    eddy_numbers=0;
    for(i=0;i<4;i++)
        eddy_lpp[i]=0.0;  /*to initialize the average eddy length,pdf and number */

    printf("\nin this case, the paramenter is:::::::::::\nalfa=%f, C_odt=%f, Z_small=%f, Z_large=%f,  Reali=%d\n", alfa, C_odt, Z_small,Z_large,  REALI);


    if(rank<10)
    {
        if((ALEX_INDEP=fopen(alex_rank_indep,"a"))==NULL)
        {	printf("cannot open this file.\n");	exit(0);  }
        
        if((ALEX_DEP=fopen(alex_rank_dep,"a"))==NULL)
        {	printf("cannot open this file.\n");	exit(0);  }	
    }
        
    if((Particle_tracking = fopen("Par_Tra.txt","a"))==NULL)
    {	printf("cannot open this file.\n");	exit(0);  }


    // begin ODT calculation!
    for(realization=1; realization<=REALI; realization++)
    {
        diff_steps = 0;
        /**to generate a randome number seed and sample the random number for 20 times to avoid the same random number appears for different processors in parallel simulation  **/
        srand((unsigned) (time(NULL)+rank*3+(int)(rank*time(NULL)/50)));  
        for(i=0; i<(20+rank);i++)
            ranum=(double)rand()/RAND_MAX;

        eddy_occur=0;  ///there is no eddy occurs
        eddy_totalnumber = 0;

        for(i=0; i<4; i++)
            eddy_lp[i]=0.0;  //means the eddy length where pdf f(l) gets its maximum value
		
        // to initialize boundary conditions and initial conditions for cell/particle/uniform grid information!!!!!
        INITIALIZE(core_bdcell, grid_y, cell_info, eddy_info, par_info_ini, par_info, domain_cellnumber, backgrid_nd);
        RENEW_BACKGRID(domain_cellnumber[1], deta_x, grid_y, cell_info, par_info, backgrid_nd);

        //         printf("-----------------------------------------------------------------------------------------\n");
        //         printf("item\t\t\t N=%d\t\t N=%d\t\t N=%d\t\t N=%d\t\t N=%d\n",0,domain_cellnumber[0]/4, domain_cellnumber[0]/2,int(domain_cellnumber[0]*3./4.),domain_cellnumber[0]);
        //         printf("Viscosity_Coeff\t\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",cell_info[0].mixture.Kinetic_Viscosity_Coeff, cell_info[int(domain_cellnumber[0]/4)].mixture.Kinetic_Viscosity_Coeff, cell_info[domain_cellnumber[0]/2].mixture.Kinetic_Viscosity_Coeff,cell_info[int(domain_cellnumber[0]*3./4.)].mixture.Kinetic_Viscosity_Coeff, cell_info[domain_cellnumber[0]-1].mixture.Kinetic_Viscosity_Coeff);
        //         printf("mixture.Density\t\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",cell_info[0].mixture.Density, cell_info[int(domain_cellnumber[0]/4)].mixture.Density, cell_info[domain_cellnumber[0]/2].mixture.Density,cell_info[int(domain_cellnumber[0]*3./4.)].mixture.Density, cell_info[domain_cellnumber[0]-1].mixture.Density);
        //         printf("Velocity\t\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",cell_info[0].u, cell_info[int(domain_cellnumber[0]/4)].u, cell_info[domain_cellnumber[0]/2].u,cell_info[int(domain_cellnumber[0]*3./4.)].u, cell_info[domain_cellnumber[0]-1].u);
        //         printf("Position\t\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",cell_info[0].y, cell_info[int(domain_cellnumber[0]/4)].y, cell_info[domain_cellnumber[0]/2].y,cell_info[int(domain_cellnumber[0]*3./4.)].y, cell_info[domain_cellnumber[0]-1].y);
        //         printf("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ END OF INITIALIZATION $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$\n\n");

        printf("\n\n this is the %dth realization! Rank=%d\n\n\n",realization,rank);
        //         printf("\t\tJ/E Number\t      Size\t\t\t      Velocity\t\t\t    Density\t\t\t          Tem\t\t\n");

        /// to generate a new file which restore the eddy information 
        if(realization==1 && rank==0)
        {
            if((Eddies = fopen("Eddies.txt","a"))==NULL)
            {	printf("cannot open this file.\n");	exit(0);  }
            //            fprintf(Eddies, "n\tx_position\typos_start\typos_end  \teddy_lifetime\teddy_uvelo\teddy_vvelo\n");
        }
    
        // begin ODT line development during a certain realization
        //j means jth odt step, j is used to print data out, maybe j is useless in furture.
        odt_x = 0.0; //the initial height of the ODT line is 0.0m
        j = 0;      // print step ==0 (no use)
        E_S_number = 0;  //eddy sample number ==0
        E_S_old = E_S_number;  //the eddy sample number that the latest diffusion step occurs 
        diff_number = 0;
        diffdx_max = CALCU_DIFFDX_MAX(domain_cellnumber[1], cell_info);  // initialize the maximum diffusion step

        Visc_Flag = 1;    // there is no error in viscous process
        SpeDiff_Flag = 1; // there is no error in species diffusion process
        MFRDiff_Flag = 1; // there is no error in mixturefraction diffusion process
        Tem_Flag = 1;     // there is no error in heat transfer process
        Trip_Flag = 0;    // there is no error in triplet map process
        Regrid_Flag = 1;  // there is no error in regrid process
        
        // begin ODT calculation!
        while(odt_x<=domain_x)   //        for(j=0; j<xstep_number; j++)
        {
            //             if(E_S_number%(5*print_step) == 0)
            //             {
            //                 printf("MFR_Vol: [%d]=%8.5f,  [%d]=%8.5f,  [%d]=%8.5f\n", domain_cellnumber[1]/2-51, cell_info[domain_cellnumber[1]/2-51].mixture.Mixture_Fraction[0],domain_cellnumber[1]/2,cell_info[domain_cellnumber[1]/2].mixture.Mixture_Fraction[0],domain_cellnumber[1]/2+50, cell_info[domain_cellnumber[1]/2+50].mixture.Mixture_Fraction[0]);
            //                 printf("MFR_C: [%d]=%8.5f,  [%d]=%8.5f,  [%d]=%8.5f\n", domain_cellnumber[1]/2-51, cell_info[domain_cellnumber[1]/2-51].mixture.Mixture_Fraction[1],domain_cellnumber[1]/2,cell_info[domain_cellnumber[1]/2].mixture.Mixture_Fraction[1],domain_cellnumber[1]/2+50, cell_info[domain_cellnumber[1]/2+50].mixture.Mixture_Fraction[1]);
            //                 printf("MFR_OP: [%d]=%8.5f,  [%d]=%8.5f,  [%d]=%8.5f\n", domain_cellnumber[1]/2-51, cell_info[domain_cellnumber[1]/2-51].mixture.Mixture_Fraction[2],domain_cellnumber[1]/2,cell_info[domain_cellnumber[1]/2].mixture.Mixture_Fraction[2],domain_cellnumber[1]/2+50, cell_info[domain_cellnumber[1]/2+50].mixture.Mixture_Fraction[2]);
            //                 printf("MFR_OS: [%d]=%8.5f,  [%d]=%8.5f,  [%d]=%8.5f\n", domain_cellnumber[1]/2-51, cell_info[domain_cellnumber[1]/2-51].mixture.Mixture_Fraction[3],domain_cellnumber[1]/2,cell_info[domain_cellnumber[1]/2].mixture.Mixture_Fraction[3],domain_cellnumber[1]/2+50, cell_info[domain_cellnumber[1]/2+50].mixture.Mixture_Fraction[3]);
            //                 printf("MFR_Vol: [%d]=%8.5f,  [%d]=%8.5f,  [%d]=%8.5f\n", domain_cellnumber[1]/2-51, cell_info[domain_cellnumber[1]/2-51].mixture.Mixture_Fraction[4],domain_cellnumber[1]/2,cell_info[domain_cellnumber[1]/2].mixture.Mixture_Fraction[4],domain_cellnumber[1]/2+50, cell_info[domain_cellnumber[1]/2+50].mixture.Mixture_Fraction[4]);
            //                 printf("Tem: [%d]=%8.5f,  [%d]=%8.5f,  [%d]=%8.5f\n", domain_cellnumber[1]/2-51, cell_info[domain_cellnumber[1]/2-51].mixture.Tem,domain_cellnumber[1]/2, cell_info[domain_cellnumber[1]/2].mixture.Tem,domain_cellnumber[1]/2+50, cell_info[domain_cellnumber[1]/2+50].mixture.Tem);
            //                 printf("Lew: [%d]=%8.5f, [%d]=%8.5f, [%d]=%8.5f\n", domain_cellnumber[1]/2-51, cell_info[domain_cellnumber[1]/2-51].mixture.Conduction_Coeff/cell_info[domain_cellnumber[1]/2-51].mixture.Density/cell_info[domain_cellnumber[1]/2-51].mixture.Heat_Capacity/1000*cell_info[domain_cellnumber[1]/2-51].mixture.Molecular_Weight/cell_info[domain_cellnumber[1]/2-51].mixture.Spe_Diff_Coeff[0], domain_cellnumber[1]/2, cell_info[domain_cellnumber[1]/2].mixture.Conduction_Coeff/cell_info[domain_cellnumber[1]/2].mixture.Density/cell_info[domain_cellnumber[1]/2].mixture.Heat_Capacity/1000*cell_info[domain_cellnumber[1]/2].mixture.Molecular_Weight/cell_info[domain_cellnumber[1]/2].mixture.Spe_Diff_Coeff[0], domain_cellnumber[1]/2+50, cell_info[domain_cellnumber[1]/2+50].mixture.Conduction_Coeff/cell_info[domain_cellnumber[1]/2+50].mixture.Density/cell_info[domain_cellnumber[1]/2+50].mixture.Heat_Capacity/1000*cell_info[domain_cellnumber[1]/2+50].mixture.Molecular_Weight/cell_info[domain_cellnumber[1]/2+50].mixture.Spe_Diff_Coeff[0]);

            //             }

            //                printf("Begin\t\tJ=%d,N=%d\t%8.5e, %8.5e\t%8.5f,  %8.5f\t\t%8.5f,  %8.5f\t\t%8.5f,  %8.5f\n", j,domain_cellnumber[1]/2,cell_info[domain_cellnumber[1]/2].size_old,cell_info[domain_cellnumber[1]/2].size,cell_info[domain_cellnumber[1]/2].u_old,cell_info[domain_cellnumber[1]/2].u,cell_info[domain_cellnumber[1]/2].Density_old,cell_info[domain_cellnumber[1]/2].mixture.Density,cell_info[domain_cellnumber[1]/2].Tem_old,cell_info[domain_cellnumber[1]/2].mixture.Tem);

            //                printf("1 %d\t%d  %d  %f  %f  %f  %f %8.5f %13.10f %8.5e\n", j, domain_cellnumber[0], domain_cellnumber[1], grid_y[0], grid_y[domain_cellnumber[1]], cell_info[0].size, cell_info[domain_cellnumber[1]-1].size, cell_info[int(domain_cellnumber[1]/2)].mixture.Molefr[He], cell_info[0].mixture.Molefr[He], cell_info[int(domain_cellnumber[1]/2)].u);
            
            // to record the initial value at the beginning of ODT step
            eddy_lp[2] = 0.0;
            eddy_lp[3] = 0.0;
    
            //eddy selection procedure. //triplet map process: monte carlo method to judge if an eddy will occur and do triplet map process
            TRIPLET_MAP(E_S_number, E_S_old, domain_cellnumber[1], core_bdcell, grid_y, cell_info, eddy_info, source, cell_ave, &eddy_occur, &eddy_totalnumber, &Trip_Flag, eddy_lp);
            deta_x += dx_stir;  //the distance of the ODT line from the last diffusion line
            E_S_number++;    /// to renew the Eddy Sampling number!
            odt_x += dx_stir;  /// odt_x = E_S_number*dx_stir

            ///Trip_Flag==1: eddy occurs
            ///deta_x>=diffdx_max: the diffusion step equal to the maximum diffusion step
            /// E_S_number==1: initial step, equilibrium should be considered
            /// E_S_number%equilibrium_step==0: to meet the equilibrium step line, both diffusion and equilibrium should be considered!
            if(Trip_Flag==1 || deta_x>=diffdx_max-1e-10 || E_S_number==1 || E_S_number%equilibrium_step==0 || E_S_number%print_step==0)
            {
                
                deta_number = 0;   // to initialize deta_number

                diff_steps += 1;  // to counter one additional diffusion step
                sub_step = 0;

                //               printf("1! core_bdcell[0]=%d,core_bdcell[1]=%d, core_0=%f, core_1=%f\n",core_bdcell[0],core_bdcell[1],grid_y[core_bdcell[0]],grid_y[core_bdcell[1]+1]);
                // to record the domain cell number in last step (for debug)
                domain_cellnumber[0] = domain_cellnumber[1];  

                if(E_S_number == 1)  // at the beginning of odt line: equilibrium, without particle track and diffusion et al.
                {
                    EQUILIBRIUM_ODT(E_S_number, domain_cellnumber[1], cell_info);
                    REGRID_KEEPCONSTANT(core_bdcell, &domain_cellnumber[1], eddy_occur, grid_y, cell_info, par_info, eddy_info);  /// to keep a constant domain!
                    for(i=0; i<domain_cellnumber[1]; i++)
                        cell_backup[i] = cell_info[i];
                    for(i=0; i<par_tracknumber; i++)
                        par_info_ini[i] = par_info[i];
                }
                else ///either an eddy occurs, or come to the maximum diffusion step, or come to the equilibrium line
                {
                    // when eddy occurs, the domain width is changed. this function is used to add/subtract cells to keep a constant domain
                    if(Trip_Flag == 1)
                    {
                        // to print eddy information
                        if(realization==1 && rank==0)
                        {
                            //                            printf("eddy_occur=%d\n",eddy_occur);
                            fprintf(Eddies, "%d\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",eddy_info[eddy_occur-1].ser_number,odt_x,eddy_info[eddy_occur-1].ystart,eddy_info[eddy_occur-1].yend,eddy_info[eddy_occur-1].lifetime, eddy_info[eddy_occur-1].length*1000, eddy_info[eddy_occur-1].height*1000, eddy_info[eddy_occur-1].height_judge*1000, eddy_info[eddy_occur-1].u, eddy_info[eddy_occur-1].v);
                        }
                        eddies_x++;
                        
                        //                    printf("2! core_bdcell[0]=%d,core_bdcell[1]=%d, core_0=%f, core_1=%f\n",core_bdcell[0],core_bdcell[1],grid_y[core_bdcell[0]],grid_y[core_bdcell[1]+1]);

                        Trip_Flag = 0;  //to reset Triplet flag:there is no eddy occurs

                        //  to keep a constant domain
                        REGRID_KEEPCONSTANT(core_bdcell, &domain_cellnumber[1], eddy_occur, grid_y, cell_info, par_info, eddy_info); 

                        for(i=0; i<domain_cellnumber[1]; i++)
                            cell_backup[i] = cell_info[i];
                        for(i=0; i<par_tracknumber; i++)
                            par_info_ini[i] = par_info[i];
                    }
//                     strcpy(Step, "AF_TE");
//                    CHECK_CONVERSATION(domain_cellnumber[1], cell_info, source, Step); 
                    E_S_renew = E_S_number;
                    while(deta_number<(E_S_number-E_S_old))  //while diffusion line is lower than odt line
                    {
                        deta_x1 = deta_x;

                        // to judge which cell is occupied by which eddy, and to remove eddies from the array eddy_info which do not across the ODT line anymore
                        EDDY_JUDGESTATE(E_S_number, E_S_old, &eddy_occur, domain_cellnumber[1], grid_y, cell_info, eddy_info);

                        // To judge which cell a particle is in.
                        PARTICLE_JUDGECELL(domain_cellnumber[1], grid_y, cell_info, par_info);
                        ///////////////////////////////////////////////////////////////////////////////////////////////
                        // to set particle source term to 0.0
                        INI_SOU_PARCELL(domain_cellnumber[1],source, backgrid_nd);
                        //        printf("before particle tracking!\n");
                        // To solve particle motion equation, to consider eddy-particle interaction and particle reactions and renew particle source term
                        PARTICLE_TRACKING(E_S_renew, domain_cellnumber[1], deta_x, grid_y, cell_info, eddy_info, par_info, source);

                        //                     strcpy(Step, "AF_Tp");
                        //                     CHECK_CONVERSATION(domain_cellnumber[1], cell_info, source, Step); 
                                        
                        domain_cellnumber[0] = domain_cellnumber[1];
                        for(i=0; i<domain_cellnumber[1]; i++)
                        {
                            cell_info[i].u_old = cell_info[i].u;
                            cell_info[i].size_old = cell_info[i].size;
                            cell_info[i].Tem_old = cell_info[i].mixture.Tem;
                            cell_info[i].Density_old = cell_info[i].mixture.Density;
                            for(k1=0; k1<Species_Number; k1++)
                                cell_info[i].Massfr_old[k1] = cell_info[i].mixture.Massfr[k1];
                            for(k1=0; k1<5; k1++)
                                cell_info[i].MFR_old[k1] = cell_info[i].mixture.MixtureFr_Coal[k1];
                            cell_info[i].v_lateral = 0.0; //to initialize lateral velocity
                            cell_info[i].y_old = cell_info[i].y;  // to record the new cell position before diffusion step, be used to calculate the lateral velocity
                        }
                        
                        if(!(deta_x>0.))
                           printf("deta_x weird before diffusion! deta_x=%e\n",deta_x);
                        //to calculate diffusion process during two eddy events, or from one eddy events to the beginning of jth odt step
                        //DIFFUSION(&Diff_Flag, domain_cellnumber[1], deta_x, cell_info);  // to solve diffusion process;
                        VISCOUS_DIFFUSION;
                        //                    DIFFUSION_FE(E_S_number,&Visc_Flag, domain_cellnumber[1], deta_x, cell_info, source);  // to solve viscous process;
                        //                     strcpy(Step, "AF_Vi");
                        //                     CHECK_CONVERSATION(domain_cellnumber[1], cell_info, source, Step); 
                        //    printf("2 %d\t%d  %d  %f  %f  %f  %f %8.5f %13.10f %8.5e\n", j, domain_cellnumber[0], domain_cellnumber[1], grid_y[0], grid_y[domain_cellnumber[1]], cell_info[0].size, cell_info[domain_cellnumber[1]-1].size, cell_info[int(domain_cellnumber[1]/2)].mixture.Molefr[He], cell_info[0].mixture.Molefr[He], cell_info[int(domain_cellnumber[1]/2)].u);
                        //    if(eddy_totalnumber%print_step == 0)
                        //    printf("EB_Spe\t\tE=%d,N=%d\t%8.5e, %8.5e\t%8.5f,  %8.5f\t\t%8.5f,  %8.5f\t\t%8.5f,  %8.5f\n", eddy_totalnumber,domain_cellnumber[1]/2,cell_info[domain_cellnumber[1]/2].size_old,cell_info[domain_cellnumber[1]/2].size,cell_info[domain_cellnumber[1]/2].u_old,cell_info[domain_cellnumber[1]/2].u,cell_info[domain_cellnumber[1]/2].Density_old,cell_info[domain_cellnumber[1]/2].mixture.Density,cell_info[domain_cellnumber[1]/2].Tem_old,cell_info[domain_cellnumber[1]/2].mixture.Tem);
                        if(Visc_Flag == 1 )
                            SPECIES_DIFFUSION;
                        
                        //                    SPECIES_DIFFUSION_FE(E_S_number, &SpeDiff_Flag, domain_cellnumber[1], deta_x, cell_info, source);  // to solve species diffusion process
                        //                     strcpy(Step, "AF_Sp");
                        //                     CHECK_CONVERSATION(domain_cellnumber[1], cell_info, source, Step); 
                        if(Visc_Flag*SpeDiff_Flag==1)
                            MFR_DIFFUSION;
                        //                    MFR_DIFFUSION_FE(E_S_number, &MFRDiff_Flag, domain_cellnumber[1], deta_x, cell_info, source);
                        //                     strcpy(Step, "AF_MF");
                        //                     CHECK_CONVERSATION(domain_cellnumber[1], cell_info, source, Step); 
                        //  if(eddy_totalnumber%print_step == 0)
                        //  printf("EB_Hea\t\tE=%d,N=%d\t%8.5e, %8.5e\t%8.5f,  %8.5f\t\t%8.5f,  %8.5f\t\t%8.5f,  %8.5f\n", eddy_totalnumber,domain_cellnumber[1]/2,cell_info[domain_cellnumber[1]/2].size_old,cell_info[domain_cellnumber[1]/2].size,cell_info[domain_cellnumber[1]/2].u_old,cell_info[domain_cellnumber[1]/2].u,cell_info[domain_cellnumber[1]/2].Density_old,cell_info[domain_cellnumber[1]/2].mixture.Density,cell_info[domain_cellnumber[1]/2].Tem_old,cell_info[domain_cellnumber[1]/2].mixture.Tem);
                        if(Visc_Flag*SpeDiff_Flag*MFRDiff_Flag==1)
                            HEAT_TRANSFER;
                        //                    HEAT_TRANSFER_FE_TEM(E_S_number, &Tem_Flag, domain_cellnumber[1], deta_x, cell_info, source);  //to solve heat transfer process
                        if(Visc_Flag*SpeDiff_Flag*MFRDiff_Flag*Tem_Flag == 1)
                        {
                            sub_step += 1;
                            E_S_renew += int((deta_x+1e-10)/dx_stir);

                            deta_number += int((deta_x+1e-10)/dx_stir);
                            //                            printf("comehere!flag! deta_number=%d\n",deta_number);
                            //                            printf("1!E_S_renew=%d,E_S_number=%d,deta_number=%d\n",E_S_renew,E_S_number, deta_number);

                            // when deta_x>the rest diffusion space
                            if(deta_number+int((deta_x+1e-10)/dx_stir)>E_S_number-E_S_old && deta_number<E_S_number-E_S_old)
                            {
                                deta_x = (E_S_number-E_S_old-deta_number)*dx_stir;
                                if(deta_x==0.)
                                    printf("deta_x weird in fianl sub-circulation! E_S_number=%d, E_S_old=%d, deta_number=%d\n", E_S_number, E_S_old, deta_number);
                                E_S_renew = E_S_number;
                            }
                            //   printf("the next step=%e, deta_number=%d,E_S_renew=%d\n",deta_x,deta_number,E_S_renew);
                        
                            RENEW_Y(domain_cellnumber[1], grid_y, cell_info);
                        
                            // to calculate lateral velocity (do not consider the equilibrium effects)
                            CAL_VLATERAL_DISP(E_S_number, domain_cellnumber[1],deta_x, cell_info);

                            //  to keep a constant domain
                            REGRID_KEEPCONSTANT(core_bdcell, &domain_cellnumber[1], eddy_occur, grid_y, cell_info, par_info, eddy_info); 
                            
                            // to identify the new cell position and domain width so that a new eddy selection process can be impleted successfully.
                            for(i=0; i<domain_cellnumber[1]; i++)
                                cell_backup[i] = cell_info[i];
                            for(i=0; i<par_tracknumber; i++)
                                par_info_ini[i] = par_info[i];
                        }
                        // diffusion step is too large so that Flag=0, then to renew the diffusion step (deta_x has been modified in equation solvers)
                        else if(deta_x1 != deta_x)
                        {

                            E_S_renew = E_S_renew-int((deta_x1+1e-10)/dx_stir)+int((deta_x+1e-10)/dx_stir);
                            for(i=0; i<domain_cellnumber[1]; i++)
                                cell_info[i] = cell_backup[i];
                            for(i=0; i<par_tracknumber; i++)
                                par_info[i] = par_info_ini[i];
                            //                            if(Visc_Flag==0)
                            //                                printf("diff wrong! old_dx=%e, new_dx=%e,E_S_old=%d, E_S_renew=%d, E_S_number=%d\n",deta_x1, deta_x,E_S_old, E_S_renew, E_S_number);
                            deta_x1 = deta_x;
                            Visc_Flag = 1;
                            SpeDiff_Flag = 1;
                            MFRDiff_Flag = 1;
                            Tem_Flag = 1;
                        }
                        else
                        {
                            printf("diff_min is not enough (x1=%e,x=%e), the calculation will be aborted,V_F=%d,S_F=%d,M_F=%d,T_F=%d,E_renew=%d,number=%d\n",deta_x1,deta_x,Visc_Flag,SpeDiff_Flag,MFRDiff_Flag,Tem_Flag,E_S_renew,deta_number);
                            deta_number = E_S_number-E_S_old;
                        }
                    }  //while(deta_number<E_S_number-E_S_old)
                        
                    //   if(eddy_totalnumber%print_step == 0)
                    //   printf("EA_Heat\t\tE=%d,N=%d\t%8.5e, %8.5e\t%8.5f,  %8.5f\t\t%8.5f,  %8.5f\t\t%8.5f,  %8.5f\n", eddy_totalnumber,domain_cellnumber[1]/2,cell_info[domain_cellnumber[1]/2].size_old,cell_info[domain_cellnumber[1]/2].size,cell_info[domain_cellnumber[1]/2].u_old,cell_info[domain_cellnumber[1]/2].u,cell_info[domain_cellnumber[1]/2].Density_old,cell_info[domain_cellnumber[1]/2].mixture.Density,cell_info[domain_cellnumber[1]/2].Tem_old,cell_info[domain_cellnumber[1]/2].mixture.Tem);
                        
                    diff_number++;
                    diffdx_max = CALCU_DIFFDX_MAX(domain_cellnumber[1], cell_info);  // to calculate the maximum diffusion step according to fourier condition
                    
                    //error occurs in diffusion process, mainly caused by numerical solution error, which should be avoided
                    if(Visc_Flag*SpeDiff_Flag*MFRDiff_Flag*Tem_Flag==0)
                    { 
                        /*realization--;*/       
                        printf("case 1!! RECALCULATION\n");   
                        goto abnormal;
                    }
                    
                    if(E_S_number%equilibrium_step == 0)
                    {
                        EQUILIBRIUM_ODT(E_S_number, domain_cellnumber[1], cell_info);

                        //                   printf("3! core_bdcell[0]=%d,core_bdcell[1]=%d, core_0=%f, core_1=%f\n",core_bdcell[0],core_bdcell[1],grid_y[core_bdcell[0]],grid_y[core_bdcell[1]+1]);
                        
                        //  to keep a constant domain
                        REGRID_KEEPCONSTANT(core_bdcell, &domain_cellnumber[1], eddy_occur, grid_y, cell_info, par_info, eddy_info); 
                        
                        // to identify the new cell position and domain width so that a new eddy selection process can be impleted successfully.
                        for(i=0; i<domain_cellnumber[1]; i++)
                            cell_backup[i] = cell_info[i];
                        for(i=0; i<par_tracknumber; i++)
                            par_info_ini[i] = par_info[i];
                    }
                    
                    //                     strcpy(Step, "AF_Eq");
                    //                     CHECK_CONVERSATION(domain_cellnumber[1], cell_info, source, Step); 
                    
                    // to renew the eddy position information!
                    for(i=0; i<eddy_occur; i++)
                    {
                        eddy_info[i].ystart = grid_y[eddy_info[i].ycellstart];
                        eddy_info[i].yend = grid_y[eddy_info[i].ycellend];
                        //                    eddy_info[i].length = eddy_info[i].yend-eddy_info[i].ystart;
                    } 
                    // to split too large cells and to merge too small cells
                    MESH_MANAGEMENT(E_S_number, core_bdcell, domain_cellnumber,grid_y,cell_info);
   
                    // to judge which cell is occupied by which eddy, and to remove eddies from the array eddy_info which do not across the ODT line anymore
                    EDDY_JUDGECELL(eddy_occur, domain_cellnumber[1], grid_y, eddy_info);
                    //  to keep a constant domain
                    REGRID_KEEPCONSTANT(core_bdcell, &domain_cellnumber[1], eddy_occur, grid_y, cell_info, par_info, eddy_info); 
                    // to identify the new cell position and domain width so that a new eddy selection process can be impleted successfully.
                    for(i=0; i<domain_cellnumber[1]; i++)
                        cell_backup[i] = cell_info[i];
                    for(i=0; i<par_tracknumber; i++)
                        par_info_ini[i] = par_info[i];

                    //   to calculate particle number density diffusion coefficient based on background grid (uniform grid)
                    RENEW_BACKGRID(domain_cellnumber[1], deta_x, grid_y, cell_info, par_info, backgrid_nd);
                    // since the species/viscous/temperature diffusion process were calculated after an eddy occur. the initial value at the beginning of ODT step should be reset at this new height

                    if(E_S_number%50000 ==0)
                        printf("d_n:%5d\t%5d\todt_x=%f, diffdx=%e, E_number=%d,%d, TF=%d, deta_x=%f, dm=%d, Tem=%f, u=%f\n", diff_number,sub_step,odt_x, diffdx_max, E_S_number, E_S_old, Trip_Flag, deta_x, domain_cellnumber[1], cell_info[int(domain_cellnumber[1]/2)].mixture.Tem, cell_info[int(domain_cellnumber[1]/2)].u);

                    if(eddy_occur > eddy_number)
                        printf("eddy_number is too small! eddy_occur=%d, Rank=%d\n\n\n\n\n", eddy_occur, rank);
                    if(domain_cellnumber[1]>totalnumber)
                        printf("totalnumber is too small! domain_cn=%d, Rank=%d\n\n\n\n\n", domain_cellnumber[1], rank);


                    deta_x = 0.0;  //to reset the diffusion step
                    E_S_old = E_S_number;  // to record the height where the last diffusion step occurs.

                   if(realization == 1 && rank==0 && diff_steps%5==0)
                    {
                        // the small particle in the eddge (1-11)
                        fprintf(Particle_tracking, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5e\t%8.5f\t%8.5f\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", par_info[0].x, par_info[0].y, par_info[0].u, cell_info[par_info[0].cellin].u, par_info[0].v, cell_info[par_info[0].cellin].v_trip+cell_info[par_info[0].cellin].v_lateral, par_info[0].diameter, par_info[0].coal.Tem, cell_info[par_info[0].cellin].mixture.Tem, par_info[0].coal.Mass[1],par_info[0].coal.Mass_P[Pry_V], par_info[0].coal.Mass_P[Pry_C],par_info[0].coal.Mass[1]/par_info[0].coal.Mass[0]);
                        
                        fprintf(Particle_tracking, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5e\t%8.5f\t%8.5f\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", par_info[8].x, par_info[8].y, par_info[8].u, cell_info[par_info[8].cellin].u, par_info[8].v, cell_info[par_info[8].cellin].v_trip+cell_info[par_info[8].cellin].v_lateral, par_info[8].diameter, par_info[8].coal.Tem, cell_info[par_info[8].cellin].mixture.Tem, par_info[8].coal.Mass[1],par_info[8].coal.Mass_P[Pry_V], par_info[8].coal.Mass_P[Pry_C],par_info[8].coal.Mass[1]/par_info[8].coal.Mass[0]);
                        
                        fprintf(Particle_tracking, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5e\t%8.5f\t%8.5f\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", par_info[16].x, par_info[16].y, par_info[16].u, cell_info[par_info[16].cellin].u, par_info[16].v, cell_info[par_info[16].cellin].v_trip+cell_info[par_info[16].cellin].v_lateral, par_info[16].diameter, par_info[16].coal.Tem, cell_info[par_info[16].cellin].mixture.Tem, par_info[16].coal.Mass[1],par_info[16].coal.Mass_P[Pry_V], par_info[16].coal.Mass_P[Pry_C],par_info[16].coal.Mass[1]/par_info[16].coal.Mass[0]);
                        
                        fprintf(Particle_tracking, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f%8.5e\t%8.5f\t%8.5f\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", par_info[int(par_tracknumber/2)].x, par_info[int(par_tracknumber/2)].y, par_info[int(par_tracknumber/2)].u, cell_info[par_info[int(par_tracknumber/2)].cellin].u, par_info[int(par_tracknumber/2)].v, cell_info[par_info[int(par_tracknumber/2)].cellin].v_trip+cell_info[par_info[int(par_tracknumber/2)].cellin].v_lateral, par_info[int(par_tracknumber/2)].diameter, par_info[int(par_tracknumber/2)].coal.Tem, cell_info[par_info[int(par_tracknumber/2)].cellin].mixture.Tem, par_info[int(par_tracknumber/2)].coal.Mass[1],par_info[int(par_tracknumber/2)].coal.Mass_P[Pry_V], par_info[int(par_tracknumber/2)].coal.Mass_P[Pry_C],par_info[int(par_tracknumber/2)].coal.Mass[1]/par_info[int(par_tracknumber/2)].coal.Mass[0]);
                        
                        fprintf(Particle_tracking, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5e\t%8.5f\t%8.5f\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", par_info[int(par_tracknumber/2+8)].x, par_info[int(par_tracknumber/2+8)].y, par_info[int(par_tracknumber/2+8)].u, cell_info[par_info[int(par_tracknumber/2+8)].cellin].u, par_info[int(par_tracknumber/2+8)].v, cell_info[par_info[int(par_tracknumber/2+8)].cellin].v_trip+cell_info[par_info[int(par_tracknumber/2+8)].cellin].v_lateral, par_info[int(par_tracknumber/2+8)].diameter, par_info[int(par_tracknumber/2+8)].coal.Tem, cell_info[par_info[int(par_tracknumber/2+8)].cellin].mixture.Tem, par_info[int(par_tracknumber/2+8)].coal.Mass[1],par_info[int(par_tracknumber/2+8)].coal.Mass_P[Pry_V], par_info[int(par_tracknumber/2+8)].coal.Mass_P[Pry_C],par_info[int(par_tracknumber/2+8)].coal.Mass[1]/par_info[int(par_tracknumber/2+8)].coal.Mass[0]);
                        
                        fprintf(Particle_tracking, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5e\t%8.5f\t%8.5f\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", par_info[int(par_tracknumber/2+16)].x, par_info[int(par_tracknumber/2+16)].y, par_info[int(par_tracknumber/2+16)].u, cell_info[par_info[int(par_tracknumber/2+16)].cellin].u, par_info[int(par_tracknumber/2+16)].v, cell_info[par_info[int(par_tracknumber/2+16)].cellin].v_trip+cell_info[par_info[int(par_tracknumber/2)+16].cellin].v_lateral, par_info[int(par_tracknumber/2+16)].diameter, par_info[int(par_tracknumber/2+16)].coal.Tem, cell_info[par_info[int(par_tracknumber/2+16)].cellin].mixture.Tem, par_info[int(par_tracknumber/2+16)].coal.Mass[1],par_info[int(par_tracknumber/2+16)].coal.Mass_P[Pry_V], par_info[int(par_tracknumber/2+16)].coal.Mass_P[Pry_C],par_info[int(par_tracknumber/2+16)].coal.Mass[1]/par_info[int(par_tracknumber/2+16)].coal.Mass[0]);
                        
                        
                        fprintf(Particle_tracking, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5e\t%8.5f\t%8.5f\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", par_info[par_tracknumber-15].x, par_info[par_tracknumber-15].y, par_info[par_tracknumber-15].u, cell_info[par_info[par_tracknumber-15].cellin].u, par_info[par_tracknumber-15].v, cell_info[par_info[par_tracknumber-15].cellin].v_trip+cell_info[par_info[par_tracknumber-15].cellin].v_lateral, par_info[par_tracknumber-15].diameter, par_info[par_tracknumber-15].coal.Tem, cell_info[par_info[par_tracknumber-15].cellin].mixture.Tem, par_info[par_tracknumber-15].coal.Mass[1],par_info[par_tracknumber-15].coal.Mass_P[Pry_V], par_info[par_tracknumber-15].coal.Mass_P[Pry_C],par_info[par_tracknumber-15].coal.Mass[1]/par_info[par_tracknumber-15].coal.Mass[0]);
                        
                        fprintf(Particle_tracking, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5e\t%8.5f\t%8.5f\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", par_info[par_tracknumber-7].x, par_info[par_tracknumber-7].y, par_info[par_tracknumber-7].u, cell_info[par_info[par_tracknumber-7].cellin].u, par_info[par_tracknumber-7].v, cell_info[par_info[par_tracknumber-7].cellin].v_trip+cell_info[par_info[par_tracknumber-7].cellin].v_lateral, par_info[par_tracknumber-7].diameter, par_info[par_tracknumber-7].coal.Tem, cell_info[par_info[par_tracknumber-7].cellin].mixture.Tem, par_info[par_tracknumber-7].coal.Mass[1],par_info[par_tracknumber-7].coal.Mass_P[Pry_V], par_info[par_tracknumber-7].coal.Mass_P[Pry_C],par_info[par_tracknumber-7].coal.Mass[1]/par_info[par_tracknumber-7].coal.Mass[0]);
                        
                        fprintf(Particle_tracking, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5e\t%8.5f\t%8.5f\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", par_info[par_tracknumber-2].x, par_info[par_tracknumber-2].y, par_info[par_tracknumber-2].u, cell_info[par_info[par_tracknumber-2].cellin].u, par_info[par_tracknumber-2].v, cell_info[par_info[par_tracknumber-2].cellin].v_trip+cell_info[par_info[par_tracknumber-2].cellin].v_lateral, par_info[par_tracknumber-2].diameter, par_info[par_tracknumber-2].coal.Tem, cell_info[par_info[par_tracknumber-2].cellin].mixture.Tem, par_info[par_tracknumber-2].coal.Mass[1],par_info[par_tracknumber-2].coal.Mass_P[Pry_V], par_info[par_tracknumber-2].coal.Mass_P[Pry_C],par_info[par_tracknumber-2].coal.Mass[1]/par_info[par_tracknumber-2].coal.Mass[0]);
                        
                        fprintf(Particle_tracking, "\n");
                    }
                } //else

//                     strcpy(Step, "AF_MM");
//                     CHECK_CONVERSATION(domain_cellnumber[1], cell_info, source, Step); 
//                     printf("\n");

            } //if(..||..||..||)

            //to print the selected value based on ODT grid: the information of gas phase flowfield is acquired based on the non-uniform grid; the information of particles is acquired based on the uniform background grid
            if(realization==1 && rank==0)
            {
                if(E_S_number == 1)
                {
                    if((Velocity_gas=fopen("Velocity_gas.txt","a"))==NULL)
                    {	printf("cannot open this file.\n");	exit(0);  }

                    if((Velocity_particle=fopen("Velocity_particle.txt","a"))==NULL)
                    {	printf("cannot open this file.\n");	exit(0);  }
                }
                
                if((E_S_number)%record_xstep==0 || E_S_number==1)
                    PRINT_VELOCITY(E_S_number, domain_cellnumber[1], grid_y, cell_info, backgrid_nd,  source, Velocity_gas, Velocity_particle);

                if(E_S_number == xstep_number)
                {
                    fclose(Velocity_gas);
                    fclose(Velocity_particle);
                    fclose(Eddies);
                }
            }

            if(((E_S_number)%(2*record_xstep)==0 || E_S_number==1) && rank<10)
                PRINT_ALEX(E_S_number, domain_cellnumber[1], grid_y, cell_info, backgrid_nd,source, ALEX_INDEP, ALEX_DEP);


            if((E_S_number)%record_xstep==0 || E_S_number==1)
            {
                //   printf("E=%d, record=%d\n", E_S_number, E_S_number/record_xstep);
                RECORD_AVE(E_S_number,domain_cellnumber[1],avenumber,grid_y,cell_info,backgrid_nd, cell_ave, source);
            }


            //            for(i=0; i<eddy_occur; i++)
            //             {
            //                 if(eddy_info[i].ser_number == 1)
            //                     printf("start=%d, end=%d, ystart=%f, yend=%f, length=%f,%d, %d, %d\n",eddy_info[i].ycellstart,eddy_info[i].ycellend,eddy_info[i].ystart,eddy_info[i].yend,eddy_info[i].length,domain_cellnumber[0],domain_cellnumber[1],domain_cellnumber[2]);
            //             }
            //            printf("5, end!\n");

        }  //one realization, ===> while()

        eddy_lp[0] /= eddy_totalnumber;
        eddy_lp[1] /= eddy_totalnumber;
        eddy_lpp[0] += eddy_lp[0];
        eddy_lpp[1] += eddy_lp[1];
        eddy_numbers += eddy_totalnumber;

        //to record the detailed information for each eddy if it is the first realization
        //        printf("eddy_totalnumber=%d, average eddy length: %fmm, pdf: %f\n", eddy_totalnumber, eddy_lp[0]*1000, eddy_lp[1]);

    abnormal:	;  // to avoid continuing error calculation when negative velocity occurs
        if(realization ==1 && rank==0)
            fclose(Particle_tracking);	
    }  //total realization responding to for(realization=0; realization<REALI; realization++)

    if(rank<10)
    {
        fclose(ALEX_DEP);
        fclose(ALEX_INDEP);
    }

    eddy_lpp[0] /= REALI;
    eddy_lpp[1] /= REALI;
    eddy_numbers /= REALI;

    printf("the final average eddy length is: %8.5fmm.\n",eddy_lpp[0]*1000);
    printf("the final average eddy pdf is: %8.5f.\n", eddy_lpp[1]);
    printf("the final average eddy number is %d.\n", eddy_numbers);

    if(rank == root)
        printf("come here0, rank=%d\n",rank);

       MPI_Barrier(MPI_COMM_WORLD);

       for(j=0; j<=int(xstep_number/record_xstep); j++)
       {
           for(i=0; i<ysample_number; i++)
           {
               // PARALLEL, to communicate all of the data of each processor and acquire the summation
               MPI_Reduce(&cell_ave[j][i],&cellave_final[j][i],260,MPI_DOUBLE, MPI_SUM, root,MPI_COMM_WORLD);
           }
           MPI_Reduce(&avenumber[j],&avenumber1[j],1,MPI_INT, MPI_SUM,root,MPI_COMM_WORLD);
           if(j%20 == 0)
               printf("rank=%d, j=%d\n",rank,j);
       }

       printf("come here!!! rank=%d\n",rank);
       MPI_Barrier(MPI_COMM_WORLD);

    if(rank == root)
    {	/* to generate a file which record a statistical average velocity at fixed height */
        printf("come here1!!!!!!!!!!!!!!!!!!\n");
        /* to generate a file which record a statistical average velocity at fixed height */

        for(j=0; j<=xstep_number/record_xstep; j++)
        {
            //  for parallel calculation
            avenumber[j]=avenumber1[j];

            for(i=0; i<ysample_number; i++)
            {
                //  for parallel calculation
                cell_ave[j][i] = cellave_final[j][i];
                CALCULATE_AVE(i,j,size,avenumber,cell_ave);
            }
        }

        PRINT_AVE(avenumber, cell_ave);

        //		PRINT_AXIS(avenumber,cell_ave);
    }
    /* to generate a file which records the parameters */
    if((Parameter_table=fopen("Parameter.txt","a"))==NULL)
    {	printf("cannot open this file.\n");		exit(0);	}

    fprintf(Parameter_table,"in this case, the paramenter is:\n alfa=%8.5f\t, C=%8.5f\t, Z_small=%8.5f\t,Z_large=%8.5f\t, Reali=%d\t, beta=%8.5f\n", alfa, C_odt, Z_small,Z_large, REALI,beta);
    fprintf(Parameter_table, "Rank=%d\t size=%d\t domain_x=%8.5f\tdomain_yleft=%8.5f\tdomain_yright=%8.5f\n",rank,size,domain_x,-dy_co*ysample_number/2,dy_co*ysample_number/2);
    fprintf(Parameter_table, "the initialization of the covelocity is %f m/s with %f intensity\n", covelocity, turb_intensity_coflow);
    fprintf(Parameter_table, "the initialization of the jet velocity with intensity is %f\n\n", turb_intensity_center);

    fprintf(Parameter_table, "the final average eddy length is:   %8.5fmm. \n", eddy_lpp[0]*1e3);
    fprintf(Parameter_table, "the final average eddy pdf is:      %8.5f.\n", eddy_lpp[1]);
    fprintf(Parameter_table, "the final average eddy number is:   %d.\n", eddy_numbers);
    fclose(Parameter_table);
    printf("simulation complete! successful!\n");

    MPI_Finalize();
    return 0;
}




    








/***************************************************************************************************
Forward Euler method to solve the viscous diffusion equation!
***************************************************************************************************/
void DIFFUSION_FE(int E_S_number, int *Visc_Flag, int domain_cellnumber, double *deta_x, struct cell_information *cell, struct source_information *source)
{


    int i,i1;
    double A0,B0,B1,B2;
    double u[domain_cellnumber], size[domain_cellnumber];
    double mass_fr,r;
    double S_buoyancy;  //buoyancy source term!!
    //    struct cell_information cell_new[domain_cellnumber];

    // to calculate new velocity
    for(i=0; i<domain_cellnumber; i++)
    {
        if(i==0)
        {
            mass_fr = cell[i].u*cell[i].mixture.Density*dy_co;
            A0 = *deta_x;
            B1 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[domain_cellnumber-1].mixture.Kinetic_Viscosity_Coeff)/(dy_co+dy_co);
            B2 = 2*(cell[i].mixture.Kinetic_Viscosity_Coeff*cell[i+1].size+cell[i+1].mixture.Kinetic_Viscosity_Coeff*dy_co)/pow((dy_co+cell[i+1].size),2);
            B0 = B1+B2;

            r = A0*B1*cell[domain_cellnumber-1].u+(mass_fr-A0*B0)*cell[i].u+A0*B2*cell[i+1].u;  //ghost point for cell[domain_cellnumber-1]
            r += source[i].mom_u;   // to consider the momentum source
            r += (cell[1].mixture.Density-cell[i].mixture.Density)*gravity_ac*(*deta_x)*dy_co;  // to consider buoyancy
            u[i] = r/(mass_fr+source[i].mass);
        }
        else if(i==domain_cellnumber-1)
        {
            mass_fr = cell[i].u*cell[i].mixture.Density*dy_co;
            A0 = *deta_x;
            B1 = 2*(cell[i].mixture.Kinetic_Viscosity_Coeff*cell[i-1].size+dy_co*cell[i-1].mixture.Kinetic_Viscosity_Coeff)/pow((cell[i-1].size+dy_co),2);
            B2 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[0].mixture.Kinetic_Viscosity_Coeff)/(dy_co+dy_co);
            B0 = B1+B2;
            r = A0*B1*cell[i-1].u+(mass_fr-A0*B0)*cell[i].u+A0*B2*cell[0].u;  //ghost point for cell[0]
            r += source[i].mom_u;
            r += (cell[1].mixture.Density-cell[i].mixture.Density)*gravity_ac*(*deta_x)*dy_co;  // to consider buoyancy
            u[i] = r/(mass_fr+source[i].mass);
        }
        else
        {
            mass_fr = cell[i].u*cell[i].mixture.Density*cell[i].size;
            A0 = (*deta_x);
            B1 = B2;            
//            B1 = 2*(cell[i].mixture.Kinetic_Viscosity_Coeff*(i==1?dy_co:cell[i-1].size)+cell[i-1].mixture.Kinetic_Viscosity_Coeff*cell[i].size)/pow(((i==1?dy_co:cell[i-1].size)+cell[i].size),2);
            B2 = 2*(cell[i].mixture.Kinetic_Viscosity_Coeff*(i==domain_cellnumber-2?dy_co:cell[i+1].size_old)+cell[i+1].mixture.Kinetic_Viscosity_Coeff*cell[i].size_old)/pow(((i==domain_cellnumber-2?dy_co:cell[i+1].size_old)+cell[i].size_old),2);
            B0 = B1+B2;
            r = A0*B1*cell[i-1].u+(mass_fr-A0*B0)*cell[i].u+A0*B2*cell[i+1].u;
            r += source[i].mom_u;  //to consider the momentum source
            r += (cell[1].mixture.Density-cell[i].mixture.Density)*gravity_ac*(*deta_x)*cell[i].size;  // to consider buoyancy
            u[i] = r/(mass_fr+source[i].mass);
        }
    }


    for(i=0; i<domain_cellnumber; i++)
    {
        // to renew the cell size according to conservation of mass flow rate
        size[i] = (cell[i].size*cell[i].u*cell[i].mixture.Density+source[i].mass)/(cell[i].mixture.Density*u[i]);

        if(!(u[i]>0 && u[i]<=300))
        {
            //  printf("%dth step: error occurs during diffusion process!cell number: %d\t,velo:%8.5f\n",E_S_number,i,cell_new[i].u);
            //printf("%d\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",E_S_number,cell[i].u,i==domain_cellnumber-1?cell[0].u:cell[i+1].u,i==0?cell[domain_cellnumber-1].u:cell[i-1].u,cell[i].size,i==domain_cellnumber-1?cell[0].size:cell[i+1].size,i==0?cell[domain_cellnumber-1].size:cell[i-1].size);
            //printf("%d\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",E_S_number,u[i],u[i+1],u[i-1],cell_new[i].size,cell_new[i+1].size,cell_new[i-1].size);
            //printf("%8.5f\t%8.5f\t%8.5f\n",cell[i].mixture.Density,cell[i+1].mixture.Density,cell[i-1].mixture.Density);

            *Visc_Flag = 0;
            printf("%dth step! error occurs during 2nd circulation for viscous diffusion process!(*deta_x)=%8.5f\n",E_S_number,(*deta_x));
            for(i1=(i-20<0?0:i-20); i1<(i+20>domain_cellnumber-1?domain_cellnumber-1:i+20); i1++)
                printf("%d, %8.5f\t%8.5f\t%8.5f\t%8.5f\n",i1,cell[i1].mixture.Density,cell[i1].size,cell[i1].u,u[i1]);
          
            printf("cell[%d].u=%8.5f,cell[%d].u=%8.5f,cell[%d].u=%8.5f,u[%d]=%8.5f,u[%d]=%8.5f,u[%d]=%8.5f\n",i,cell[i].u,i-1,cell[i-1].u,i+1,cell[i+1].u,i,u[i],i-1,u[i-1],i+1,u[i+1]);
            printf("cell[0].u=%8.5f,cell[end].u=%8.5f\n",cell[0].u,cell[domain_cellnumber].u);

            // to modify the diffusion step
            MODIFY_DIFFDX(deta_x, cell[i].u,u[i]);
            goto abnormal2;
        }
    }
    for(i=0; i<domain_cellnumber; i++)
    {
        //        cell_new[i].u_old = cell[i].u_old;
        //        cell_new[i].size_old = cell[i].size_old;      // to save the origional cell size at the beginning of E_S_numberth step,this .size_old will be useding in species diffusion process!!!, see in species_diffusion.cpp for details.
        cell[i].u_old = cell[i].u;
        cell[i].u = u[i];
        cell[i].size_old = cell[i].size;
        cell[i].size = size[i];
    }
 abnormal2:    ;
}










/***************************************************************************************************
IMPROVED Forward Euler method to solve the viscous diffusion equation!
***************************************************************************************************/
void DIFFUSION_2NDFE(int E_S_number, int *Visc_Flag, int domain_cellnumber, double *deta_x, struct cell_information *cell, struct source_information *source)
{

    int i,i1;
    double A0,B0,B1,B2;
    double B0_1, B1_1, B2_1;
    double u[domain_cellnumber], size[domain_cellnumber];
    double u1[domain_cellnumber], size1[domain_cellnumber];
    double mass_fr,r;
    double S_buoyancy;  //buoyancy source term!!
    //    struct cell_information cell_new[domain_cellnumber];

    // to calculate new velocity
    for(i=0; i<domain_cellnumber; i++)
    {
        if(i==0)
        {
            mass_fr = cell[i].u*cell[i].mixture.Density*dy_co;  // here mass_fr=cell[i].u_old*cell[i].Density_old*dy_co
            A0 = (*deta_x);
            B1 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[domain_cellnumber-1].mixture.Kinetic_Viscosity_Coeff)/(dy_co+dy_co);
            B2 = 2*(cell[i].mixture.Kinetic_Viscosity_Coeff*cell[i+1].size+cell[i+1].mixture.Kinetic_Viscosity_Coeff*dy_co)/pow((dy_co+cell[i+1].size),2);
            B0 = B1+B2;

            r = A0*B1*cell[domain_cellnumber-1].u+(mass_fr-A0*B0)*cell[i].u+A0*B2*cell[i+1].u;  //ghost point for cell[domain_cellnumber-1]
            r += source[i].mom_u;   // to consider the momentum source
            r += (cell[1].mixture.Density-cell[i].mixture.Density)*gravity_ac*(*deta_x)*dy_co;  // to consider buoyancy
            u[i] = r/(mass_fr+source[i].mass);
        }
        else if(i==domain_cellnumber-1)
        {
            mass_fr = cell[i].u*cell[i].mixture.Density*dy_co;
            A0 = (*deta_x);
            B1 = 2*(cell[i].mixture.Kinetic_Viscosity_Coeff*cell[i-1].size+dy_co*cell[i-1].mixture.Kinetic_Viscosity_Coeff)/pow((cell[i-1].size+dy_co),2);
            B2 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[0].mixture.Kinetic_Viscosity_Coeff)/(dy_co+dy_co);
            B0 = B1+B2;
            r = A0*B1*cell[i-1].u+(mass_fr-A0*B0)*cell[i].u+A0*B2*cell[0].u;  //ghost point for cell[0]
            r += source[i].mom_u;
            r += (cell[1].mixture.Density-cell[i].mixture.Density)*gravity_ac*(*deta_x)*dy_co;  // to consider buoyancy
            u[i] = r/(mass_fr+source[i].mass);
        }
        else
        {
            mass_fr = cell[i].u*cell[i].mixture.Density*cell[i].size;
            A0 = (*deta_x);
            B1 = B2;            
//            B1 = 2*(cell[i].mixture.Kinetic_Viscosity_Coeff*(i==1?dy_co:cell[i-1].size)+cell[i-1].mixture.Kinetic_Viscosity_Coeff*cell[i].size)/pow(((i==1?dy_co:cell[i-1].size)+cell[i].size),2);
            B2 = 2*(cell[i].mixture.Kinetic_Viscosity_Coeff*(i==domain_cellnumber-2?dy_co:cell[i+1].size_old)+cell[i+1].mixture.Kinetic_Viscosity_Coeff*cell[i].size_old)/pow(((i==domain_cellnumber-2?dy_co:cell[i+1].size_old)+cell[i].size_old),2);
            B0 = B1+B2;
            r = A0*B1*cell[i-1].u+(mass_fr-A0*B0)*cell[i].u+A0*B2*cell[i+1].u;
            r += source[i].mom_u;  //to consider the momentum source
            r += (cell[1].mixture.Density-cell[i].mixture.Density)*gravity_ac*(*deta_x)*cell[i].size;  // to consider buoyancy
            u[i] = r/(mass_fr+source[i].mass);
        }
    }


    for(i=0; i<domain_cellnumber; i++)
    {
        // to renew the cell size according to conservation of mass flow rate
        size[i] = (cell[i].size*cell[i].u*cell[i].mixture.Density+source[i].mass)/(cell[i].mixture.Density*u[i]);

        if(!(u[i]>0 && u[i]<=300))
        {
            //  printf("%dth step: error occurs during diffusion process!cell number: %d\t,velo:%8.5f\n",E_S_number,i,cell_new[i].u);
            //printf("%d\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",E_S_number,cell[i].u,i==domain_cellnumber-1?cell[0].u:cell[i+1].u,i==0?cell[domain_cellnumber-1].u:cell[i-1].u,cell[i].size,i==domain_cellnumber-1?cell[0].size:cell[i+1].size,i==0?cell[domain_cellnumber-1].size:cell[i-1].size);
            //printf("%d\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",E_S_number,u[i],u[i+1],u[i-1],cell_new[i].size,cell_new[i+1].size,cell_new[i-1].size);
            //printf("%8.5f\t%8.5f\t%8.5f\n",cell[i].mixture.Density,cell[i+1].mixture.Density,cell[i-1].mixture.Density);

            *Visc_Flag = 0;

            printf("%dth step! error occurs during 2nd circulation for viscous diffusion process!(*deta_x)=%8.5f\n",E_S_number,(*deta_x));
            for(i1=(i-20<0?0:i-20); i1<(i+20>domain_cellnumber-1?domain_cellnumber-1:i+20); i1++)
                printf("%d, %8.5f\t%8.5f\t%8.5f\t%8.5f\n",i1,cell[i1].mixture.Density,cell[i1].size,cell[i1].u,u[i1]);
          
            printf("cell[%d].u=%8.5f,cell[%d].u=%8.5f,cell[%d].u=%8.5f,u[%d]=%8.5f,u[%d]=%8.5f,u[%d]=%8.5f\n",i,cell[i].u,i-1,cell[i-1].u,i+1,cell[i+1].u,i,u[i],i-1,u[i-1],i+1,u[i+1]);
            printf("cell[0].u=%8.5f,cell[end].u=%8.5f\n",cell[0].u,cell[domain_cellnumber].u);
             // to modify the diffusion step
            MODIFY_DIFFDX(deta_x, cell[i].u,u[i]);
            goto abnormal2;
        }
    }

//     for(i=0; i<domain_cellnumber; i++)
//     {
//         //        cell_new[i].u_old = cell[i].u_old;
//         //        cell_new[i].size_old = cell[i].size_old;      // to save the origional cell size at the beginning of E_S_numberth step,this .size_old will be useding in species diffusion process!!!, see in species_diffusion.cpp for details.
//         cell[i].u = u[i];
//         cell[i].size = size[i];
//     }



    // to calculate new velocity
    for(i=0; i<domain_cellnumber; i++)
    {
        if(i==0)
        {
            mass_fr = cell[i].u_old*cell[i].Density_old*dy_co;
            A0 = (*deta_x);
            B1 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[domain_cellnumber-1].mixture.Kinetic_Viscosity_Coeff)/(dy_co+dy_co)/2.0;
            B2 = (cell[i].mixture.Kinetic_Viscosity_Coeff*cell[i+1].size_old+cell[i+1].mixture.Kinetic_Viscosity_Coeff*dy_co)/pow((dy_co+cell[i+1].size_old),2);
            B1_1 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[domain_cellnumber-1].mixture.Kinetic_Viscosity_Coeff)/(dy_co+dy_co)/2.0;
            B2_1 = (cell[i].mixture.Kinetic_Viscosity_Coeff*size[i+1]+cell[i+1].mixture.Kinetic_Viscosity_Coeff*dy_co)/pow((dy_co+size[i+1]),2);
            B0 = B1+B2;
            B0_1 = B1_1+B2_1;

            r = A0*B1*cell[domain_cellnumber-1].u_old+A0*B1_1*u[domain_cellnumber-1]+(mass_fr-A0*B0)*cell[i].u_old-A0*B0_1*u[i]+A0*B2*cell[i+1].u_old+A0*B2_1*u[i+1];  //ghost point for cell[domain_cellnumber-1]
            r += source[i].mom_u;   // to consider the momentum source
            r += (cell[1].mixture.Density-cell[i].mixture.Density)*gravity_ac*(*deta_x)*dy_co;  // to consider buoyancy
            u1[i] = r/(mass_fr+source[i].mass);
        }
        else if(i==domain_cellnumber-1)
        {
            mass_fr = cell[i].u_old*cell[i].Density_old*dy_co;  //this mass_fr = old_mass_fr, now cell[i].u*cell[i].mixture.Density*dy_co=mass_fr_old+source[i].mass!!!
            A0 = (*deta_x);
            B1 = (cell[i].mixture.Kinetic_Viscosity_Coeff*cell[i-1].size_old+dy_co*cell[i-1].mixture.Kinetic_Viscosity_Coeff)/pow((cell[i-1].size_old+dy_co),2);
            B1_1 = (cell[i].mixture.Kinetic_Viscosity_Coeff*size[i-1]+dy_co*cell[i-1].mixture.Kinetic_Viscosity_Coeff)/pow((size[i-1]+dy_co),2);
            B2 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[0].mixture.Kinetic_Viscosity_Coeff)/(dy_co+dy_co)/2.0;
            B2_1 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[0].mixture.Kinetic_Viscosity_Coeff)/(dy_co+dy_co)/2.0;
            B0 = B1+B2;
            B0_1 = B1_1+B2_1;
            r = A0*B1*cell[i-1].u_old+A0*B1_1*u[i-1]+(mass_fr-A0*B0)*cell[i].u_old-A0*B0_1*u[i]+A0*B2*cell[0].u_old+A0*B2_1*u[0];  //ghost point for cell[0]
            r += source[i].mom_u;  //particle momentum source
            r += (cell[1].mixture.Density-cell[i].mixture.Density)*gravity_ac*(*deta_x)*dy_co;  // to consider buoyancy
            u1[i] = r/(mass_fr+source[i].mass);
        }
        else
        {
            mass_fr = cell[i].u_old*cell[i].Density_old*cell[i].size_old;
            A0 = (*deta_x);
            B1 = B2;     
            B1_1 = B2_1;       
//            B1 = 2*(cell[i].mixture.Kinetic_Viscosity_Coeff*(i==1?dy_co:cell[i-1].size)+cell[i-1].mixture.Kinetic_Viscosity_Coeff*cell[i].size)/pow(((i==1?dy_co:cell[i-1].size)+cell[i].size),2);
            B2 = (cell[i].mixture.Kinetic_Viscosity_Coeff*(i==domain_cellnumber-2?dy_co:cell[i+1].size_old)+cell[i+1].mixture.Kinetic_Viscosity_Coeff*cell[i].size_old)/pow(((i==domain_cellnumber-2?dy_co:cell[i+1].size_old)+cell[i].size_old),2);
            B2_1 = (cell[i].mixture.Kinetic_Viscosity_Coeff*(i==domain_cellnumber-2?dy_co:size[i+1])+cell[i+1].mixture.Kinetic_Viscosity_Coeff*size[i])/pow(((i==domain_cellnumber-2?dy_co:size[i+1])+size[i]),2);
            B0 = B1+B2;
            B0_1 = B1_1+B2_1;
            r = A0*B1*cell[i-1].u_old+A0*B1_1*u[i-1]+(mass_fr-A0*B0)*cell[i].u_old-A0*B0_1*u[i]+A0*B2*cell[i+1].u_old+A0*B2_1*u[i+1];
            r += source[i].mom_u;  //to consider the momentum source
            r += (cell[1].mixture.Density-cell[i].mixture.Density)*gravity_ac*(*deta_x)*(cell[i].size_old+size[i])/2.0;  // to consider buoyancy
            u1[i] = r/(mass_fr+source[i].mass);
        }
    }


    for(i=0; i<domain_cellnumber; i++)
    {
        // to renew the cell size according to conservation of mass flow rate
        size1[i] = (cell[i].size_old*cell[i].u_old*cell[i].Density_old+source[i].mass)/(cell[i].mixture.Density*u1[i]);

        if(!(u1[i]>0 && u1[i]<=300))
        {
            //  printf("%dth step: error occurs during diffusion process!cell number: %d\t,velo:%8.5f\n",E_S_number,i,cell_new[i].u);
            //printf("%d\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",E_S_number,cell[i].u,i==domain_cellnumber-1?cell[0].u:cell[i+1].u,i==0?cell[domain_cellnumber-1].u:cell[i-1].u,cell[i].size,i==domain_cellnumber-1?cell[0].size:cell[i+1].size,i==0?cell[domain_cellnumber-1].size:cell[i-1].size);
            //printf("%d\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",E_S_number,u[i],u[i+1],u[i-1],cell_new[i].size,cell_new[i+1].size,cell_new[i-1].size);
            //printf("%8.5f\t%8.5f\t%8.5f\n",cell[i].mixture.Density,cell[i+1].mixture.Density,cell[i-1].mixture.Density);

            *Visc_Flag = 0;

            printf("%dth step! error occurs during 2nd circulation for viscous diffusion process!(*deta_x)=%8.5f\n",E_S_number,(*deta_x));
            for(i1=(i-20<0?0:i-20); i1<(i+20>domain_cellnumber-1?domain_cellnumber-1:i+20); i1++)
                printf("%d, %8.5f\t%8.5f\t%8.5f\t%8.5f\n",i1,cell[i1].mixture.Density,cell[i1].size,cell[i1].u,u1[i1]);
          
            printf("cell[%d].u=%8.5f,cell[%d].u=%8.5f,cell[%d].u=%8.5f,u[%d]=%8.5f,u[%d]=%8.5f,u[%d]=%8.5f\n",i,cell[i].u,i-1,cell[i-1].u,i+1,cell[i+1].u,i,u1[i],i-1,u1[i-1],i+1,u1[i+1]);
            printf("cell[0].u=%8.5f,cell[end].u=%8.5f\n",cell[0].u,cell[domain_cellnumber].u);

            // to modify the diffusion step
            MODIFY_DIFFDX(deta_x,cell[i].u_old, u1[i]);
            goto abnormal2;
        }
    }
    for(i=0; i<domain_cellnumber; i++)
    {
        //        cell_new[i].u_old = cell[i].u_old;
        //        cell_new[i].size_old = cell[i].size_old;      // to save the origional cell size at the beginning of E_S_numberth step,this .size_old will be useding in species diffusion process!!!, see in species_diffusion.cpp for details.
        cell[i].u = u1[i];
        cell[i].size = size1[i];
    }


 abnormal2:    ;
}









/****************************************************************************************************/
/* This function is to use 4th order Runge-Kutta method to solve the diffusion process              */
/****************************************************************************************************/
void DIFFUSION_4THRK(int *Visc_Flag, int domain_cellnumber, double *deta_x, struct cell_information *cell)
{
    int i;
    double J1[domain_cellnumber+1],J2[domain_cellnumber+1],J3[domain_cellnumber+1],J4[domain_cellnumber+1];
    struct cell_information cell_1[domain_cellnumber],cell_2[domain_cellnumber],cell_3[domain_cellnumber];

    // the first iteration of 4th Runge-Kutta method

    {
        //to set boundary conditions and record the initial values of each step	
        for(i=0; i<domain_cellnumber; i++)
            cell_1[i] = cell[i];
        
        J1[0] = -(cell[0].mixture.Kinetic_Viscosity_Coeff+cell[domain_cellnumber-1].mixture.Kinetic_Viscosity_Coeff)*(cell[0].u-cell[domain_cellnumber-1].u)/(dy_co+dy_co);
        J1[1] = -(cell[0].mixture.Kinetic_Viscosity_Coeff+cell[1].mixture.Kinetic_Viscosity_Coeff)*(cell[1].u-cell[0].u)/(dy_co+cell[1].size);
        i = domain_cellnumber-1;
        J1[i] = -(cell[i].mixture.Kinetic_Viscosity_Coeff+cell[i-1].mixture.Kinetic_Viscosity_Coeff)*(cell[i].u-cell[i-1].u)/(dy_co+cell[i-1].size);
        J1[domain_cellnumber] = -(cell[domain_cellnumber-1].mixture.Kinetic_Viscosity_Coeff+cell[0].mixture.Kinetic_Viscosity_Coeff)*(cell[0].u-cell[domain_cellnumber-1].u)/(dy_co+dy_co);

        for(i=2; i<domain_cellnumber-1; i++)
            J1[i] = -(cell[i-1].mixture.Kinetic_Viscosity_Coeff+cell[i].mixture.Kinetic_Viscosity_Coeff)*(cell[i].u-cell[i-1].u)/(cell[i].size+cell[i-1].size);

        //solve the diffusion problem by explicit method.
        for(i=0; i<domain_cellnumber; i++)
        {
            if(i==0 || i==domain_cellnumber-1)
                cell_1[i].u = cell[i].u + (*deta_x)/2/(cell[i].u*cell[i].mixture.Density*dy_co)*(J1[i]-J1[i+1]);
            else
                cell_1[i].u = cell[i].u + (*deta_x)/2/(cell[i].u*cell[i].mixture.Density*cell[i].size)*(J1[i]-J1[i+1]);

  	
            //these two equations may be modified to consider diffusion effect on v and w!
            cell_1[i].v_lateral = cell[i].v_lateral;
            cell_1[i].v_trip = cell[i].v_trip;
            cell_1[i].w=cell[i].w;
            // to renew the cell size according to conservation of mass flow rate
            cell_1[i].size = cell[i].mixture.Density*cell[i].size*cell[i].u/cell_1[i].u/cell_1[i].mixture.Density;
 
            if (cell_1[i].u<=0 || cell_1[i].u>300)
            {
                //*Visc_Flag = 0;
                printf("error occurs during diffusion process_1!cell number: %d\t,velo:%8.5f\n",i,cell_1[i].u);
                printf("%d\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",domain_cellnumber,cell[i].u,cell[i+1].u,cell[i-1].u,cell[i].size,cell[i+1].size,cell[i-1].size);
                printf("%8.5f\t%8.5f\t%8.5f\n",cell[i].mixture.Density,cell[i+1].mixture.Density,cell[i-1].mixture.Density);

                // to modify the diffusion step
                MODIFY_DIFFDX(deta_x,cell[i].u, cell_1[i].u);
                //      goto abnormal2;
            }
        }
    }

    // the second iteration of 4th Runge-Kutta method
    {
        //to set boundary conditions and record the initial values of each step	
        for(i=0; i<domain_cellnumber; i++)
            cell_2[i] = cell_1[i];
        
        J2[0] = -(cell_1[0].mixture.Kinetic_Viscosity_Coeff+cell_1[domain_cellnumber-1].mixture.Kinetic_Viscosity_Coeff)*(cell_1[0].u-cell_1[domain_cellnumber-1].u)/(dy_co+dy_co);
        J2[1] = -(cell_1[0].mixture.Kinetic_Viscosity_Coeff+cell_1[1].mixture.Kinetic_Viscosity_Coeff)*(cell_1[1].u-cell_1[0].u)/(dy_co+cell_1[1].size);
        i = domain_cellnumber-1;
        J2[i] = -(cell_1[i].mixture.Kinetic_Viscosity_Coeff+cell_1[i-1].mixture.Kinetic_Viscosity_Coeff)*(cell_1[i].u-cell_1[i-1].u)/(dy_co+cell_1[i-1].size);
        J2[domain_cellnumber] = -(cell_1[domain_cellnumber-1].mixture.Kinetic_Viscosity_Coeff+cell_1[0].mixture.Kinetic_Viscosity_Coeff)*(cell_1[0].u-cell_1[domain_cellnumber-1].u)/(dy_co+dy_co);

        for(i=2; i<domain_cellnumber-1; i++)
            J2[i] = -(cell_1[i-1].mixture.Kinetic_Viscosity_Coeff+cell_1[i].mixture.Kinetic_Viscosity_Coeff)*(cell_1[i].u-cell_1[i-1].u)/(cell_1[i].size+cell_1[i-1].size);

        //solve the diffusion problem by explicit method.
        for(i=0; i<domain_cellnumber; i++)
        {
            if(i==0 || i==domain_cellnumber-1)
                cell_2[i].u = cell[i].u + (*deta_x)/2/(cell[i].u*cell[i].mixture.Density*dy_co)*(J2[i]-J2[i+1]);
            else
                cell_2[i].u = cell[i].u + (*deta_x)/2/(cell[i].u*cell[i].mixture.Density*cell[i].size)*(J2[i]-J2[i+1]);

  	
            //these two equations may be modified to consider diffusion effect on v and w!
            cell_2[i].v_lateral = cell_1[i].v_lateral;
            cell_2[i].v_trip = cell_1[i].v_trip;
            cell_2[i].w=cell_1[i].w;
            // to renew the cell size according to conservation of mass flow rate
            cell_2[i].size = cell[i].mixture.Density*cell[i].size*cell[i].u/cell_2[i].u/cell_2[i].mixture.Density;
 
            if (cell_2[i].u<=0 || cell_2[i].u>300)
            {
                //*Visc_Flag = 0;


                printf("error occurs during diffusion process_2!cell number: %d\t,velo:%8.5f\n",i,cell_2[i].u);
                printf("%d\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",domain_cellnumber,cell_1[i].u,cell_1[i+1].u,cell_1[i-1].u,cell_1[i].size,cell_1[i+1].size,cell_1[i-1].size);
                printf("%d\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",domain_cellnumber,cell[i].u,cell[i+1].u,cell[i-1].u,cell[i].size,cell[i+1].size,cell[i-1].size);
                printf("%8.5f\t%8.5f\t%8.5f\n",cell_1[i].mixture.Density,cell_1[i+1].mixture.Density,cell_1[i-1].mixture.Density);

                // to modify the diffusion step
                MODIFY_DIFFDX(deta_x, cell[i].u, cell_2[i].u);
                //       goto abnormal2;
            }
        }
    }


    // the 3rd iteration of 4th Runge-Kutta method

    {
        //to set boundary conditions and record the initial values of each step	
        for(i=0; i<domain_cellnumber; i++)
            cell_3[i] = cell_2[i];
        
        J3[0] = -(cell_2[0].mixture.Kinetic_Viscosity_Coeff+cell_2[domain_cellnumber-1].mixture.Kinetic_Viscosity_Coeff)*(cell_2[0].u-cell_2[domain_cellnumber-1].u)/(dy_co+dy_co);
        J3[1] = -(cell_2[0].mixture.Kinetic_Viscosity_Coeff+cell_2[1].mixture.Kinetic_Viscosity_Coeff)*(cell_2[1].u-cell_2[0].u)/(dy_co+cell_2[1].size);
        i = domain_cellnumber-1;
        J3[i] = -(cell_2[i].mixture.Kinetic_Viscosity_Coeff+cell_2[i-1].mixture.Kinetic_Viscosity_Coeff)*(cell_2[i].u-cell_2[i-1].u)/(dy_co+cell_2[i-1].size);
        J3[domain_cellnumber] = -(cell_2[domain_cellnumber-1].mixture.Kinetic_Viscosity_Coeff+cell_2[0].mixture.Kinetic_Viscosity_Coeff)*(cell_2[0].u-cell_2[domain_cellnumber-1].u)/(dy_co+dy_co);

        for(i=2; i<domain_cellnumber-1; i++)
            J3[i] = -(cell_2[i-1].mixture.Kinetic_Viscosity_Coeff+cell_2[i].mixture.Kinetic_Viscosity_Coeff)*(cell_2[i].u-cell_2[i-1].u)/(cell_2[i].size+cell_2[i-1].size);

        //solve the diffusion problem by explicit method.
        for(i=0; i<domain_cellnumber; i++)
        {
            if(i==0 || i==domain_cellnumber-1)
                cell_3[i].u = cell[i].u + (*deta_x)/(cell[i].u*cell[i].mixture.Density*dy_co)*(J3[i]-J3[i+1]);
            else
                cell_3[i].u = cell[i].u + (*deta_x)/(cell[i].u*cell[i].mixture.Density*cell[i].size)*(J3[i]-J3[i+1]);

            //these two equations may be modified to consider diffusion effect on v and w!
            cell_3[i].v_lateral = cell_2[i].v_lateral;
            cell_3[i].v_trip = cell_2[i].v_trip;
            cell_3[i].w=cell_2[i].w;
            // to renew the cell size according to conservation of mass flow rate
            cell_3[i].size = cell[i].mixture.Density*cell[i].size*cell[i].u/cell_3[i].u/cell_3[i].mixture.Density;
 
            if (cell_3[i].u<=0 || cell_3[i].u>300)
            {
                //*Visc_Flag = 0;

                // to modify the diffusion step
                MODIFY_DIFFDX(deta_x, cell[i].u, cell_3[i].u);

                printf("error occurs during diffusion process_3!cell number: %d\t,velo:%8.5f\n",i,cell_3[i].u);
                printf("J=  %8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",J1[i],J1[i+1],J2[i],J2[i+1],J3[i],J3[i+1]);
                printf("%d\t%8.5f\t%8.5f\t%8.5f\t%8.5e\t%8.5e\t%8.5e\n",domain_cellnumber,cell_2[i].u,cell_2[i+1].u,cell_2[i-1].u,cell_2[i].size,cell_2[i+1].size,cell_2[i-1].size);
                printf("%d\t%8.5f\t%8.5f\t%8.5f\t%8.5e\t%8.e\t%8.5e\n",domain_cellnumber,cell_1[i].u,cell_1[i+1].u,cell_1[i-1].u,cell_1[i].size,cell_1[i+1].size,cell_1[i-1].size);
                printf("%d\t%8.5f\t%8.5f\t%8.5f\t%8.5e\t%8.5e\t%8.5e\n",domain_cellnumber,cell[i].u,cell[i+1].u,cell[i-1].u,cell[i].size,cell[i+1].size,cell[i-1].size);
                printf("%8.5f\t%8.5f\t%8.5f\n",cell_2[i].mixture.Density,cell_2[i+1].mixture.Density,cell_2[i-1].mixture.Density);

                printf("come here!???????????????????\n\n\n");
            }
        }
    }



    //to calculate the final value

    {
        
        for(i=0; i<domain_cellnumber; i++)
            cell_1[i] = cell_3[i];

        J4[0] = -(cell_3[0].mixture.Kinetic_Viscosity_Coeff+cell_3[domain_cellnumber-1].mixture.Kinetic_Viscosity_Coeff)*(cell_3[0].u-cell_3[domain_cellnumber-1].u)/(dy_co+dy_co);
        J4[1] = -(cell_3[0].mixture.Kinetic_Viscosity_Coeff+cell_3[1].mixture.Kinetic_Viscosity_Coeff)*(cell_3[1].u-cell_3[0].u)/(dy_co+cell_3[1].size);
        i = domain_cellnumber-1;
        J4[i] = -(cell_3[i].mixture.Kinetic_Viscosity_Coeff+cell_3[i-1].mixture.Kinetic_Viscosity_Coeff)*(cell_3[i].u-cell_3[i-1].u)/(dy_co+cell_3[i-1].size);
        J4[domain_cellnumber] = -(cell_3[domain_cellnumber-1].mixture.Kinetic_Viscosity_Coeff+cell_3[0].mixture.Kinetic_Viscosity_Coeff)*(cell_3[0].u-cell_3[domain_cellnumber-1].u)/(dy_co+dy_co);

        for(i=2; i<domain_cellnumber-1; i++)
            J4[i] = -(cell_3[i-1].mixture.Kinetic_Viscosity_Coeff+cell_3[i].mixture.Kinetic_Viscosity_Coeff)*(cell_3[i].u-cell_3[i-1].u)/(cell_3[i].size+cell_3[i-1].size);


        //solve the diffusion problem by explicit method.
        for(i=0; i<domain_cellnumber; i++)
        {
            if(i==0 || i==domain_cellnumber-1)
                cell_1[i].u = cell[i].u + (*deta_x)/6/(cell[i].u*cell[i].mixture.Density*dy_co)*(J1[i]-J1[i+1]+J4[i]-J4[i+1]+2*(J2[i]-J2[i+1]+J3[i]-J3[i+1]));
            else
                cell_1[i].u = cell[i].u + (*deta_x)/6/(cell[i].u*cell[i].mixture.Density*cell[i].size)*(J1[i]-J1[i+1]+J4[i]-J4[i+1]+2*(J2[i]-J2[i+1]+J3[i]-J3[i+1]));

  	
            //these two equations may be modified to consider diffusion effect on v and w!
            cell_1[i].v_lateral = cell_3[i].v_lateral;
            cell_1[i].v_trip = cell_3[i].v_trip;
            cell_1[i].w = cell_3[i].w;
            // to renew the cell size according to conservation of mass flow rate
            cell_1[i].size = cell[i].mixture.Density*cell[i].size*cell[i].u/cell_1[i].u/cell_1[i].mixture.Density;
 
            if (cell_1[i].u<=0 || cell_1[i].u>300)
            {
                printf("come here!!!!!!!!!!!!!!!!!!!!!!!!!\n\n\n");
                *Visc_Flag = 0;

                printf("error occurs during diffusion process_4!cell number: %d\t,velo:%8.5f\n",i,cell_3[i].u);
                printf("%d\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",domain_cellnumber,cell_2[i].u,cell_2[i+1].u,cell_2[i-1].u,cell_2[i].size,cell_2[i+1].size,cell_2[i-1].size);
                printf("%8.5f\t%8.5f\t%8.5f\n",cell_2[i].mixture.Density,cell_2[i+1].mixture.Density,cell_2[i-1].mixture.Density);

                // to modify the diffusion step
                MODIFY_DIFFDX(deta_x, cell[i].u, cell_1[i].u);
                goto abnormal2;
            }
        }
    }

    for(i=0; i<domain_cellnumber; i++)
        cell[i] = cell_1[i];

 abnormal2:    ;

}








// Crank-Nicolson implicit method followed by an explicit method
// gost point was used at the boundary cells
// since the cell size of the boundary cells shall be very small sometime, the cell size of the boundary cell was set to dy_co during the calculation,
// this maks the calculation for the 0th, 1th, (domain_cell-1)th and (domain_cell-2)th cell be different with the other cells

void VISCOUS_DIFFUSION_CNONLY(int j, int *Visc_Flag, int domain_cellnumber, double (*deta_x), struct cell_information *cell)
{
    int i;
    //  a[i]u[i-1]+b[i]u[i]+c[i]u[i+1]=r[i], vector of tridiaginal matrix
    double a[domain_cellnumber],b[domain_cellnumber],c[domain_cellnumber],r[domain_cellnumber];
    double A0,B0,B1,B2,A0_1,B0_1,B1_1,B2_1;
    double u[domain_cellnumber];
    struct cell_information cell_new[domain_cellnumber];

    //to set boundary conditions and record the initial values of each step	
    for(i=0; i<domain_cellnumber; i++)
    {    cell_new[i] = cell[i]; 
    if(cell[i].u == 0 )
        printf("dfj_wierd! %d,%8.5f\n",i,cell[i].u);
    }

    // to calculate vector a[],b[],c[] and d[]
    for(i=0; i<domain_cellnumber; i++)
    {
        if(i==0)
        {
            A0 = (*deta_x)/(cell[i].u*cell[i].mixture.Density*dy_co)/2;
            B1 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[domain_cellnumber-1].mixture.Kinetic_Viscosity_Coeff)/(dy_co+dy_co);
            B2 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[i+1].mixture.Kinetic_Viscosity_Coeff)/(dy_co+cell[i+1].size);
            B0 = B1+B2;
            a[i] = 0.0;
            b[i] = 1+A0*B0;
            c[i] = -A0*B2;
            r[i] = 2*A0*B1*cell[domain_cellnumber-1].u+(1-A0*B0)*cell[i].u+A0*B2*cell[i+1].u;  //ghost point for cell[domain_cellnumber-1]
            r[i] += (cell[1].mixture.Density-cell[i].mixture.Density)*gravity_ac*(*deta_x)/(cell[i].mixture.Density*cell[i].u);  // to consider buoyancy
        }
        else if(i==domain_cellnumber-1)
        {
            A0 = (*deta_x)/(cell[i].u*cell[i].mixture.Density*dy_co)/2;
            B1 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[i-1].mixture.Kinetic_Viscosity_Coeff)/(cell[i-1].size+dy_co);
            B2 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[0].mixture.Kinetic_Viscosity_Coeff)/(dy_co+dy_co);
            B0 = B1+B2;
            a[i] = -A0*B1;
            b[i] = 1+A0*B0;
            c[i] = 0.0;
            r[i] = A0*B1*cell[i-1].u+(1-A0*B0)*cell[i].u+2*A0*B2*cell[0].u;  //ghost point for cell[0]
            r[i] += (cell[1].mixture.Density-cell[i].mixture.Density)*gravity_ac*(*deta_x)/(cell[i].mixture.Density*cell[i].u);  // to consider buoyancy
        }
        else
        {
            A0 = (*deta_x)/(cell[i].u*cell[i].mixture.Density*cell[i].size)/2;
            B1 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[i-1].mixture.Kinetic_Viscosity_Coeff)/(cell[i-1].size+cell[i].size);
            B2 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[i+1].mixture.Kinetic_Viscosity_Coeff)/(cell[i+1].size+cell[i].size);
            B0 = B1+B2;
            a[i] = -A0*B1;
            b[i] = 1+A0*B0;
            c[i] = -A0*B2;
            r[i] = A0*B1*cell[i-1].u+(1-A0*B0)*cell[i].u+A0*B2*cell[i+1].u;
            r[i] += (cell[1].mixture.Density-cell[i].mixture.Density)*gravity_ac*(*deta_x)/(cell[i].mixture.Density*cell[i].u);  // to consider buoyancy
        }
        u[i] = cell[i].u;
    }

    //to calculate the candidate cell velocity on (n+1)th odt line
    TRIDIAG(a,b,c,r,u,domain_cellnumber);

    //to calculate the candidate cell size
    for(i=0; i<domain_cellnumber; i++)
    {
        cell_new[i].u = u[i];
        cell_new[i].size = cell[i].mixture.Density*cell[i].size*cell[i].u/u[i]/cell_new[i].mixture.Density;

        if (cell_new[i].u<=0 || cell_new[i].u>300)
        {
            *Visc_Flag = 0;

            printf("%dth step: error occurs during diffusion process!cell number: %d\t,velo:%8.5f\n",j,i,cell_new[i].u);
            printf("%d\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",j,cell[i].u,i==domain_cellnumber-1?cell[0].u:cell[i+1].u,i==0?cell[domain_cellnumber-1].u:cell[i-1].u,cell[i].size,i==domain_cellnumber-1?cell[0].size:cell[i+1].size,i==0?cell[domain_cellnumber-1].size:cell[i-1].size);
            printf("%d\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",j,u[i],u[i+1],u[i-1],cell_new[i].size,cell_new[i+1].size,cell_new[i-1].size);
            printf("%8.5f\t%8.5f\t%8.5f\n",cell[i].mixture.Density,cell[i+1].mixture.Density,cell[i-1].mixture.Density);

            // to modify the diffusion step
            MODIFY_DIFFDX(deta_x, cell[i].u,cell_new[i].u);
            goto abnormal2;
        }

    }

    for(i=0; i<domain_cellnumber; i++)
        cell[i] = cell_new[i];

 abnormal2:    ;

}







// Crank-Nicolson implicit method followed by an explicit method
// gost point was used at the boundary cells
// since the cell size of the boundary cells shall be very small sometime, the cell size of the boundary cell was set to dy_co during the calculation,
// this maks the calculation for the 0th, 1th, (domain_cell-1)th and (domain_cell-2)th cell be different with the other cells
void VISCOUS_DIFFUSION_CN(int E_S_number, int *Visc_Flag, int domain_cellnumber, double (*deta_x), struct cell_information *cell, struct source_information *source)
{
    int i,i1;
    int detanumber;
    //  a[i]u[i-1]+b[i]u[i]+c[i]u[i+1]=r[i], vector of tridiaginal matrix
    double a[domain_cellnumber],b[domain_cellnumber],c[domain_cellnumber],r[domain_cellnumber];
    double A0,B0,B1,B2,A0_1,B0_1,B1_1,B2_1;
    double u[domain_cellnumber];
    double mass_fr;
    double S_buoyancy;  //buoyancy source term!!
    struct cell_information cell_new[domain_cellnumber];

    //to set boundary conditions and record the initial values of each step	
    for(i=0; i<domain_cellnumber; i++)
    {   
        cell_new[i] = cell[i]; 
        if(cell[i].u == 0 )
            printf("velocity wierd! %d,%8.5f\n",i,cell[i].u);
    }

    // to calculate vector a[],b[],c[] and d[]
    for(i=0; i<domain_cellnumber; i++)
    {
        if(i==0)
        {
            mass_fr = cell[i].u*cell[i].mixture.Density*dy_co;
            A0 = (*deta_x);
            B1 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[domain_cellnumber-1].mixture.Kinetic_Viscosity_Coeff)/(dy_co+dy_co)/2.0;
            B2 = (cell[i].mixture.Kinetic_Viscosity_Coeff*cell[i+1].size+cell[i+1].mixture.Kinetic_Viscosity_Coeff*dy_co)/pow((dy_co+cell[i+1].size),2);
            B0 = B1+B2;
            a[i] = 0.0;
            b[i] = mass_fr+A0*B0;
            b[i] += source[i].mass;
            c[i] = -A0*B2;
            r[i] = 2*A0*B1*cell[domain_cellnumber-1].u+(mass_fr-A0*B0)*cell[i].u+A0*B2*cell[i+1].u;  //ghost point for cell[domain_cellnumber-1]
            r[i] += source[i].mom_u;   // to consider the momentum source
            r[i] += (cell[1].mixture.Density-cell[i].mixture.Density)*gravity_ac*(*deta_x)*dy_co;  // to consider buoyancy
        }
        else if(i==domain_cellnumber-1)
        {
            mass_fr = cell[i].u*cell[i].mixture.Density*dy_co;
            A0 = (*deta_x);
            B1 = (cell[i].mixture.Kinetic_Viscosity_Coeff*cell[i-1].size+dy_co*cell[i-1].mixture.Kinetic_Viscosity_Coeff)/pow((cell[i-1].size+dy_co),2);
            B2 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[0].mixture.Kinetic_Viscosity_Coeff)/(dy_co+dy_co)/2.0;
            B0 = B1+B2;
            a[i] = -A0*B1;
            b[i] = mass_fr+A0*B0;
            b[i] += source[i].mass;  // to add the mass source term
            c[i] = 0.0;
            r[i] = A0*B1*cell[i-1].u+(mass_fr-A0*B0)*cell[i].u+2*A0*B2*cell[0].u;  //ghost point for cell[0]
            r[i] += source[i].mom_u;
            r[i] += (cell[1].mixture.Density-cell[i].mixture.Density)*gravity_ac*(*deta_x)*dy_co;  // to consider buoyancy
        }
        else
        {
            mass_fr = cell[i].u*cell[i].mixture.Density*cell[i].size;
            A0 = (*deta_x);
            B1 = B2;            
//            B1 = 2*(cell[i].mixture.Kinetic_Viscosity_Coeff*(i==1?dy_co:cell[i-1].size)+cell[i-1].mixture.Kinetic_Viscosity_Coeff*cell[i].size)/pow(((i==1?dy_co:cell[i-1].size)+cell[i].size),2);
            B2 = (cell[i].mixture.Kinetic_Viscosity_Coeff*(i==domain_cellnumber-2?dy_co:cell[i+1].size_old)+cell[i+1].mixture.Kinetic_Viscosity_Coeff*cell[i].size_old)/pow(((i==domain_cellnumber-2?dy_co:cell[i+1].size_old)+cell[i].size_old),2);
            B0 = B1+B2;
            a[i] = -A0*B1;
            b[i] = mass_fr+A0*B0;
            b[i] += source[i].mass;
            c[i] = -A0*B2;
            r[i] = A0*B1*cell[i-1].u_old+(mass_fr-A0*B0)*cell[i].u_old+A0*B2*cell[i+1].u_old;
            r[i] += source[i].mom_u;  //to consider the momentum source
            r[i] += (cell[1].mixture.Density-cell[i].mixture.Density)*gravity_ac*(*deta_x)*cell[i].size;  // to consider buoyancy
        }
    }

    //to calculate the candidate cell velocity on (n+1)th odt line
    TRIDIAG(a,b,c,r,u,domain_cellnumber);

    //to calculate the candidate cell size
    for(i=0; i<domain_cellnumber; i++)
    {
        cell_new[i].size = (cell[i].size_old*cell[i].u_old*cell[i].Density_old+source[i].mass)/(u[i]*cell[i].Density_old);

        if(!(u[i]>=0 && u[i]<=300))
        {
            *Visc_Flag = 0;
            
            printf("%dth step! error occurs during 1st circulation for viscous diffusion process!(*deta_x)=%8.5e\n",E_S_number,(*deta_x));
            //            i1 = 10;
            printf("%d, %8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5e\n",i,cell[i].mixture.Density,cell[i].size,cell[i].u,u[i],source[i].mom_u);
            for(i1=(i-20<0?0:i-20); i1<(i+20>domain_cellnumber-1?domain_cellnumber-1:i+20); i1++)
                printf("%d, %8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5e\n",i1,cell[i1].mixture.Density,cell[i1].size,cell[i1].u,u[i1],source[i1].mom_u);
            i1 = domain_cellnumber-10;
            printf("%d, %8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5e\n",i1,cell[i1].mixture.Density,cell[i1].size,cell[i1].u,u[i1],source[i1].mom_u);
            printf("cell[%d].u=%8.5f,cell[%d].u=%8.5f,cell[%d].u=%8.5f,u[%d]=%8.5f,u[%d]=%8.5f,u[%d]=%8.5e\n",i,cell[i].u,i-1,cell[i-1].u,i+1,cell[i+1].u,i,u[i],i-1,u[i-1],i+1,u[i+1]);
            printf("cell[0].u=%8.5f,cell[end].u=%8.5f\n",cell[0].u,cell[domain_cellnumber].u);

            // to modify the diffusion step
            MODIFY_DIFFDX(deta_x, cell[i].u, u[i]);
            goto abnormal2;
        }
    }

    //solve the diffusion problem by 2nd C-N method.
    for(i=0; i<domain_cellnumber; i++)
    {
        if(i==0)
        {
            mass_fr = cell[i].u*cell[i].mixture.Density*dy_co;
            A0 = (*deta_x);
            B1 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[domain_cellnumber-1].mixture.Kinetic_Viscosity_Coeff)/(dy_co+dy_co)/2.0;
            B2 = (cell[i].mixture.Kinetic_Viscosity_Coeff*cell[i+1].size+cell[i+1].mixture.Kinetic_Viscosity_Coeff*dy_co)/pow((dy_co+cell[i+1].size),2);
            B0 = B1+B2;
            B1_1 = (cell_new[i].mixture.Kinetic_Viscosity_Coeff+cell_new[domain_cellnumber-1].mixture.Kinetic_Viscosity_Coeff)/(dy_co+dy_co)/2.0;
            B2_1 = (cell_new[i].mixture.Kinetic_Viscosity_Coeff*cell_new[i+1].size+cell_new[i+1].mixture.Kinetic_Viscosity_Coeff*dy_co)/pow((dy_co+cell_new[i+1].size),2);
            B0_1 = B1_1+B2_1;
            a[i] = 0.0;
            b[i] = mass_fr+A0*B0_1;
            b[i] += source[i].mass;
            c[i] = -A0*B2_1;
            r[i] = 2*A0*B1*cell[domain_cellnumber-1].u+(mass_fr-A0*B0)*cell[i].u+A0*B2*cell[i+1].u; //ghost point for cell[domain_cellnumber-1]
            r[i] += source[i].mom_u;
            r[i] += (cell[1].mixture.Density-(cell[i].mixture.Density+cell_new[i].mixture.Density)/2)*gravity_ac*(*deta_x)*dy_co;  // to consider buoyancy
        }
        else if(i==domain_cellnumber-1)
        {
            mass_fr = cell[i].u*cell[i].mixture.Density*dy_co;
            A0 = (*deta_x);
            B1 = (cell[i].mixture.Kinetic_Viscosity_Coeff*cell[i-1].size+dy_co*cell[i-1].mixture.Kinetic_Viscosity_Coeff)/pow((cell[i-1].size+dy_co),2);
            B2 = (cell[i].mixture.Kinetic_Viscosity_Coeff+cell[0].mixture.Kinetic_Viscosity_Coeff)/(dy_co+dy_co)/2.0;
            B0 = B1+B2;
            B1_1 = (cell_new[i].mixture.Kinetic_Viscosity_Coeff*cell_new[i-1].size+dy_co*cell_new[i-1].mixture.Kinetic_Viscosity_Coeff)/pow((cell_new[i-1].size+dy_co),2);
            B2_1 = (cell_new[i].mixture.Kinetic_Viscosity_Coeff+cell_new[0].mixture.Kinetic_Viscosity_Coeff)/(dy_co+dy_co)/2.0;
            B0_1 = B1_1+B2_1;
            a[i] = -A0*B1_1;
            b[i] = mass_fr+A0*B0_1;
            b[i] += source[i].mass;
            c[i] = 0.0;
            r[i] = A0*B1*cell[i-1].u+(mass_fr-A0*B0)*cell[i].u+2*A0*B2*cell[0].u;  //ghost point for cell[0]
            r[i] += source[i].mom_u;
            r[i] += (cell[1].mixture.Density-(cell[i].mixture.Density+cell_new[i].mixture.Density)/2)*gravity_ac*(*deta_x)*dy_co;  // to consider buoyancy
        }
        else
        {
            mass_fr = cell[i].u*cell[i].mixture.Density*cell[i].size;
            A0 = (*deta_x);
            B1 = B2;
            //            B1 = 2*(cell[i].mixture.Kinetic_Viscosity_Coeff*(i==1?dy_co:cell[i-1].size)+cell[i-1].mixture.Kinetic_Viscosity_Coeff*cell[i].size)/pow(((i==1?dy_co:cell[i-1].size)+cell[i].size),2);
            B2 = (cell[i].mixture.Kinetic_Viscosity_Coeff*(i==domain_cellnumber-2?dy_co:cell[i+1].size_old)+cell[i+1].mixture.Kinetic_Viscosity_Coeff*cell[i].size_old)/pow(((i==domain_cellnumber-2?dy_co:cell[i+1].size_old)+cell[i].size_old),2);
            B0 = B1+B2;
            B1_1 = B2_1;
            //            B1_1 = 2*(cell_new[i].mixture.Kinetic_Viscosity_Coeff*(i==1?dy_co:cell_new[i-1].size)+cell_new[i-1].mixture.Kinetic_Viscosity_Coeff*cell_new[i].size)/pow(((i==1?dy_co:cell_new[i-1].size)+cell_new[i].size),2);
            B2_1 = (cell_new[i].mixture.Kinetic_Viscosity_Coeff*(i==domain_cellnumber-2?dy_co:cell_new[i+1].size)+cell_new[i+1].mixture.Kinetic_Viscosity_Coeff*cell_new[i].size)/pow(((i==domain_cellnumber-2?dy_co:cell_new[i+1].size)+cell_new[i].size),2);
            B0_1 = B1_1+B2_1;
            a[i] = -A0*B1_1;
            b[i] = mass_fr+A0*B0_1;
            b[i] += source[i].mass;
            c[i] = -A0*B2_1;
            r[i] = A0*B1*cell[i-1].u+(mass_fr-A0*B0)*cell[i].u+A0*B2*cell[i+1].u;
            r[i] += source[i].mom_u;
            r[i] += (cell[1].mixture.Density-(cell[i].mixture.Density+cell_new[i].mixture.Density)/2)*(cell[i].size+cell_new[i].size)*gravity_ac*(*deta_x)/2.0;  // to consider buoyancy
        }
    }

    //to calculate the candidate cell velocity on (n+1)th odt line
    TRIDIAG(a,b,c,r,u,domain_cellnumber);

    for(i=0; i<domain_cellnumber; i++)
    {
        cell_new[i].u = u[i];
        // to renew the cell size according to conservation of mass flow rate
        cell_new[i].size = (cell[i].size_old*cell[i].u_old*cell[i].Density_old+source[i].mass)/(cell_new[i].u*cell_new[i].mixture.Density);

        if (!(cell_new[i].u>0 && cell_new[i].u<300))
        {
            *Visc_Flag = 0;


            //  printf("%dth step: error occurs during diffusion process!cell number: %d\t,velo:%8.5f\n",E_S_number,i,cell_new[i].u);
            //printf("%d\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",E_S_number,cell[i].u,i==domain_cellnumber-1?cell[0].u:cell[i+1].u,i==0?cell[domain_cellnumber-1].u:cell[i-1].u,cell[i].size,i==domain_cellnumber-1?cell[0].size:cell[i+1].size,i==0?cell[domain_cellnumber-1].size:cell[i-1].size);
            //printf("%d\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",E_S_number,u[i],u[i+1],u[i-1],cell_new[i].size,cell_new[i+1].size,cell_new[i-1].size);
            //printf("%8.5f\t%8.5f\t%8.5f\n",cell[i].mixture.Density,cell[i+1].mixture.Density,cell[i-1].mixture.Density);

            printf("%dth step! error occurs during 2nd circulation for viscous diffusion process!(*deta_x)=%8.5e\n",E_S_number,(*deta_x));
//            i1 = 10;
            printf("%d, %8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",i,cell[i].mixture.Density,cell[i].size,cell[i].u,u[i],source[i].mom_u);
            for(i1=(i-20<0?0:i-20); i1<(i+20>domain_cellnumber-1?domain_cellnumber-1:i+20); i1++)
                printf("%d, %8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",i1,cell[i1].mixture.Density,cell[i1].size,cell[i1].u,u[i1],source[i1].mom_u);
            i1 = domain_cellnumber-10;
            printf("%d, %8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",i1,cell[i1].mixture.Density,cell[i1].size,cell[i1].u,u[i1],source[i1].mom_u);          
            printf("cell[%d].u=%8.5f,cell[%d].u=%8.5f,cell[%d].u=%8.5f,u[%d]=%8.5f,u[%d]=%8.5f,u[%d]=%8.5f\n",i,cell[i].u,i-1,cell[i-1].u,i+1,cell[i+1].u,i,u[i],i-1,u[i-1],i+1,u[i+1]);
            printf("cell[0].u=%8.5f,cell[end].u=%8.5f\n",cell[0].u,cell[domain_cellnumber].u);

            // to modify the diffusion step
            MODIFY_DIFFDX(deta_x, cell[i].u, cell_new[i].u);

            goto abnormal2;
        }
    }
    for(i=0; i<domain_cellnumber; i++)
    {
        //        cell_new[i].u_old = cell[i].u_old;
        //        cell_new[i].size_old = cell[i].size_old;      // to save the origional cell size at the beginning of E_S_numberth step,this .size_old will be useding in species diffusion process!!!, see in species_diffusion.cpp for details.
        cell[i] = cell_new[i];
    }
 abnormal2:    ;
}


void MODIFY_DIFFDX(double *deta_x, double u_old, double u_new)
{
    int newnumber, detanumber;
    newnumber = int((*deta_x+1e-10)/dx_stir);
    detanumber = int((dx_max+1e-10)/dx_stir);
    if(u_new<0)
        newnumber *= (u_old*3/(4*(u_old-u_new)));
    else if(u_new>300)
        newnumber *= (300-u_old)/(u_new-u_old);

    if(newnumber>int(detanumber*2/3))
        newnumber -= 5;
    else if(newnumber>(int(detanumber/2)))
        newnumber = int(detanumber/2);
    else if(newnumber>(int(detanumber/3)+1))
        newnumber = int(detanumber/3)+1;
    else if(newnumber>int(detanumber/4))
        newnumber = int(detanumber/4);
    *deta_x = newnumber*dx_stir;
    *deta_x = *deta_x>dx_min?(*deta_x):dx_min;
    if(*deta_x<0)
        printf("deta_x wierd in viscous diffusion!deta_x=%f\n",*deta_x);
}






// TO CALCULATE lateral velocity according to lagrangian parcel displacement 
// in this function, the displacement according to the triplet map are omitted
void CAL_VLATERAL_DISP(int E_S_number, int domain_cellnumber, double deta_x, struct cell_information *cell)
{
    int i;
    double T_massflux, T_momflux, Ave_u;

    for(i=0; i<domain_cellnumber; i++)
        cell[i].v_lateral = (cell[i].y-cell[i].y_old);

    // to calculate the final lateral velocity
    T_massflux = 0.0;
    T_momflux = 0.0;
    for(i=0; i<domain_cellnumber; i++)
    {
        T_massflux += (cell[i].size_old+cell[i].size)*(cell[i].u+cell[i].u_old)*(cell[i].Density_old+cell[i].mixture.Density)/8.0;
        T_momflux += (cell[i].size_old+cell[i].size)*(cell[i].u+cell[i].u_old)*(cell[i].u+cell[i].u_old)*(cell[i].Density_old+cell[i].mixture.Density)/16.0;
    }
    Ave_u = T_momflux/T_massflux;
    for(i=0; i<domain_cellnumber; i++)
        cell[i].v_lateral /= (deta_x/(0.5*cell[i].u));
        //        cell[i].v_lateral /= (deta_x/cell[i].u);

}
	








// to calculate lateral velocity according to continuous equation
// no use any more!!
void CAL_VLATERAL(int eddies, int eddynumber, int E_S_number, int domain_cellnumber, double deta_x, struct eddy_information *eddy, struct cell_information *cell, struct back_grid *backgrid_nd)
{
    int i,k;
    int bg_eddystart, bg_eddyend;
    int bgnumber;
    double eddy_bgnumber;
    double grid_u1,grid_mass1;
    double grid_u0,grid_mass0;
    double v_lat[int((domain_y+1e-10)/dy_bg)+1][2];      //  v_lat is the lateral velocity at the boundary of cells (not at the center point of the cell) 
    double v_eddy;  //eddy v velocity
    //  v_lat[i][0] is the old lateral velocity at the right boundary of ith cell
    //  v_lat[i][1] is the new lateral velocity at the right boundary of ith cell 

    bgnumber = int((domain_y+1e-10)/dy_bg);              //  bgnumber should be an even number

    v_lat[bgnumber/2][0] = 0.0;
    v_lat[bgnumber/2][1] = 0.0;

    // to initialize the initial vgas and Flag_eddy for uniform grid
    for(i=0; i<bgnumber; i++)
    {
        backgrid_nd[i].Flag_eddy = 0;
        backgrid_nd[i].vgas1 = 0.0;
        // printf("bg[%d].ugas1=%8.5f, bg[%d].ugas0=%8.5f\n",i,backgrid_nd[i].ugas1, i,backgrid_nd[i].ugas0);
    }

    if(eddies>0)  //eddies occur during E_S_numberth step
    {
        for(i=eddies-1; i>=0; i--)
        {
            bg_eddystart = (int)((eddy[eddynumber-1-i].ystart+domain_y/2)/dy_bg);
            bg_eddyend = (int)((eddy[eddynumber-1-i].yend+domain_y/2)/dy_bg);
            eddy_bgnumber = bg_eddyend-bg_eddystart;
            grid_u1 = 0.0;
            grid_mass1 = 0.0;
            grid_u0 = 0.0;
            grid_mass0 = 0.0;

            for(k=bg_eddystart; k<=bg_eddyend; k++)
            {
                backgrid_nd[k].Flag_eddy = 1;    // ith cell was occupied by an eddy

                grid_u1 += backgrid_nd[k].mass1*backgrid_nd[k].ugas1;
                grid_mass1 += backgrid_nd[k].mass1;
                grid_u0 += backgrid_nd[k].mass0*backgrid_nd[k].ugas0;
                grid_mass0 += backgrid_nd[k].mass0;
            }

            grid_u0 /= grid_mass0;  // to calculate the old average u velocity in this eddy
            grid_u1 /= grid_mass1;  // to calculate the new average u velocity in this eddy
           
            /*             printf("the difference is : %8.5f, eddy=%8.5f, u=%8.5f\n", grid_u1-eddy[eddynumber-1-i].u, grid_u1, eddy[eddynumber-1-i].u); */
            /*             printf("the difference is : %8.5f, eddy=%8.5f, u=%8.5f\n", grid_u1-grid_u0, grid_u1, grid_u0); */
            v_eddy = (fabs(grid_u1-grid_u0)>fabs(grid_u1-eddy[eddynumber-1-i].u))?((grid_u1-eddy[eddynumber-1-i].u)*dy_bg/deta_x/eddy_bgnumber/eddy_factor):((grid_u1-grid_u0)*dy_bg/deta_x/eddy_bgnumber/eddy_factor);
            

            //            printf("v_eddy = %8.5f, grid_u0=%8.5f, grid_u1=%8.5f, eddy_u=%8.5f\n", v_eddy,grid_u0, grid_u1, eddy[eddynumber-1-i].u);


            for(k=bg_eddystart; k<=bg_eddyend; k++)
            {
                backgrid_nd[k].vgas1 = v_eddy;
                
            }
        }
    }


    for(i=(int)(bgnumber/2-1); i>=0; i--)
    {

        if(backgrid_nd[i].Flag_eddy==1)
            v_lat[i][1] = v_lat[i+1][1]+backgrid_nd[i].vgas1;
        else
            v_lat[i][1] = (backgrid_nd[i].ugas1-backgrid_nd[i].ugas0)/deta_x*dy_bg+v_lat[i+1][1];

        /*          if(v_lat[i][1] >15.0) */
        /*              printf("too large! Flag=%d, v_lat[%d]=%8.5f,  bg1[%d]=%8.5f,  bg0[%d]=%8.5f,  bg_v[%d]=%8.5f\n", backgrid_nd[i].Flag_eddy, i, v_lat[i][1],i, backgrid_nd[i].ugas1, i, backgrid_nd[i].ugas0, i, backgrid_nd[i].vgas1); */
            
        
    }

    for(i=(int)(bgnumber/2+1); i<=bgnumber; i++)
    {
        /*         if(E_S_number==0)  // since at the first step, the old lateral velocity (boundary conditions) is 0 for each cell, the new lateral velocity is E_S_numberust calculated */
        /*         {         // by v[i]=(du/deta_x)*dy+v[i+1] */
        if(backgrid_nd[i].Flag_eddy==1)
            v_lat[i][1] = v_lat[i-1][1]-backgrid_nd[i].vgas1;
        else
            v_lat[i][1] = -(backgrid_nd[i-1].ugas1-backgrid_nd[i-1].ugas0)*dy_bg/deta_x+v_lat[i-1][1]; 
        /*         } */
        /*         else */
        /*         { */
        /*             if(backgrid_nd[i].Flag_eddy==1) */
        /*                 v_lat[i][1] = v_lat[i-1][1]-backgrid_nd[i].vgas1; */
        /*             else */
        /*             { */
        /* /\*                 v_lat[i][0] = 2*backgrid_nd[i-1].vgas-v_lat[i-1][0]; *\/ */
        /* /\*                 v_lat[i][1] = -(2*(backgrid_nd[i-1].ugas1-backgrid_nd[i-1].ugas)/deta_x-(v_lat[i-1][0]-v_lat[i][0])/dy_bg)*dy_bg+v_lat[i-1][1]; *\/ */
        /*                 v_lat[i][1] = -(backgrid_nd[i-1].ugas1-backgrid_nd[i-1].ugas0)/deta_x*dy_bg+v_lat[i-1][1]; */
        /*             } */
        /*         } */


        
        /*         if(v_lat[i][1] >15.0) */
        /*             printf("too large! Flag=%d, v_lat[%d]=%8.5f,  bg1[%d]=%8.5f,  bg0[%d]=%8.5f,  bg_v[%d]=%8.5f\n", backgrid_nd[i].Flag_eddy, i, v_lat[i][1], i, backgrid_nd[i].ugas1,i, backgrid_nd[i].ugas0, i,backgrid_nd[i].vgas1); */

    }

    //    printf("u[100]=%8.5f, u1[100]=%8.5f\n", backgrid_nd[100].ugas, backgrid_nd[100].ugas1);
    //    printf("v_lat[100]=%8.5f, v_lat[300]=%8.5f, v_lat[%d]=%8.5f, v_lat[%d]=%8.5f\n", v_lat[100][1],  v_lat[300][1], int(bgnumber/2)+50, v_lat[bgnumber/2+50][1], bgnumber-300, v_lat[bgnumber-300][1]);

    for(i=0; i<bgnumber; i++)  //to calculate the lateral velocity of ith cell
        backgrid_nd[i].vgas1 = (v_lat[i][1]+v_lat[i+1][1])/2;

    for(i=0; i<domain_cellnumber; i++)
    {
        cell[i].v_lateral = backgrid_nd[(int)((cell[i].y+domain_y/2)/dy_bg)].vgas1;

        /*        if(fabs(cell[i].v_lateral)>10) */
        /*            printf("v_lateral too large! y=%8.5f,   v=%8.5f,   u0=%8.5f,  u1=%8.5f\n", cell[i].y, cell[i].v_lateral, backgrid_nd[(int)((cell[i].y+domain_y/2)/dy_bg)].ugas0,  backgrid_nd[(int)((cell[i].y+domain_y/2)/dy_bg)].ugas1); */
    }
}




// according to continuty equation(no use anymore)
void CAL_VLATERAL1(int E_S_number, int domain_cellnumber, double deta_x, struct back_grid *backgrid_nd, struct cell_information *cell)
{
    int i,k;
    int bgnumber;
    double v_lat[int((domain_y+1e-10)/dy_bg)+1][2];      //  v_lat is the lateral velocity at the boundary of cells (not at the center point of the cell) 
    //  v_lat[i][0] is the old lateral velocity at the right boundary of ith cell
    //  v_lat[i][1] is the new lateral velocity at the right boundary of ith cell 
    bgnumber = int((domain_y+1e-10)/dy_bg);              //  bgnumber should be an even number

    v_lat[bgnumber/2][0] = 0.0;
    v_lat[bgnumber/2][1] = 0.0;


    for(i=(int)(bgnumber/2-1); i>=0; i--)
        v_lat[i][1] = (backgrid_nd[i].ugas1-backgrid_nd[i].ugas0)*dy_bg/deta_x+v_lat[i+1][1]; 

    for(i=(int)(bgnumber/2+1);i<=bgnumber; i++)
        v_lat[i][1] = -(backgrid_nd[i-1].ugas1-backgrid_nd[i-1].ugas0)/deta_x*dy_bg+v_lat[i-1][1];
    //    printf("u[100]=%8.5f, u1[100]=%8.5f\n", backgrid_nd[100].ugas, backgrid_nd[100].ugas1);
    //    printf("v_lat[100]=%8.5f, v_lat[300]=%8.5f, v_lat[%d]=%8.5f, v_lat[%d]=%8.5f\n", v_lat[100][1],  v_lat[300][1], int(bgnumber/2)+50, v_lat[bgnumber/2+50][1], bgnumber-300, v_lat[bgnumber-300][1]);

    for(i=0; i<bgnumber; i++)  //to calculate the lateral velocity of ith cell
        backgrid_nd[i].vgas1 = (v_lat[i][1]+v_lat[i+1][1])/2;

    for(i=0; i<domain_cellnumber; i++)
        cell[i].v_lateral = backgrid_nd[(int)((cell[i].y+domain_y/2)/dy_bg)].vgas1;
}










// to calculate the buoyancy source term for the momentum equation of the gas phase
double SOURCE_BUOYANCY(struct cell_information cell, double deta_x)
{
    int i;
    double source_buoyancy;
    source_buoyancy = 0.0;
    return(source_buoyancy);
}






// TO calculate the maximum diffusion step according to Fourier conditio
double CALCU_DIFFDX_MAX(int domain_cellnumber, struct cell_information *cell)
{
    int i,j;
    double coeff_min;
    double diff_dx, diff_dxmin;
    double diffdx_max;
    diffdx_max = dx_max;  //to initialize the diffusion step
    diff_dxmin = 1;
    for(i=5; i<domain_cellnumber-5; i++)
    {
        coeff_min = cell[i].mixture.Kinetic_Viscosity_Coeff;
        coeff_min = coeff_min<cell[i].mixture.Spe_Diff_Coeff_mix*cell[i].mixture.Density?coeff_min:cell[i].mixture.Spe_Diff_Coeff_mix*cell[i].mixture.Density;
        coeff_min = coeff_min<cell[i].mixture.Conduction_Coeff/cell[i].mixture.Heat_Capacity?coeff_min:cell[i].mixture.Conduction_Coeff/cell[i].mixture.Heat_Capacity;
        diff_dx = cell[i].u*cell[i].mixture.Density*cell[i].size*cell[i].size_old/2.5/coeff_min;
        j = diffdx_max<diff_dx?j:i;
        diffdx_max = diffdx_max<diff_dx?diffdx_max:diff_dx;
        diff_dxmin = diff_dxmin<diff_dx?diff_dxmin:diff_dx;
    }
    diffdx_max *= 2.5;  //for C-N scheme only
    diffdx_max = diffdx_max>dx_max?dx_max:diffdx_max;
    diffdx_max = diffdx_max<dx_min?dx_min:diffdx_max;
    //    printf("diffdx_max=%e, j=%d, diff_dxmin=%f\n", diffdx_max,j, diff_dxmin);
    return(diffdx_max);
}






//this function is used to check the mass conservation of the flow, it is only used to debug the code!
void CHECK_CONVERSATION(int domain_cellnumber, struct cell_information *cell, struct source_information *source, char *step)
{
    double O2_mf, CO2_mf, S_mass_mf, S_O2_mf, S_CO2_mf, mfrr;
    int i, Centercell;

    // to check the conservation
    Centercell = int(domain_cellnumber/2);
    O2_mf=0.0;
    CO2_mf = 0.0;
    S_mass_mf = 0.0;
    S_O2_mf = 0.0;
    S_CO2_mf = 0.0;
    mfrr = 0.0;
    for(i=Centercell-1350; i<Centercell+1349; i++)
    {
        mfrr += cell[i].u*cell[i].size*cell[i].mixture.Density;
        O2_mf += cell[i].u*cell[i].size*cell[i].mixture.Massfr[O2]*cell[i].mixture.Density;
        CO2_mf += cell[i].u*cell[i].size*cell[i].mixture.Massfr[CO2]*cell[i].mixture.Density;
        S_mass_mf += source[i].mass;
        S_O2_mf += source[i].massflux_species[O2];
        S_CO2_mf += source[i].massflux_species[CO2];
    }
    printf("%s!cn=%d, O2_mf=%f, CO2_mf=%f, S_mass=%e, S_O2_mf=%e, S_CO2_mf=%e, mfr=%f, mfr_old=%f\n", step, Centercell, O2_mf, CO2_mf, S_mass_mf, S_O2_mf, S_CO2_mf, mfrr, mfrr-S_mass_mf);
}




// to convert in i to char string
void my_itoa(int i, char string[])
{
    int power, j,k,s;
    j = i;
    k = i;
    for(power=1; j>=10; j/=10)
        power *=10;
    for(s=0; power>0; power /=10)
    {
        string[s] = '0'+k/power;
        s++;
        k %= power;
    }
    string[s]='\0';
}
