#include "header.h"

// this function is used to sample odt data to build the relationship between instant particle moments with flow field
void PRINT_ALEX(int E_S_number, int domain_cellnumber, double *grid_y, struct cell_information *cell_info, struct back_grid *backgrid_nd, struct source_information *source, FILE *ALEX_INDEP, FILE *ALEX_DEP)
{
    int i,k,k_bg;
    int kp;


    k = 0;
    k_bg = 0;
    for(i=0; i<domain_cellnumber; i++)
    {

        if(grid_y[i]<=(k*dy_co*record_ystep-domain_y/2+dy_co/2) && grid_y[i+1]>(k*dy_co*record_ystep-domain_y/2+dy_co/2))
        {
            k_bg = (grid_y[i]+domain_y/2+dy_co/2)/dy_bg;

            if(backgrid_nd[k_bg].y>-0.1 && backgrid_nd[k_bg].y<0.1 && backgrid_nd[k_bg].par_numberdensity[3]>0)
            {
                // to printf velocity information(1-7)
                fprintf(ALEX_INDEP, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t", E_S_number*dx_stir, k*dy_co*record_ystep-domain_y/2+dy_co/2, cell_info[i].u, cell_info[i].v_lateral+cell_info[i].v_trip);
                
                for(kp=0; kp<5; kp++)
                    fprintf(ALEX_INDEP, "%8.5e\t", cell_info[i].mixture.MixtureFr_Coal[kp]);
                
                // numberdensity(7-10)
                fprintf(ALEX_INDEP, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t", backgrid_nd[k_bg].par_numberdensity[0],backgrid_nd[k_bg].par_numberdensity[1],backgrid_nd[k_bg].par_numberdensity[2],backgrid_nd[k_bg].par_numberdensity[3]);
                
                // particle diameter and 01, 02, 03rd moment, d10, d32 (11-15)
                fprintf(ALEX_INDEP, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", backgrid_nd[k_bg].par_size, backgrid_nd[k_bg].par_surface, backgrid_nd[k_bg].par_volume, backgrid_nd[k_bg].par_d10,backgrid_nd[k_bg].par_d32);
                
                //to print mixture information (17.18)
                fprintf(ALEX_DEP, "%8.5f\t%8.5f\t", cell_info[i].mixture.Tem, cell_info[i].mixture.Density);
                //to print source term (19-22)
                fprintf(ALEX_DEP, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t", source[i].mass, source[i].mom_u, source[i].mom_v, source[i].enthalpy);
                // to print species source term (23-29)
                fprintf(ALEX_DEP, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t",source[i].massflux_species[N2],source[i].massflux_species[C2H2],source[i].massflux_species[CO],source[i].massflux_species[CO2],source[i].massflux_species[H2],source[i].massflux_species[H2O],source[i].massflux_species[O2]);
                
                //to print species information (30-39)
                fprintf(ALEX_DEP, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5f\t%8.5e\t%8.5f\t%8.5e\t%8.5f\t%8.5e\t",cell_info[i].mixture.Molefr[N2],cell_info[i].mixture.Molefr[C2H2],cell_info[i].mixture.Molefr[CH4],cell_info[i].mixture.Molefr[CO],cell_info[i].mixture.Molefr[CO2],cell_info[i].mixture.Molefr[H2],cell_info[i].mixture.Molefr[H2O],cell_info[i].mixture.Molefr[NO],cell_info[i].mixture.Molefr[O2],cell_info[i].mixture.Molefr[OH]);
                //(50-54) mixture fraction
                
                fprintf(ALEX_DEP, "\n");
                fprintf(ALEX_INDEP, "\n");
                
            }
            
            k++;
            // when a cell size is larger than dy!
            if(grid_y[i+1]>(k*dy_co*record_ystep-domain_y/2+dy_co/2))
                i--;
        }
    } 



}











// this function is used to print data and to do the main postprocess work
void PRINT_VELOCITY(int E_S_number, int domain_cellnumber, double *grid_y, struct cell_information *cell_info, struct back_grid *backgrid_nd, struct source_information *source, FILE *Velocity_gas, FILE *Velocity_particle)
{
    int i,k,k_bg;
    int kp;

/*     if(stirnumber == 0) */
/*     { */
/*         /\* to generate a file which record velocity at each 10 x developed step *\/ */
/*         // to write the header of the data file which should be read through Tecplot. */
/*         fprintf(Velocity_gas," TITLE = \"the value of gas phase after the first realization\"\n"); */
/*         fprintf(Velocity_gas, " VARIABLES =X\ny\nvel_u\nvel_vlateral\nvel_vtrip\nvel_w\nv_gas1\ndensity\nmassfr_air\nmolefr_air\n"); */
/*         fprintf(Velocity_gas, "ZONE I=%d E_S_NUMBER=%d", domain_y/dy_co/record_ystep, xstep_number/record_xstep+1); */
/*         fprintf(Velocity_gas, "\n\n"); */

/*  /       fprintf(Velocity_particle, " TITLE = \"the value of particle phase after the first realization\"\n"); */
/*         fprintf(Velocity_particle, " VARIABLES =1.X\n2.y\n\ */
/* 3.par_massflux(kg/sm2)\n4.par_massflux_10(kg/sm2)\n5.par_massflux_70(kg/sm2)\n6.par_massflux_130(kg/sm2)\n\ */
/* 7.par_numberdenstiy(#/m3)\n8.par_numberdensity_10\n9.par_numberdensity_70\n10.par_numberdensity_130\n\ */
/* 11.par_size(m/m3)\n12.par_surface(m2/m3)\n13.par_volume(m3/m3)\n14.par_d10\n15.par_d32\n\ */
/* 16.par_Rep\n17.par_Rep_10\n18.par_Rep_70\n19.par_Rep_130\n\ */
/* 20.par_up\n21.par_up_10\n22.par_up_70\n23.par_up_130\n24.par_vp\n25.par_vp_10\n26.par_vp70\n27.par_vp_130\n\ */
/* 28.par_0thdifcoe[Par_SN-1]\n29.par_1stdifcoe\n 30.par_2nddifcoe\n 31.par_3rddifcoe\n\ */
/* 32.par_0thdifcoe[0]\n, 33.par_0thdifcoe[1]\n, 34. par_0thdifcoe[2]\n\ */
/* 35.Mom_u,\n 36.Mom_v,\n 37.Mov_w.\n"); */
/*         fprintf(Velocity_particle, "ZONE I=%d E_S_NUMBER=%d", (int)(domain_y/dy_co/record_ystep), (int)(xstep_number/record_xstep+1)); */
/*         fprintf(Velocity_particle, "\n\n"); */
/*     } */


    k = 0;
    k_bg = 0;
    for(i=0; i<domain_cellnumber; i++)
    {
        if(grid_y[i]<=(k*dy_co*record_ystep-domain_y/2+dy_co/2) && grid_y[i+1]>(k*dy_co*record_ystep-domain_y/2+dy_co/2))
        {
            // to printf velocity information(1-7)
            fprintf(Velocity_gas,"%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t",(E_S_number)*dx_stir, k*dy_co*record_ystep-domain_y/2+dy_co/2, cell_info[i].u,cell_info[i].v_lateral, cell_info[i].v_trip, cell_info[i].w, backgrid_nd[(int)((cell_info[i].y+domain_y/2)/dy_bg)].vgas1);
            // to print eddy/turbulenct information(8-11)
            fprintf(Velocity_gas, "%d\t%d\t%d\t%d\t", cell_info[i].eddystate, cell_info[i].eddystate_instant, cell_info[i].eddynumber, cell_info[i].abseddynumber); 
            //to print mixture fraction(12-16)
//             for(kp=0; kp<5; kp++)
//                 fprintf(Velocity_gas, "%8.5e\t", cell_info[i].mixture.Mixture_Fraction[kp]);
            //to print mixture information (17.18)
            fprintf(Velocity_gas, "%8.5f\t%8.5f\t", cell_info[i].mixture.Tem, cell_info[i].mixture.Density);
            //to print source term (19-22)
            fprintf(Velocity_gas, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t", source[i].mass, source[i].mom_u, source[i].mom_v, source[i].enthalpy);
            // to print species source term (23-29)
            fprintf(Velocity_gas, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t",source[i].massflux_species[N2],source[i].massflux_species[C2H2],source[i].massflux_species[CO],source[i].massflux_species[CO2],source[i].massflux_species[H2],source[i].massflux_species[H2O],source[i].massflux_species[O2]);
            //to print species information (30-39)
            fprintf(Velocity_gas, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5f\t%8.5e\t%8.5f\t%8.5e\t%8.5f\t%8.5e\t",cell_info[i].mixture.Massfr[N2],cell_info[i].mixture.Massfr[C2H2],cell_info[i].mixture.Massfr[CH4],cell_info[i].mixture.Massfr[CO],cell_info[i].mixture.Massfr[CO2],cell_info[i].mixture.Massfr[H2],cell_info[i].mixture.Massfr[H2O],cell_info[i].mixture.Massfr[NO],cell_info[i].mixture.Massfr[O2],cell_info[i].mixture.Massfr[OH]);
            //(40-49)
            fprintf(Velocity_gas, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5f\t%8.5e\t%8.5f\t%8.5e\t%8.5f\t%8.5e\t",cell_info[i].mixture.Molefr[N2],cell_info[i].mixture.Molefr[C2H2],cell_info[i].mixture.Molefr[CH4],cell_info[i].mixture.Molefr[CO],cell_info[i].mixture.Molefr[CO2],cell_info[i].mixture.Molefr[H2],cell_info[i].mixture.Molefr[H2O],cell_info[i].mixture.Molefr[NO],cell_info[i].mixture.Molefr[O2],cell_info[i].mixture.Molefr[OH]);
            //(50-54) mixture fraction
            for(kp=0; kp<5; kp++)
                fprintf(Velocity_gas, "%8.5e\t", cell_info[i].mixture.MixtureFr_Coal[kp]);
            // (55-57) source term of mixture fraction
            for(kp=0; kp<3; kp++)
                fprintf(Velocity_gas, "%8.5e\t", source[i].mixture_fr[kp]/cell_info[i].size);

            fprintf(Velocity_gas, "\n");
            
            k++;
            // when a cell size is larger than dy!
            if(grid_y[i+1]>(k*dy_co*record_ystep-domain_y/2+dy_co/2))
                i--;
        }
    } 
    k = 0;
    for(i=0; i<(int)((domain_y+1e-10)/dy_bg); i++)
    {
        if(backgrid_nd[i].y-dy_bg/2<=(k*dy_co*record_ystep-domain_y/2+dy_co/2) && backgrid_nd[i].y+dy_bg/2>(k*dy_co*record_ystep-domain_y/2+dy_co/2))
        {
            // coordinate (1-2)
            fprintf(Velocity_particle, "%8.5f\t%8.5f\t",  (E_S_number)*dx_stir, k*dy_co*record_ystep-domain_y/2+dy_co/2);
            // massflux (3-6)
            fprintf(Velocity_particle, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t", backgrid_nd[i].par_massflux[0], backgrid_nd[i].par_massflux[1], backgrid_nd[i].par_massflux[2], backgrid_nd[i].par_massflux[3]);
            // numberdensity(7-10)
            fprintf(Velocity_particle, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t", backgrid_nd[i].par_numberdensity[0],backgrid_nd[i].par_numberdensity[1],backgrid_nd[i].par_numberdensity[2],backgrid_nd[i].par_numberdensity[3]);
            // particle diameter and 01, 02, 03rd moment, d10, d32 (11-15)
            fprintf(Velocity_particle, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", backgrid_nd[i].par_size, backgrid_nd[i].par_surface, backgrid_nd[i].par_volume, backgrid_nd[i].par_d10,backgrid_nd[i].par_d32);
            // Reynolds number(16-19)
            fprintf(Velocity_particle, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t", backgrid_nd[i].par_Re[0], backgrid_nd[i].par_Re[1], backgrid_nd[i].par_Re[2], backgrid_nd[i].par_Re[3]);
            // particle axial velocity (20-23)
            fprintf(Velocity_particle, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t", backgrid_nd[i].par_u[0], backgrid_nd[i].par_u[1], backgrid_nd[i].par_u[2], backgrid_nd[i].par_u[3]);
            // particle lateral velocity (24-27)
            fprintf(Velocity_particle, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t", backgrid_nd[i].par_v[0], backgrid_nd[i].par_v[1], backgrid_nd[i].par_v[2], backgrid_nd[i].par_v[3]);
            //particle temperature (28-31)
            fprintf(Velocity_particle, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t", backgrid_nd[i].Tem[0], backgrid_nd[i].Tem[1], backgrid_nd[i].Tem[2], backgrid_nd[i].Tem[3]);
            //particle mass_total(32-35)
            fprintf(Velocity_particle, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t", backgrid_nd[i].Mass_P[4][0], backgrid_nd[i].Mass_P[4][1], backgrid_nd[i].Mass_P[4][2], backgrid_nd[i].Mass_P[4][3]);
            //particle mass_volatile(36-39)
            fprintf(Velocity_particle, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t", backgrid_nd[i].Mass_P[1][0], backgrid_nd[i].Mass_P[1][1], backgrid_nd[i].Mass_P[1][2], backgrid_nd[i].Mass_P[1][3]);
            //particle mass_carbon(40-43)
            fprintf(Velocity_particle, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t", backgrid_nd[i].Mass_P[2][0], backgrid_nd[i].Mass_P[2][1], backgrid_nd[i].Mass_P[2][2], backgrid_nd[i].Mass_P[2][3]);
            // particle density(44-47)
            fprintf(Velocity_particle, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t", backgrid_nd[i].density[0], backgrid_nd[i].density[1], backgrid_nd[i].density[2], backgrid_nd[i].density[3]);
            fprintf(Velocity_particle, "\n");
            k++;
            // when a cell size is larger than dy!
            if(backgrid_nd[i].y+dy_bg/2>(k*dy_co*record_ystep-domain_y/2+dy_co/2))
                i--;
        }
    }
}









// to record the sumation value at selected point based on ODT grid (non-uniform grid cell size)
void RECORD_AVE(int E_S_number, int domain_cellnumber, int *avenumber, double *grid_y, struct cell_information *cell_info, struct back_grid *backgrid_nd, struct cell_average cell_ave[][ysample_number], struct source_information *source)
{
    int i,k,k_spe,bg_number,kp;
    int ave_rec_step;
    int i_mfr;

    ave_rec_step = int(E_S_number/record_xstep);
    //    printf("ave_rec_step=%d\n", ave_rec_step);

    k=0;
    for(i=0; i<domain_cellnumber; i++)
    {
        if(grid_y[i]<=cell_ave[ave_rec_step][k].y && grid_y[i+1]>cell_ave[ave_rec_step][k].y)
        {
            cell_ave[ave_rec_step][k].u += cell_info[i].u;
            cell_ave[ave_rec_step][k].v_trip += cell_info[i].v_trip;
            cell_ave[ave_rec_step][k].v_lateral += cell_info[i].v_lateral;
            cell_ave[ave_rec_step][k].w += cell_info[i].w;
            
            //to restore the thermal variables of the mixture 
            cell_ave[ave_rec_step][k].mixture.Density += cell_info[i].mixture.Density;
            for(i_mfr=0; i_mfr<5; i_mfr++)
            {
                cell_ave[ave_rec_step][k].mixture.Mixture_Fraction[i_mfr] += cell_info[i].mixture.Mixture_Fraction[i_mfr];
                cell_ave[ave_rec_step][k].mixture.Mixture_Fraction_Var[i_mfr] += pow(cell_info[i].mixture.Mixture_Fraction[i_mfr],2);
                cell_ave[ave_rec_step][k].mixture.MixtureFr_Coal[i_mfr] += cell_info[i].mixture.MixtureFr_Coal[i_mfr];
                cell_ave[ave_rec_step][k].mixture.MixtureFr_Coal_Var[i_mfr] += pow(cell_info[i].mixture.MixtureFr_Coal[i_mfr],2);
            }
            cell_ave[ave_rec_step][k].mixture.Mole_Number_Flowrate += cell_info[i].mixture.Mole_Number_Flowrate;
            cell_ave[ave_rec_step][k].mixture.Mole_Number_Flux += cell_info[i].mixture.Mole_Number_Flux;
            cell_ave[ave_rec_step][k].mixture.Mass_Flowrate += cell_info[i].mixture.Mass_Flowrate;
            cell_ave[ave_rec_step][k].mixture.Mass_Flux += cell_info[i].mixture.Mass_Flux;
            cell_ave[ave_rec_step][k].mixture.Tem += cell_info[i].mixture.Tem;
            cell_ave[ave_rec_step][k].mixture.Molecular_Weight += cell_info[i].mixture.Molecular_Weight;
            cell_ave[ave_rec_step][k].mixture.Enthalpy += cell_info[i].mixture.Enthalpy;
            cell_ave[ave_rec_step][k].mixture.Entropy += cell_info[i].mixture.Entropy;
            cell_ave[ave_rec_step][k].mixture.Gibbs_Energy += cell_info[i].mixture.Gibbs_Energy;
            
            for(k_spe=0; k_spe<Species_Number; k_spe++)
            {
                cell_ave[ave_rec_step][k].mixture.Molefr[k_spe] += cell_info[i].mixture.Molefr[k_spe];
                cell_ave[ave_rec_step][k].mixture.Massfr[k_spe] += cell_info[i].mixture.Massfr[k_spe];
                cell_ave[ave_rec_step][k].massfr_rms[k_spe] += cell_info[i].mixture.Massfr[k_spe]*cell_info[i].mixture.Massfr[k_spe];
            }
            
            //  // .par_32 is determined by .surface and .volume! 	
            // 				if(cell_ave[ave_rec_step][k].particle.par_number!=0)
            // 					cell_ave[ave_rec_step][k].particle.par_d32 += backgrid_nd[i].par_volume*6/backgrid_nd[i].par_surface;
            // to record turbulent information during total realizations
            cell_ave[ave_rec_step][k].eddy_density += cell_info[i].eddystate;
            cell_ave[ave_rec_step][k].eddy_density_instant += cell_info[i].eddystate_instant;
            cell_ave[ave_rec_step][k].uu += cell_info[i].u*cell_info[i].u;
            //deta_u = u'u'-uu, u' means u velocity before triplet map, u' means u velocity after triplet map
            //cell_ave[ave_rec_step][k].deta_u += cell_info[i].u*cell_info[i].u;
            
            //	cell_ave[ave_rec_step][k].uv += cell_info[i].u*cell_info[i].v;
            cell_ave[ave_rec_step][k].vv += (cell_info[i].v_trip+v_latcoe*cell_info[i].v_lateral)*(cell_info[i].v_trip+v_latcoe*cell_info[i].v_lateral);
            
            cell_ave[ave_rec_step][k].ww += cell_info[i].w*cell_info[i].w;
            
            //to record source terms of particles during total realizations
            cell_ave[ave_rec_step][k].source.mass += source[i].mass;
            cell_ave[ave_rec_step][k].source.mom_u += source[i].mom_u;
            cell_ave[ave_rec_step][k].source.mom_v += source[i].mom_v;
            cell_ave[ave_rec_step][k].source.mom_w += source[i].mom_w;
            cell_ave[ave_rec_step][k].source.enthalpy += source[i].enthalpy;
            cell_ave[ave_rec_step][k].source.Enth_h += source[i].Enth_h;
            for(k_spe=0; k_spe<Species_Number; k_spe++)
                cell_ave[ave_rec_step][k].source.massflux_species[k_spe] += source[i].massflux_species[k_spe];
            for(k_spe=0; k_spe<3; k_spe++)
                cell_ave[ave_rec_step][k].source.mixture_fr[k_spe] += source[i].mixture_fr[k_spe];
            
            k++;
            // when a cell size is larger than dy!
            if(grid_y[i+1]>cell_ave[ave_rec_step][k].y)
                i--;
        }
    }

    
    k = 0;
    i = 0;
    // to calculate k so that meet the initial record requirment
    while(backgrid_nd[i].y-dy_bg/2.0>cell_ave[ave_rec_step][k].y)
        k++;

    for(i=0; i<(int)((domain_y+1e-10)/dy_bg); i++)
    {
        if(backgrid_nd[i].y-dy_bg/2.0<=cell_ave[ave_rec_step][k].y+1e-15 && backgrid_nd[i].y+dy_bg/2>cell_ave[ave_rec_step][k].y)
        {
            //            printf("important! k=%d,y=%f\n", k, cell_ave[ave_rec_step][k].y);
            for(kp=0; kp<Par_SN; kp++)
            {
                //.par_number means particle tracks in this cell, it has relation ship with cell size
                cell_ave[ave_rec_step][k].particle.par_number[kp] += backgrid_nd[i].par_number[kp];
                
                //the following variables has nothing to do with cell size.						
                cell_ave[ave_rec_step][k].particle.par_numberdensity[kp] += backgrid_nd[i].par_numberdensity[kp];
                cell_ave[ave_rec_step][k].particle.par_massflux[kp] += backgrid_nd[i].par_massflux[kp];
                
                //the average Re, up and vp should not consider the realizations that there r no particles appears in this cell
                cell_ave[ave_rec_step][k].particle.par_Re[kp] += backgrid_nd[i].par_Re[kp]*backgrid_nd[i].par_massflux[kp];
                cell_ave[ave_rec_step][k].particle.par_u[kp] += backgrid_nd[i].par_u[kp]*backgrid_nd[i].par_massflux[kp];
                cell_ave[ave_rec_step][k].particle.par_v[kp] += backgrid_nd[i].par_v[kp]*backgrid_nd[i].par_massflux[kp];
                
                cell_ave[ave_rec_step][k].particle.Tem[kp] += backgrid_nd[i].Tem[kp]*backgrid_nd[i].par_massflux[kp];
                cell_ave[ave_rec_step][k].particle.Mass_P[0][kp] += backgrid_nd[i].Mass_P[0][kp]*backgrid_nd[i].par_massflux[kp];
                cell_ave[ave_rec_step][k].particle.Mass_P[1][kp] += backgrid_nd[i].Mass_P[1][kp]*backgrid_nd[i].par_massflux[kp];
                cell_ave[ave_rec_step][k].particle.Mass_P[2][kp] += backgrid_nd[i].Mass_P[2][kp]*backgrid_nd[i].par_massflux[kp];
                cell_ave[ave_rec_step][k].particle.Mass_P[3][kp] += backgrid_nd[i].Mass_P[3][kp]*backgrid_nd[i].par_massflux[kp];
                cell_ave[ave_rec_step][k].particle.Mass_P[4][kp] += backgrid_nd[i].Mass_P[4][kp]*backgrid_nd[i].par_massflux[kp];
                cell_ave[ave_rec_step][k].particle.density[kp] += backgrid_nd[i].density[kp]*backgrid_nd[i].par_massflux[kp];
                
                //0th momentum flux of particle phase
                cell_ave[ave_rec_step][k].particle.par_nd0th_new[kp] += backgrid_nd[i].par_nd0th_new[kp];
                cell_ave[ave_rec_step][k].particle.par_nd0th_old[kp] += backgrid_nd[i].par_nd0th_old[kp];
                }
            
            //the summation of d10*mass_flux
            cell_ave[ave_rec_step][k].particle.par_d10 += backgrid_nd[i].par_d10*backgrid_nd[i].par_massflux[Par_SN-1];
            
            
            //1st/2nd/3rd momentum flux of particle phase, the .par_ndnth_new is the average value during this step
            cell_ave[ave_rec_step][k].particle.par_nd1st_new += backgrid_nd[i].par_nd1st_new;
            cell_ave[ave_rec_step][k].particle.par_nd2nd_new += backgrid_nd[i].par_nd2nd_new;
            cell_ave[ave_rec_step][k].particle.par_nd3rd_new += backgrid_nd[i].par_nd3rd_new;
            cell_ave[ave_rec_step][k].particle.par_nd1st_old += backgrid_nd[i].par_nd1st_old;
            cell_ave[ave_rec_step][k].particle.par_nd2nd_old += backgrid_nd[i].par_nd2nd_old;
            cell_ave[ave_rec_step][k].particle.par_nd3rd_old += backgrid_nd[i].par_nd3rd_old;
            
            
            // 1st order, 2nd order and 3rd order moments of particles							
            cell_ave[ave_rec_step][k].particle.par_size += backgrid_nd[i].par_size;
            cell_ave[ave_rec_step][k].particle.par_surface += backgrid_nd[i].par_surface;
            cell_ave[ave_rec_step][k].particle.par_volume += backgrid_nd[i].par_volume;
            
            for(kp=0; kp<Par_SN; kp++)
            {
                
                if(backgrid_nd[i].par_0thdiffcoe[kp] != 0)
                {
                    cell_ave[ave_rec_step][k].particle.par_0thdiffcoe[kp] += backgrid_nd[i].par_0thdiffcoe[kp];
                    cell_ave[ave_rec_step][k].par_nd0thcoe_number[kp]++;
                }
            }
            
            if(backgrid_nd[i].par_1stdiffcoe != 0)
            {
                cell_ave[ave_rec_step][k].particle.par_1stdiffcoe += backgrid_nd[i].par_1stdiffcoe;
                cell_ave[ave_rec_step][k].par_nd1stcoe_number++;
            }
            
            if(backgrid_nd[i].par_2nddiffcoe != 0)
            {
                cell_ave[ave_rec_step][k].particle.par_2nddiffcoe += backgrid_nd[i].par_2nddiffcoe;
                cell_ave[ave_rec_step][k].par_nd2ndcoe_number++;
            }
            
            if(backgrid_nd[i].par_3rddiffcoe != 0)
            {
                cell_ave[ave_rec_step][k].particle.par_3rddiffcoe += backgrid_nd[i].par_3rddiffcoe;
                cell_ave[ave_rec_step][k].par_nd3rdcoe_number++;
            }
            
            k++;
            // when a cell size is larger than dy!
            if(backgrid_nd[i].y+dy_bg/2>cell_ave[ave_rec_step][k].y)
                i--;
        }
    }
    
    
    /*         k = 0; */
    /*         for(i=0; i<bg_number; i++) */
    /*         { */
    /*             if((backgrid_nd[i].y-dy_bg/2)<=cell_ave[ave_rec_step][k].y && (backgrid_nd[i].y+dy_bg/2)>cell_ave[ave_rec_step][k].y) */
    /*             { */
    /*                 cell_ave[ave_rec_step][k].v_lateral += backgrid_nd[i].vgas1; */
    
    /*                 k++; */
    /*                 if((backgrid_nd[i].y+dy_bg/2)>cell_ave[ave_rec_step][k].y) */
    /*                     i--; */
    /*             } */
    /*         } */
    //    printf("ave_par=%f\n", cell_ave[ave_rec_step][ysample_number/2].particle.par_number[3]);
    avenumber[ave_rec_step]++;
    
}









//this function is used to calculate the final average number for each selected point
void CALCULATE_AVE(int i, int j, int size, int *avenumber, struct cell_average cell_ave[][ysample_number])
{
    int k,i_mfr;
    int k_spe;

    cell_ave[j][i].x /= size;   //size is used in parallel computing, for non-parallel, size=1.
    cell_ave[j][i].y /= size;

    cell_ave[j][i].u /= avenumber[j];
    cell_ave[j][i].v_trip /= avenumber[j];
    cell_ave[j][i].v_lateral /= avenumber[j];
    cell_ave[j][i].w /= avenumber[j];

    // to calculate average variables of the mixture
    cell_ave[j][i].mixture.Density /= avenumber[j];
    for(i_mfr=0; i_mfr<5; i_mfr++)
    {
        cell_ave[j][i].mixture.Mixture_Fraction[i_mfr] /= avenumber[j];
        cell_ave[j][i].mixture.Mixture_Fraction_Var[i_mfr] /= avenumber[j];
        cell_ave[j][i].mixture.Mixture_Fraction_Var[i_mfr] -= pow(cell_ave[j][i].mixture.Mixture_Fraction[i_mfr],2);    //F_var = <F^2>-<F>^2

        cell_ave[j][i].mixture.MixtureFr_Coal[i_mfr] /= avenumber[j];
        cell_ave[j][i].mixture.MixtureFr_Coal_Var[i_mfr] /= avenumber[j];
        cell_ave[j][i].mixture.MixtureFr_Coal_Var[i_mfr] -= pow(cell_ave[j][i].mixture.MixtureFr_Coal[i_mfr],2);    //F_var = <F^2>-<F>^2
    }
    cell_ave[j][i].mixture.Mole_Number_Flowrate /= avenumber[j];
    cell_ave[j][i].mixture.Mole_Number_Flux /= avenumber[j];
    cell_ave[j][i].mixture.Mass_Flowrate /= avenumber[j];
    cell_ave[j][i].mixture.Mass_Flux /= avenumber[j];
    cell_ave[j][i].mixture.Tem /= avenumber[j];
    cell_ave[j][i].mixture.Molecular_Weight /= avenumber[j];
    cell_ave[j][i].mixture.Enthalpy /= avenumber[j];
    cell_ave[j][i].mixture.Entropy /= avenumber[j];
    cell_ave[j][i].mixture.Gibbs_Energy /= avenumber[j];
    for(k=0; k<Species_Number; k++)
    {
        cell_ave[j][i].mixture.Molefr[k] /= avenumber[j];
        cell_ave[j][i].mixture.Massfr[k] /= avenumber[j];
        cell_ave[j][i].massfr_rms[k] /= avenumber[j];
        cell_ave[j][i].massfr_rms[k] -= pow(cell_ave[j][i].mixture.Molefr[k],2);  //the square of rms
    }

    // to calculate particle d10 and d32
    cell_ave[j][i].particle.par_d10 /= cell_ave[j][i].particle.par_massflux[Par_SN-1];
    cell_ave[j][i].particle.par_d32 = cell_ave[j][i].particle.par_volume*6/cell_ave[j][i].particle.par_surface;

    //the following values only consider those realizations which particles can be found in that cell
    for(k=0; k<Par_SN; k++)
    {
        //to calculate the average particle Ryenolds number, u/v velocity
        if(cell_ave[j][i].particle.par_number[k]>0.0)
        {
            cell_ave[j][i].particle.par_Re[k] /= cell_ave[j][i].particle.par_massflux[k];
            cell_ave[j][i].particle.par_u[k] /= cell_ave[j][i].particle.par_massflux[k];
            cell_ave[j][i].particle.par_v[k] /= cell_ave[j][i].particle.par_massflux[k];
            cell_ave[j][i].particle.Tem[k] /= cell_ave[j][i].particle.par_massflux[k];
            cell_ave[j][i].particle.Mass_P[0][k] /= cell_ave[j][i].particle.par_massflux[k];
            cell_ave[j][i].particle.Mass_P[1][k] /= cell_ave[j][i].particle.par_massflux[k];
            cell_ave[j][i].particle.Mass_P[2][k] /= cell_ave[j][i].particle.par_massflux[k];
            cell_ave[j][i].particle.Mass_P[3][k] /= cell_ave[j][i].particle.par_massflux[k];
            cell_ave[j][i].particle.Mass_P[4][k] /= cell_ave[j][i].particle.par_massflux[k];
            cell_ave[j][i].particle.density[k] /= cell_ave[j][i].particle.par_massflux[k];
        }
        //to calculate the average diffusion coefficient of 0th moment of all particle size
        if(cell_ave[j][i].par_nd0thcoe_number[k]>0)
            cell_ave[j][i].particle.par_0thdiffcoe[k] /= cell_ave[j][i].par_nd0thcoe_number[k];
    }

    //to calculate the average diffusion coefficient of 1st moment of the whelm particle
    if(cell_ave[j][i].par_nd1stcoe_number>0)
        cell_ave[j][i].particle.par_1stdiffcoe /= cell_ave[j][i].par_nd1stcoe_number;

    //to calculate the average diffusion coefficient of 1st moment of the whelm particle
    if(cell_ave[j][i].par_nd2ndcoe_number>0)
        cell_ave[j][i].particle.par_2nddiffcoe /= cell_ave[j][i].par_nd2ndcoe_number;

    //to calculate the average diffusion coefficient of 1st moment of the whelm particle
    if(cell_ave[j][i].par_nd3rdcoe_number>0)
        cell_ave[j][i].particle.par_3rddiffcoe /= cell_ave[j][i].par_nd3rdcoe_number;

     //the following values consider all realizations
    for(k=0; k<Par_SN; k++)
    {
        cell_ave[j][i].particle.par_number[k] /= avenumber[j];
        cell_ave[j][i].particle.par_massflux[k] /= avenumber[j];
        cell_ave[j][i].particle.par_numberdensity[k] /= avenumber[j];
    }

    cell_ave[j][i].particle.par_size /= avenumber[j];
    cell_ave[j][i].particle.par_surface /= avenumber[j];
    cell_ave[j][i].particle.par_volume /= avenumber[j];
    cell_ave[j][i].source.mass /= avenumber[j];
    cell_ave[j][i].source.mom_u /= avenumber[j];
    cell_ave[j][i].source.mom_v /= avenumber[j];
    cell_ave[j][i].source.mom_w /= avenumber[j];
    for(k_spe=0; k_spe<Species_Number; k_spe++)
        cell_ave[j][i].source.massflux_species[k_spe] /= avenumber[j];
    for(k_spe=0; k_spe<3; k_spe++)
        cell_ave[j][i].source.mixture_fr[k_spe] /= avenumber[j];

    cell_ave[j][i].eddy_density /= avenumber[j];
    cell_ave[j][i].eddy_density_instant /= avenumber[j];
    cell_ave[j][i].eddy_density_instant *= 100;
    cell_ave[j][i].uu /= avenumber[j];
    cell_ave[j][i].deta_u /= avenumber[j];
    //cell_ave[j][i].deta_u /= dx;
    cell_ave[j][i].vv /= avenumber[j];
    cell_ave[j][i].ww /= avenumber[j];
    cell_ave[j][i].uu -= cell_ave[j][i].u*cell_ave[j][i].u;  // <u'u'>=<uu>-<u_ave*u_ave>
    cell_ave[j][i].vv -= (cell_ave[j][i].v_trip+v_latcoe*cell_ave[j][i].v_lateral)*(cell_ave[j][i].v_trip+v_latcoe*cell_ave[j][i].v_lateral);
    cell_ave[j][i].ww -= cell_ave[j][i].w*cell_ave[j][i].w;
}








// to calculate axis average value and to print average value into the file
void PRINT_AVE(int *avenumber,struct cell_average cell_ave[][ysample_number])
{
    int i,j,k,i_mfr,kp;
    double center_uu, mini;
    // cell size of average cell
    double dy_ave;
    // v lateral velocity at the grid point of average cells
    double ave_vp[ysample_number+1];
    double d2;  //2nd derivation of moments

    struct axis_average axis_ave[xstep_number/record_xstep+1];

    FILE *Ave_Axis;

    FILE *Average_Gas, *Average_Particle,*Average_Nondimension;

    FILE *DEPENDENT, *INDEPENDENT;

    //cell size of the average cell
    dy_ave = ysample_width_ratio*jet_width_OP/ysample_number;

    //to calculate v velocity according to the average u velocity
    for(j=1; j<=xstep_number/record_xstep; j++)
    {
        ave_vp[ysample_number/2] = 0.0;
        for(i=ysample_number/2-1; i>=0; i--)
            ave_vp[i] = (cell_ave[j][i].u-cell_ave[j-1][i].u)*dy_ave/(dx_stir*record_xstep)+ave_vp[i+1];
        for(i=ysample_number/2+1; i<=ysample_number; i++)
            ave_vp[i] = -(cell_ave[j][i-1].u-cell_ave[j-1][i-1].u)*dy_ave/(dx_stir*record_xstep)+ave_vp[i-1];
        for(i=0; i<ysample_number; i++)
            cell_ave[j][i].v_ave = (ave_vp[i]+ave_vp[i+1])/2.0;
    }


    //to calculate particle moment diffusion coefficient based on the average value
    for(j=1; j<xstep_number/record_xstep; j++)
    {
        for(i=1; i<ysample_number-1; i++)
        {
            for(k=0; k<Par_SN-1; k++)
            {
                d2 = (cell_ave[j][i+1].particle.par_numberdensity[k]-2*cell_ave[j][i].particle.par_numberdensity[k]+cell_ave[j][i-1].particle.par_numberdensity[k])/pow(dy_ave,2);
                if(d2 != 0)
                    cell_ave[j][i].par_0thdiffcoe[k] = (cell_ave[j][i].particle.par_nd0th_new[k]-cell_ave[j][i].particle.par_nd0th_old[k])/d2;
                else
                    cell_ave[j][i].par_0thdiffcoe[k] = 0.0;
            }

            d2 = (cell_ave[j][i+1].particle.par_size-2*cell_ave[j][i].particle.par_size+cell_ave[j][i-1].particle.par_size)/pow(dy_ave,2);
            if(d2 != 0)
                cell_ave[j][i].par_1stdiffcoe = (cell_ave[j][i].particle.par_nd1st_new-cell_ave[j][i].particle.par_nd1st_old)/d2;
            else
                cell_ave[j][i].par_1stdiffcoe = 0.0;

            d2 = (cell_ave[j][i+1].particle.par_surface-2*cell_ave[j][i].particle.par_surface+cell_ave[j][i-1].particle.par_surface)/pow(dy_ave,2);
            if(d2 != 0)
                cell_ave[j][i].par_2nddiffcoe = (cell_ave[j][i].particle.par_nd2nd_new-cell_ave[j][i].particle.par_nd2nd_old)/d2;
            else
                cell_ave[j][i].par_2nddiffcoe = 0.0;

            d2 = (cell_ave[j][i+1].particle.par_volume-2*cell_ave[j][i].particle.par_volume+cell_ave[j][i-1].particle.par_volume)/pow(dy_ave,2);
            if(d2 != 0)
                cell_ave[j][i].par_3rddiffcoe = (cell_ave[j][i].particle.par_nd3rd_new-cell_ave[j][i].particle.par_nd3rd_old)/d2;
            else
                cell_ave[j][i].par_3rddiffcoe = 0.0;
        }
    }


    // to record average scalar for gas flow field
    if((Average_Gas = fopen("ave_gas.txt","a"))==NULL)
    {	printf("cannot open this file.\n");		exit(0);	}
    
    //to record average scalar for particles
    if((Average_Particle = fopen("ave_particle.txt","a"))==NULL)
    {	printf("cannot open this file.\n");		exit(0);	}
    
    //to record average scalar for particles
    if((Average_Nondimension = fopen("ave_nondim.txt","a"))==NULL)
    {	printf("cannot open this file.\n");		exit(0);	}

    /* to generate a file which records the average scalar on axis*/
    if((Ave_Axis=fopen("axis_value.txt","a"))==NULL)
    {	printf("cannot open this file.\n");		exit(0);	}

    /* to generate a file which records the average scalar on axis*/
    if((INDEPENDENT=fopen("Independent.txt","a"))==NULL)
    {	printf("cannot open this file.\n");		exit(0);	}

    /* to generate a file which records the average scalar on axis*/
    if((DEPENDENT=fopen("Dependent.txt","a"))==NULL)
    {	printf("cannot open this file.\n");		exit(0);	}


    // to calculate Reynold_uv stress
    for(j=0; j<=xstep_number/record_xstep; j++)
    {
        center_uu = pow((cell_ave[j][ysample_number/2-1].u+cell_ave[j][ysample_number/2].u)/2,2);
        // to calculate Reynold stress uv according to eq.()
        cell_ave[j][ysample_number-1].uv = 0.0;
        cell_ave[j][0].uv = 0.0;
        for(i=1;i<ysample_number/2;i++)
            cell_ave[j][i].uv = cell_ave[j][i-1].uv + cell_ave[j][i].deta_u*ysample_width_ratio*jet_width_OP/ysample_number;
        for(i=ysample_number-2; i>=ysample_number/2; i--)
            cell_ave[j][i].uv = cell_ave[j][i+1].uv + cell_ave[j][i].deta_u*ysample_width_ratio*jet_width_OP/ysample_number;
    }

    // to calculate average value on axis
    for(j=0; j<=xstep_number/record_xstep; j++)
    {
        axis_ave[j].u = (cell_ave[j][ysample_number/2-1].u+cell_ave[j][ysample_number/2].u)/2;
        axis_ave[j].v_trip = (cell_ave[j][ysample_number/2-1].v_trip+cell_ave[j][ysample_number/2].v_trip)/2;
        axis_ave[j].v_lateral = (cell_ave[j][ysample_number/2-1].v_lateral+cell_ave[j][ysample_number/2].v_lateral)/2;
        axis_ave[j].Restress[0] = (cell_ave[j][ysample_number/2-1].uu+cell_ave[j][ysample_number/2].uu)/2.0/(axis_ave[j].u*axis_ave[j].u);
        axis_ave[j].Restress[1] = (cell_ave[j][ysample_number/2-1].vv+cell_ave[j][ysample_number/2].vv)/2.0/(axis_ave[j].u*axis_ave[j].u);
        axis_ave[j].Restress[2] = (cell_ave[j][ysample_number/2-1].ww+cell_ave[j][ysample_number/2].ww)/2.0/(axis_ave[j].u*axis_ave[j].u);
        axis_ave[j].Restress[3] = (cell_ave[j][ysample_number/2-1].uv+cell_ave[j][ysample_number/2].uv)/2.0/(axis_ave[j].u*axis_ave[j].u);

        //to calculate variable of mixture
        axis_ave[j].mixture.Density = (cell_ave[j][ysample_number/2-1].mixture.Density+cell_ave[j][ysample_number/2].mixture.Density)/2.0;
        axis_ave[j].mixture.Tem = (cell_ave[j][ysample_number/2-1].mixture.Tem+cell_ave[j][ysample_number/2].mixture.Tem)/2.0;
        for(i_mfr=0; i_mfr<5; i_mfr++)
        {
            axis_ave[j].mixture.Mixture_Fraction[i_mfr] = (cell_ave[j][ysample_number/2-1].mixture.Mixture_Fraction[i_mfr]+cell_ave[j][ysample_number/2].mixture.Mixture_Fraction[i_mfr])/2;
            axis_ave[j].mixture.Mixture_Fraction_Var[i_mfr] = (cell_ave[j][ysample_number/2-1].mixture.Mixture_Fraction_Var[i_mfr]+cell_ave[j][ysample_number/2].mixture.Mixture_Fraction_Var[i_mfr])/2;
            axis_ave[j].mixture.MixtureFr_Coal[i_mfr] = (cell_ave[j][ysample_number/2-1].mixture.MixtureFr_Coal[i_mfr]+cell_ave[j][ysample_number/2].mixture.MixtureFr_Coal[i_mfr])/2;
            axis_ave[j].mixture.MixtureFr_Coal_Var[i_mfr] = (cell_ave[j][ysample_number/2-1].mixture.MixtureFr_Coal_Var[i_mfr]+cell_ave[j][ysample_number/2].mixture.MixtureFr_Coal_Var[i_mfr])/2;
        }
        axis_ave[j].mixture.Mole_Number_Flowrate = (cell_ave[j][ysample_number/2-1].mixture.Mole_Number_Flowrate+cell_ave[j][ysample_number/2].mixture.Mole_Number_Flowrate)/2;
        axis_ave[j].mixture.Mole_Number_Flux = (cell_ave[j][ysample_number/2-1].mixture.Mole_Number_Flux+cell_ave[j][ysample_number/2].mixture.Mole_Number_Flux)/2;
        axis_ave[j].mixture.Mass_Flowrate = (cell_ave[j][ysample_number/2-1].mixture.Mass_Flowrate+cell_ave[j][ysample_number/2].mixture.Mass_Flowrate)/2;
        axis_ave[j].mixture.Mass_Flux = (cell_ave[j][ysample_number/2-1].mixture.Mass_Flux+cell_ave[j][ysample_number/2].mixture.Mass_Flux)/2;
        axis_ave[j].mixture.Tem = (cell_ave[j][ysample_number/2-1].mixture.Tem+cell_ave[j][ysample_number/2].mixture.Tem)/2;
        axis_ave[j].mixture.Molecular_Weight = (cell_ave[j][ysample_number/2-1].mixture.Molecular_Weight+cell_ave[j][ysample_number/2].mixture.Molecular_Weight)/2;
        axis_ave[j].mixture.Enthalpy = (cell_ave[j][ysample_number/2-1].mixture.Enthalpy+cell_ave[j][ysample_number/2].mixture.Enthalpy)/2;
        axis_ave[j].mixture.Entropy = (cell_ave[j][ysample_number/2-1].mixture.Entropy+cell_ave[j][ysample_number/2].mixture.Entropy)/2;
        axis_ave[j].mixture.Gibbs_Energy = (cell_ave[j][ysample_number/2-1].mixture.Gibbs_Energy+cell_ave[j][ysample_number/2].mixture.Gibbs_Energy)/2;
        for(k=0; k<Species_Number; k++)
        {
            axis_ave[j].mixture.Molefr[k] = (cell_ave[j][ysample_number/2-1].mixture.Molefr[k]+cell_ave[j][ysample_number/2].mixture.Molefr[k])/2;
            axis_ave[j].mixture.Massfr[k] = (cell_ave[j][ysample_number/2-1].mixture.Massfr[k]+cell_ave[j][ysample_number/2].mixture.Massfr[k])/2;
        }

        axis_ave[j].x = cell_ave[j][ysample_number/2-1].x;

        for(k=0; k<Par_SN; k++)
        {
            axis_ave[j].par_ndaxis[k] = (cell_ave[j][ysample_number/2-1].particle.par_numberdensity[k]+cell_ave[j][ysample_number/2].particle.par_numberdensity[k])/2;
            axis_ave[j].par_Tem[k] = (cell_ave[j][ysample_number/2-1].particle.Tem[k]+cell_ave[j][ysample_number/2].particle.Tem[k])/2;
            axis_ave[j].par_density[k] = (cell_ave[j][ysample_number/2-1].particle.density[k]+cell_ave[j][ysample_number/2].particle.density[k])/2;

            axis_ave[j].par_ndmax[k] = 0.0;
        }

        axis_ave[j].eddy_den_axis = (cell_ave[j][ysample_number/2-1].eddy_density+cell_ave[j][ysample_number/2].eddy_density)/2;
        axis_ave[j].eddy_den_max = 0.0;
        axis_ave[j].eddy_instden_max = 0.0;

        // to record the maximum value and its position of particle number density and eddy density
        for(i=0; i<ysample_number; i++)
        {
            for(k=0; k<Par_SN; k++)
            {
                if(cell_ave[j][i].particle.par_numberdensity[k] > axis_ave[j].par_ndmax[k])
                {
                    axis_ave[j].par_ndmax[k] = cell_ave[j][i].particle.par_numberdensity[k];
                    axis_ave[j].par_ndmax_y[k] = cell_ave[j][i].y;
                }
            }

            if(cell_ave[j][i].eddy_density>axis_ave[j].eddy_den_max)
            {
                axis_ave[j].eddy_den_max = cell_ave[j][i].eddy_density;
                axis_ave[j].eddy_den_max_y = cell_ave[j][i].y;
            }

            if(cell_ave[j][i].eddy_density_instant > axis_ave[j].eddy_instden_max)
            {
                axis_ave[j].eddy_instden_max = cell_ave[j][i].eddy_density_instant;
                axis_ave[j].eddy_instden_max_y = cell_ave[j][i].y;
            }
        }

        mini = 1.0;
        for(i=ysample_number/2+1; i<ysample_number-1; i++)
        {
            if(fabs((cell_ave[j][i].u-covelocity)-(axis_ave[j].u-covelocity)/2)/((axis_ave[j].u-covelocity)/2)<mini)
            {
                mini = fabs((cell_ave[j][i].u-covelocity)-(axis_ave[j].u-covelocity)/2)/((axis_ave[j].u-covelocity)/2);
                axis_ave[j].half_width_p = cell_ave[j][i].y;
            }
        }
		
        mini = 1.0;
        for(i=ysample_number/2-1; i>1; i--)
        {
            if(fabs((cell_ave[j][i].u-covelocity)-(axis_ave[j].u-covelocity)/2)/((axis_ave[j].u-covelocity)/2)<mini)
            {
                mini = fabs((cell_ave[j][i].u-covelocity)-(axis_ave[j].u-covelocity)/2)/((axis_ave[j].u-covelocity)/2);
                axis_ave[j].half_width_n = cell_ave[j][i].y;
            }
        }

        mini = 1.0;
        for(i=ysample_number/2+1; i<ysample_number-1; i++)
        {
            for(i_mfr=0; i_mfr<5; i_mfr++)
            {
                if(fabs(cell_ave[j][i].mixture.Mixture_Fraction[i_mfr]-axis_ave[j].mixture.Mixture_Fraction[i_mfr]/2)/(axis_ave[j].mixture.Mixture_Fraction[i_mfr]/2)<mini)
                {
                    mini = fabs(cell_ave[j][i].mixture.Mixture_Fraction[i_mfr]-axis_ave[j].mixture.Mixture_Fraction[i_mfr]/2)/(axis_ave[j].mixture.Mixture_Fraction[i_mfr]/2);
                    axis_ave[j].half_width_fp[i_mfr] = cell_ave[j][i].y;
                }
                if(fabs(cell_ave[j][i].mixture.MixtureFr_Coal[i_mfr]-axis_ave[j].mixture.MixtureFr_Coal[i_mfr]/2)/(axis_ave[j].mixture.MixtureFr_Coal[i_mfr]/2)<mini)
                {
                    mini = fabs(cell_ave[j][i].mixture.MixtureFr_Coal[i_mfr]-axis_ave[j].mixture.MixtureFr_Coal[i_mfr]/2)/(axis_ave[j].mixture.MixtureFr_Coal[i_mfr]/2);
                    axis_ave[j].half_width_fmrp[i_mfr] = cell_ave[j][i].y;
                }
            }
        }
		
        mini = 1.0;
        for(i=ysample_number/2-1; i>1; i--)
        {
            for(i_mfr=0; i_mfr<5; i_mfr++)
            {
                if(fabs(cell_ave[j][i].mixture.Mixture_Fraction[i_mfr]-axis_ave[j].mixture.Mixture_Fraction[i_mfr]/2)/(axis_ave[j].mixture.Mixture_Fraction[i_mfr]/2)<mini)
                {
                    mini = fabs(cell_ave[j][i].mixture.Mixture_Fraction[i_mfr]-axis_ave[j].mixture.Mixture_Fraction[i_mfr]/2)/(axis_ave[j].mixture.Mixture_Fraction[i_mfr]/2);
                    axis_ave[j].half_width_fn[i_mfr] = cell_ave[j][i].y;
                }
                if(fabs(cell_ave[j][i].mixture.MixtureFr_Coal[i_mfr]-axis_ave[j].mixture.MixtureFr_Coal[i_mfr]/2)/(axis_ave[j].mixture.MixtureFr_Coal[i_mfr]/2)<mini)
                {
                    mini = fabs(cell_ave[j][i].mixture.MixtureFr_Coal[i_mfr]-axis_ave[j].mixture.MixtureFr_Coal[i_mfr]/2)/(axis_ave[j].mixture.MixtureFr_Coal[i_mfr]/2);
                    axis_ave[j].half_width_fmrn[i_mfr] = cell_ave[j][i].y;
                }
            }
        }


        for(k=0; k<Par_SN; k++)
        {
            mini = 1.0;
            for(i=ysample_number/2+1; i<ysample_number-1; i++)
            {
                if(fabs(cell_ave[j][i].particle.par_numberdensity[k]-axis_ave[j].par_ndmax[k]/2)/(axis_ave[j].par_ndmax[k]/2)<mini)
                {
                    mini = fabs(cell_ave[j][i].particle.par_numberdensity[k]-axis_ave[j].par_ndmax[k]/2)/(axis_ave[j].par_ndmax[k]/2);
                    axis_ave[j].par_ndhalfmax_yp[k] = cell_ave[j][i].y;
                }
            }

            mini = 1.0;
            for(i=ysample_number/2-1; i>1; i--)
            {
                if(fabs(cell_ave[j][i].particle.par_numberdensity[k]-axis_ave[j].par_ndmax[k]/2)/(axis_ave[j].par_ndmax[k]/2)<mini)
                {
                    mini = fabs(cell_ave[j][i].particle.par_numberdensity[k]-axis_ave[j].par_ndmax[k]/2)/(axis_ave[j].par_ndmax[k]/2);
                    axis_ave[j].par_ndhalfmax_yn[k] = cell_ave[j][i].y;
                }
            }
        }
    }


//     //    fprintf(Average_Gas,"TITLE = \"the average value of gas flow field after %dth realization\"\n", REALI);
//     //     fprintf(Average_Gas,"VARIABLES = X\ny\nvel_u\nvel_vtrip\nvel_vlateral\nvel_vtotal\nvel_v_ave\nvel_w\neddy_dn\ndensity\n\
//         // Re_uu\nRe_uv\nRe_vv\nRe_ww\nMixture_Fraction\nTemperature\nMolecular_Weight\nEnthalpy\nMassfr[0..K]\nMolefr[0..k]");
//         //     fprintf(Average_Gas,"ZONE I=%d J=%d\n", ysample_number, xstep_number/record_xstep+1);
        
//         /*     fprintf(Average_Particle,"TITLE = \"the average value of particle phase after %dth realization\"\n", REALI); */
//         /*     fprintf(Average_Particle, " VARIABLES =1.x\n 2.y\n 3.par_number\n4.par_number_10\n5.par_number_70\n6.par_number_130\n\ */
//         /* 7.par_numberdensity\n8.par_numberdensity_10\n9.par_numberdensity_70\n10.par_numberdensity_130\n\ */
//         /* 11.par_massflux\n12.par_massflux_10\n13.par_massflux_70\n14.par_massflux_130\n\ */
//         /* 15.par_size\n16.par_surface\n17.par_volume\n18.par_d10\n19.par_d32\n\ */
//         /* 20.par_Rep\n21.par_Rep10\n22.par_Rep70\n23.par_Rep130\n\ */
//         /* 24.par_up\n25.par_up10\n26.par_up70\n27.par_up130\n\ */
//         /* 28.par_vp\n29.par_vp10\n30.par_vp70\n31.par_vp130\n\ */
//         /* 32.par_nd0thcoeff\n33.par_nd0thcoeff10\n34.par_nd0thcoeff70\n35.par_nd0thcoeff130\n\ */
//         /* 36.par_nd1stcoeff\n37.par_nd2ndcoeff\n38.par_nd3rdcoeff\n\ */
//         /* 39 par_nd0thcoeff_ave\n40par_nd0thcoeff10_ave\n41par_nd0thcoeff70_ave\n42par_nd0thcoeff130_ave\n */
//         /* 43 par_nd1stcoeff_ave\n44par_nd2ndcoeff_ave\n45par_nd3rdcoeff_ave\n */
//         /* 46 source_mom_u\n47.source_mom_v\n48.source_mom_w\n"); */
//         /*     fprintf(Average_Particle, "ZONE I=%d J=%d\n", ysample_number, xstep_number/record_xstep+1); */

    for(j=0; j<=xstep_number/record_xstep; j++)
    {
        center_uu = axis_ave[j].u*axis_ave[j].u;
        for(i=0; i<ysample_number; i++)
        {
            //coordinate and velocity(1-6)
            fprintf(Average_Gas,"%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t", cell_ave[j][i].x, cell_ave[j][i].y, cell_ave[j][i].u, cell_ave[j][i].v_trip, cell_ave[j][i].v_lateral, cell_ave[j][i].v_ave);
            // mixture information and mixture fraction(7-12)
            fprintf(Average_Gas, "%8.5f\t%8.5f\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].mixture.Tem,cell_ave[j][i].mixture.Density, cell_ave[j][i].mixture.Mixture_Fraction[0], cell_ave[j][i].mixture.Mixture_Fraction[1], cell_ave[j][i].mixture.Mixture_Fraction[4], cell_ave[j][i].mixture.Mixture_Fraction_Var[4]);
            // mixture fraction by transportequ(13-22)
            for(i_mfr=0; i_mfr<5; i_mfr++)
                fprintf(Average_Gas, "%8.5e\t", cell_ave[j][i].mixture.MixtureFr_Coal[i_mfr]);
            for(i_mfr=0; i_mfr<5; i_mfr++)
                fprintf(Average_Gas, "%8.5e\t", cell_ave[j][i].mixture.MixtureFr_Coal_Var[i_mfr]);
            //eddy information and turbulence information(23-28)
            fprintf(Average_Gas, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t", cell_ave[j][i].eddy_density, cell_ave[j][i].eddy_density_instant, cell_ave[j][i].uu/center_uu, cell_ave[j][i].uv/center_uu, cell_ave[j][i].vv/center_uu, cell_ave[j][i].ww/center_uu);
            //source term(29-33)
            fprintf(Average_Gas, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].source.mass, cell_ave[j][i].source.mom_u, cell_ave[j][i].source.mom_v, cell_ave[j][i].source.mom_w, cell_ave[j][i].source.enthalpy);  
            //(34-40)
            fprintf(Average_Gas, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].source.massflux_species[N2], cell_ave[j][i].source.massflux_species[C2H2], cell_ave[j][i].source.massflux_species[CH4], cell_ave[j][i].source.massflux_species[CO], cell_ave[j][i].source.massflux_species[CO2], cell_ave[j][i].source.massflux_species[H2],cell_ave[j][i].source.massflux_species[H2O]); 
            // source_Moisture, source_Vol, Source_char(41-43)
            fprintf(Average_Gas,"%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].source.mixture_fr[0], cell_ave[j][i].source.mixture_fr[1], cell_ave[j][i].source.mixture_fr[2]); 
            //species information and it RMS(44-53)
            fprintf(Average_Gas, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].mixture.Molefr[N2], cell_ave[j][i].mixture.Molefr[C2H2],cell_ave[j][i].mixture.Molefr[CH4],cell_ave[j][i].mixture.Molefr[CO],cell_ave[j][i].mixture.Molefr[CO2],cell_ave[j][i].mixture.Molefr[H2],cell_ave[j][i].mixture.Molefr[H2O],cell_ave[j][i].mixture.Molefr[NO],cell_ave[j][i].mixture.Molefr[O2],cell_ave[j][i].mixture.Molefr[OH]);
            // Massfr (54-63)
            fprintf(Average_Gas, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].mixture.Massfr[N2], cell_ave[j][i].mixture.Massfr[C2H2],cell_ave[j][i].mixture.Massfr[CH4],cell_ave[j][i].mixture.Massfr[CO],cell_ave[j][i].mixture.Massfr[CO2],cell_ave[j][i].mixture.Massfr[H2],cell_ave[j][i].mixture.Massfr[H2O],cell_ave[j][i].mixture.Massfr[NO],cell_ave[j][i].mixture.Massfr[O2],cell_ave[j][i].mixture.Massfr[OH]);
            // Massfr_var(64-73)
            fprintf(Average_Gas, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].massfr_rms[N2], cell_ave[j][i].massfr_rms[C2H2],cell_ave[j][i].massfr_rms[CH4],cell_ave[j][i].massfr_rms[CO],cell_ave[j][i].massfr_rms[CO2],cell_ave[j][i].massfr_rms[H2],cell_ave[j][i].massfr_rms[H2O],cell_ave[j][i].massfr_rms[NO],cell_ave[j][i].massfr_rms[O2],cell_ave[j][i].massfr_rms[OH]);

            fprintf(Average_Gas,"\n");


 //coordinate and velocity(1-6)
            fprintf(INDEPENDENT,"%8.5f\t%8.5f\t%8.5f\t%8.5f\t", cell_ave[j][i].x, cell_ave[j][i].y, cell_ave[j][i].u, cell_ave[j][i].v_trip+cell_ave[j][i].v_lateral);
            // mixture information and mixture fraction(7-12)
            fprintf(DEPENDENT, "%8.5f\t%8.5f\t", cell_ave[j][i].mixture.Tem,cell_ave[j][i].mixture.Density);

            // mixture fraction by transportequ(13-22)
            for(i_mfr=0; i_mfr<5; i_mfr++)
                fprintf(INDEPENDENT, "%8.5e\t", cell_ave[j][i].mixture.MixtureFr_Coal[i_mfr]);

            for(i_mfr=0; i_mfr<4; i_mfr++)
                fprintf(INDEPENDENT, "%8.5e\t", cell_ave[j][i].mixture.MixtureFr_Coal_Var[i_mfr]);
            i_mfr = 4;
            fprintf(INDEPENDENT, "%8.5e\n", cell_ave[j][i].mixture.MixtureFr_Coal_Var[i_mfr]);


            //eddy information and turbulence information(23-28)
            fprintf(DEPENDENT, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t", cell_ave[j][i].eddy_density, cell_ave[j][i].eddy_density_instant, cell_ave[j][i].uu/center_uu, cell_ave[j][i].uv/center_uu, cell_ave[j][i].vv/center_uu, cell_ave[j][i].ww/center_uu);

            //source term(29-33)
            fprintf(DEPENDENT, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].source.mass, cell_ave[j][i].source.mom_u, cell_ave[j][i].source.mom_v, cell_ave[j][i].source.mom_w, cell_ave[j][i].source.Enth_h);  
            //(34-40)
            fprintf(DEPENDENT, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].source.massflux_species[N2], cell_ave[j][i].source.massflux_species[C2H2], cell_ave[j][i].source.massflux_species[CH4], cell_ave[j][i].source.massflux_species[CO], cell_ave[j][i].source.massflux_species[CO2], cell_ave[j][i].source.massflux_species[H2],cell_ave[j][i].source.massflux_species[H2O]); 

            //species information and it RMS(44-53)
            fprintf(DEPENDENT, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].mixture.Molefr[N2], cell_ave[j][i].mixture.Molefr[C2H2],cell_ave[j][i].mixture.Molefr[CH4],cell_ave[j][i].mixture.Molefr[CO],cell_ave[j][i].mixture.Molefr[CO2],cell_ave[j][i].mixture.Molefr[H2],cell_ave[j][i].mixture.Molefr[H2O],cell_ave[j][i].mixture.Molefr[NO],cell_ave[j][i].mixture.Molefr[O2],cell_ave[j][i].mixture.Molefr[OH]);

            // Massfr (54-63)
            fprintf(DEPENDENT, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].mixture.Massfr[N2], cell_ave[j][i].mixture.Massfr[C2H2],cell_ave[j][i].mixture.Massfr[CH4],cell_ave[j][i].mixture.Massfr[CO],cell_ave[j][i].mixture.Massfr[CO2],cell_ave[j][i].mixture.Massfr[H2],cell_ave[j][i].mixture.Massfr[H2O],cell_ave[j][i].mixture.Massfr[NO],cell_ave[j][i].mixture.Massfr[O2],cell_ave[j][i].mixture.Massfr[OH]);

            // Massfr_var(64-73)
            fprintf(DEPENDENT, "%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\n", cell_ave[j][i].massfr_rms[N2], cell_ave[j][i].massfr_rms[C2H2],cell_ave[j][i].massfr_rms[CH4],cell_ave[j][i].massfr_rms[CO],cell_ave[j][i].massfr_rms[CO2],cell_ave[j][i].massfr_rms[H2],cell_ave[j][i].massfr_rms[H2O],cell_ave[j][i].massfr_rms[NO],cell_ave[j][i].massfr_rms[O2],cell_ave[j][i].massfr_rms[OH]);


            // to print file to store the average information of the particles
            // coordinate(1,2)
            fprintf(Average_Particle,"%8.5f\t%8.5f\t", cell_ave[j][i].x,cell_ave[j][i].y);
            // particle track number(3-6)
            fprintf(Average_Particle,"%8.5f\t%8.5f\t%8.5f\t%8.5f\t", cell_ave[j][i].particle.par_number[3], cell_ave[j][i].particle.par_number[0],cell_ave[j][i].particle.par_number[1],cell_ave[j][i].particle.par_number[2]);
            // particle number density(7-10)
            fprintf(Average_Particle,"%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].particle.par_numberdensity[3],cell_ave[j][i].particle.par_numberdensity[0],cell_ave[j][i].particle.par_numberdensity[1],cell_ave[j][i].particle.par_numberdensity[2]);
            // particle mass flux(11-14)
            fprintf(Average_Particle,"%8.5e\t%8.5e\t%8.5e\t%8.5e\t",cell_ave[j][i].particle.par_massflux[3],cell_ave[j][i].particle.par_massflux[0],cell_ave[j][i].particle.par_massflux[1],cell_ave[j][i].particle.par_massflux[2]);
            //particle size(m/m3), surface(m2/m3), volume(m3/m3), d10(m) and d32(m) (15-19)
            fprintf(Average_Particle,"%8.5e\t%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].particle.par_size,cell_ave[j][i].particle.par_surface,cell_ave[j][i].particle.par_volume,cell_ave[j][i].particle.par_d10,cell_ave[j][i].particle.par_d32);
            // particle reynolds number(20-23)
            fprintf(Average_Particle,"%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].particle.par_Re[Par_SN-1],cell_ave[j][i].particle.par_Re[0],cell_ave[j][i].particle.par_Re[1],cell_ave[j][i].particle.par_Re[2]);
            // particle velocity(24-27)
            fprintf(Average_Particle,"%8.5f\t%8.5f\t%8.5f\t%8.5f\t", cell_ave[j][i].particle.par_u[Par_SN-1],cell_ave[j][i].particle.par_u[0],cell_ave[j][i].particle.par_u[1],cell_ave[j][i].particle.par_u[2]);
            // particle v velocity(28-31)
            fprintf(Average_Particle,"%8.5f\t%8.5f\t%8.5f\t%8.5f\t", cell_ave[j][i].particle.par_v[Par_SN-1],cell_ave[j][i].particle.par_v[0],cell_ave[j][i].particle.par_v[1],cell_ave[j][i].particle.par_v[2]);
            // particle Tem(32-35)
            fprintf(Average_Particle,"%8.5f\t%8.5f\t%8.5f\t%8.5f\t", cell_ave[j][i].particle.Tem[Par_SN-1],cell_ave[j][i].particle.Tem[0],cell_ave[j][i].particle.Tem[1],cell_ave[j][i].particle.Tem[2]);
            // particle Mass_P(36-39)
            fprintf(Average_Particle,"%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].particle.Mass_P[0][Par_SN-1],cell_ave[j][i].particle.Mass_P[0][0],cell_ave[j][i].particle.Mass_P[0][1],cell_ave[j][i].particle.Mass_P[0][2]);  //Pry_M
            //(40-43)// Pry_V
            fprintf(Average_Particle,"%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].particle.Mass_P[1][Par_SN-1],cell_ave[j][i].particle.Mass_P[1][0],cell_ave[j][i].particle.Mass_P[1][1],cell_ave[j][i].particle.Mass_P[1][2]);  
            // Pry_C(44-47)
            fprintf(Average_Particle,"%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].particle.Mass_P[2][Par_SN-1],cell_ave[j][i].particle.Mass_P[2][0],cell_ave[j][i].particle.Mass_P[2][1],cell_ave[j][i].particle.Mass_P[2][2]); 
            // Pry_A(48-51)
            fprintf(Average_Particle,"%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].particle.Mass_P[3][Par_SN-1],cell_ave[j][i].particle.Mass_P[3][0],cell_ave[j][i].particle.Mass_P[3][1],cell_ave[j][i].particle.Mass_P[3][2]); 
            // Pry_all(52-55)
            fprintf(Average_Particle,"%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].particle.Mass_P[4][Par_SN-1],cell_ave[j][i].particle.Mass_P[4][0],cell_ave[j][i].particle.Mass_P[4][1],cell_ave[j][i].particle.Mass_P[4][2]);  
            // particle density(56-59)
            fprintf(Average_Particle,"%8.5f\t%8.5f\t%8.5f\t%8.5f\t", cell_ave[j][i].particle.density[Par_SN-1],cell_ave[j][i].particle.density[0],cell_ave[j][i].particle.density[1],cell_ave[j][i].particle.density[2]);
            // particle moment diffusion coefficent(60-63)
            fprintf(Average_Particle,"%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].particle.par_0thdiffcoe[Par_SN-1],cell_ave[j][i].particle.par_0thdiffcoe[0],cell_ave[j][i].particle.par_0thdiffcoe[1],cell_ave[j][i].particle.par_0thdiffcoe[2]);
            //(64-67) 1stdiffcoe, 2nddiffcoe and 3rddiffcoe
            fprintf(Average_Particle,"%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].particle.par_1stdiffcoe,cell_ave[j][i].particle.par_2nddiffcoe,cell_ave[j][i].particle.par_3rddiffcoe);
            //(68-71) 
            fprintf(Average_Particle,"%8.5e\t%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].par_0thdiffcoe[Par_SN-1],cell_ave[j][i].par_0thdiffcoe[0],cell_ave[j][i].par_0thdiffcoe[1],cell_ave[j][i].par_0thdiffcoe[2]);
            //(72-74)
            fprintf(Average_Particle,"%8.5e\t%8.5e\t%8.5e\t", cell_ave[j][i].par_1stdiffcoe,cell_ave[j][i].par_2nddiffcoe,cell_ave[j][i].par_3rddiffcoe);

            fprintf(Average_Particle, "\n");
        }

        if(j%2 == 0)
        {
            // fprintf(Average_Nondimension, "nondimen_x\tnondimen_y\tnondimen_u\tnondimen_v\nondi_vave\tnond_Reuu\tnond_Reuv\tnond_Revv\tnond_Reww\tMix_Fraction\n");
            for(i=0; i<ysample_number; i++)
            {
                fprintf(Average_Nondimension, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\n",\
                        cell_ave[j][i].x/jet_width_OP,2*cell_ave[j][i].y/(axis_ave[j].half_width_p-axis_ave[j].half_width_n),(cell_ave[j][i].u-covelocity)/(axis_ave[j].u-covelocity),\
                        cell_ave[j][i].v_lateral/(axis_ave[j].u-covelocity), cell_ave[j][i].v_ave/(axis_ave[j].u-covelocity),cell_ave[j][i].mixture.Density/axis_ave[j].mixture.Density,cell_ave[j][i].uu/center_uu,cell_ave[j][i].uv/center_uu,cell_ave[j][i].vv/center_uu,cell_ave[j][i].ww/center_uu,(cell_ave[j][i].mixture.Mixture_Fraction[4])/(axis_ave[j].mixture.Mixture_Fraction[4]),(cell_ave[j][i].mixture.Mixture_Fraction_Var[4]/(axis_ave[j].mixture.Mixture_Fraction[4]*axis_ave[j].mixture.Mixture_Fraction[4])));
            }
        }

/*         fprintf(Ave_Axis, "the average scalar on the axis is as follows:\n\n"); */
/*         fprintf(Ave_Axis, "1.num\t2.x_locat\t3.Uaxis_velo\t4.Vtr_axis\t5.vlate_axis\t6.vtotal_axis\t7.axis_density\t\ */
/* 8. Re_uu    9 Re_vv  10. Re_ww,   11 Re_uv
/* 12.eddyden_ax\t13.par_nd10axis\t14.par_nd70axis\t15.par_nd130axis\t\ */
/* 16.eddy_denmax\t17.eddy_max_y\t18.par_nd10max\t19.parnd10ma_y\t\ */
/* 20.par_nd70max\t21.parnd70ma_y\t22.par_130max\t23.par_130ma_y\t\ */
/* 24.halfwidt_yp\t25.halfwidt_yn\t26.pn10_ha_yp\t27.pn10_ha_yn\t\ */
/* 28.pn70_haf_yp\t29.pnd70_ha_yn\t30.pn130_ha_yp\t31.pn130_ha_yn
32.Mixt_Frac\t33.Mixt_Fr_Var\t34.Molecular_Weight\n"); */


        fprintf(Ave_Axis,"%d\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t",avenumber[j],axis_ave[j].x,axis_ave[j].u,axis_ave[j].v_trip,axis_ave[j].v_lateral,axis_ave[j].v_lateral*v_latcoe+axis_ave[j].v_trip,axis_ave[j].mixture.Density,axis_ave[j].mixture.Tem);
        fprintf(Ave_Axis,"%8.5f\t%8.5f\t%8.5f\t%8.5f\t", axis_ave[j].Restress[0], axis_ave[j].Restress[1],axis_ave[j].Restress[2],axis_ave[j].Restress[3]);
        fprintf(Ave_Axis,"%8.5f\t%8.5e\t%8.5e\t%8.5e\t", axis_ave[j].eddy_den_axis,axis_ave[j].par_ndaxis[0],axis_ave[j].par_ndaxis[1],axis_ave[j].par_ndaxis[2]);
        fprintf(Ave_Axis,"%8.5e\t%8.5f\t%8.5e\t%8.5f\t%8.5e\t%8.5f\t", axis_ave[j].eddy_den_max,axis_ave[j].eddy_den_max_y,axis_ave[j].eddy_instden_max,axis_ave[j].eddy_instden_max_y,axis_ave[j].par_ndmax[0],axis_ave[j].par_ndmax_y[0]);
        fprintf(Ave_Axis, "%8.5e\t%8.5f\t%8.5e\t%8.5f\t", axis_ave[j].par_ndmax[1],axis_ave[j].par_ndmax_y[1],axis_ave[j].par_ndmax[2],axis_ave[j].par_ndmax_y[2]);
        fprintf(Ave_Axis, "%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t%8.5f\t", axis_ave[j].half_width_p,axis_ave[j].half_width_n,axis_ave[j].half_width_fp[4],axis_ave[j].half_width_fn[4],axis_ave[j].par_ndhalfmax_yp[0],axis_ave[j].par_ndhalfmax_yn[0]);
        for(i_mfr=0; i_mfr<5; i_mfr++)
        {
            fprintf(Ave_Axis, "%8.5f\t%8.5f\t", axis_ave[j].half_width_fmrp[i_mfr], axis_ave[j].half_width_fmrn[i_mfr]);
        }
        fprintf(Ave_Axis,"%8.5f\t%8.5f\t%8.5f\t%8.5f\t", axis_ave[j].par_ndhalfmax_yp[1],axis_ave[j].par_ndhalfmax_yn[1],axis_ave[j].par_ndhalfmax_yp[2],axis_ave[j].par_ndhalfmax_yn[2]);
        fprintf(Ave_Axis,"%8.5f\t%8.5f\t%8.5f\n", axis_ave[j].mixture.Mixture_Fraction[4],axis_ave[j].mixture.Mixture_Fraction_Var[4],axis_ave[j].mixture.Molecular_Weight);
    }

    fclose(Average_Gas);
    fclose(Average_Particle);
    fclose(Average_Nondimension);
    fclose(Ave_Axis);
    fclose(INDEPENDENT);
    fclose(DEPENDENT);
}
